#!/usr/local/bin/perl 
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools";
#-------------------------------------------------------------------------
#    Name:  dbamon_patches.pl
#
# Version:  @(#)$Revision$
#
# Purpose:  
#
#   Specs: 
#
#  Author:  Bill Border
#-------------------------------------------------------------------------
$| = 1;
$P = "dbamon_patches.pl";
require "cgi_handlers.pl";

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

$fs = "<font face='$font' size=2>";
$fs1 = "<font face='$font' size=1>";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

# Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

chop($date     = `date`);
chop($host     = `hostname`);

$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
}

#------------------------------------------------------------------------------
#
# Subroutines
#
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub html_hdr_patch 
#------------------------------------------------------------------------------
{
  my $z = "
    <tr bgcolor=lightblue>
      <th colspan=6 bgcolor=wheat>$fs &lt;--- From \$ORACLE_HOME/patch/applied.txt ---&gt;
      <th colspan=1 bgcolor=skyblue nowrap>$fs &lt;--- From <a href='/cgi-bin/dbamon_patches.pl?,,,LD_UPDATE'>Locally Defined Patch Descriptions</a> ---&gt;
      <th colspan=6 bgcolor=pink> $fs &lt;--- From Oracle Metalink ---&gt;
    <tr bgcolor=slate>
      <th>$fs Patch Number
      <th>$fs Instance
      <th>$fs Version At<br> The Time of<br> Patch
      <th>$fs Date Applied
      <th>$fs Person Who<br> Applied Patch
      <th>$fs Comments
      <th>$fs Patch Description
      <th>$fs Patch<br> Desc.
      <th>$fs Product<br> Patched
      <th>$fs Product<br> Release
      <th>$fs Patch<br> Creation<br> Date
      <th>$fs Patch<br> Size
  ";
  return $z;
}

#------------------------------------------------------------------------------
sub html_hdr_version 
#------------------------------------------------------------------------------
{
  my $z = "
    <tr bgcolor=lightblue>
      <th colspan=6 bgcolor=wheat>$fs &lt;--- From \$ORACLE_HOME/patch/applied.txt ---&gt;
      <th colspan=1 bgcolor=skyblue nowrap>$fs &lt;--- From <a href='/cgi-bin/dbamon_patches.pl?,,,LD_UPDATE'>Locally Defined Patch Descriptions</a> ---&gt;
      <th colspan=6 bgcolor=pink> $fs &lt;--- From Oracle Metalink ---&gt;
    <tr bgcolor=slate>
      <th>$fs Version At<br> The Time of<br> Patch
      <th>$fs Patch Number
      <th>$fs Instance
      <th>$fs Date Applied
      <th>$fs Person Who<br> Applied Patch
      <th>$fs Comments
      <th>$fs Patch Description
      <th>$fs Patch<br> Desc.
      <th>$fs Product<br> Patched
      <th>$fs Product<br> Release
      <th>$fs Patch<br> Creation<br> Date
      <th>$fs Patch<br> Size
  ";
  return $z;
}

#------------------------------------------------------------------------------
sub html_hdr_instance 
#------------------------------------------------------------------------------
{
  my $z = "
    <tr bgcolor=lightblue>
      <th colspan=6 bgcolor=wheat>$fs &lt;--- From \$ORACLE_HOME/patch/applied.txt ---&gt;
      <th colspan=1 bgcolor=skyblue nowrap>$fs &lt;--- From <a href='/cgi-bin/dbamon_patches.pl?,,,LD_UPDATE'>Locally Defined Patch Descriptions</a> ---&gt;
      <th colspan=6 bgcolor=pink> $fs &lt;--- From Oracle Metalink ---&gt;
    <tr bgcolor=slate>
      <th>$fs Instance
      <th>$fs Patch Number
      <th>$fs Version At<br> The Time of<br> Patch
      <th>$fs Date Applied
      <th>$fs Person Who<br> Applied Patch
      <th>$fs Comments
      <th>$fs Patch Description
      <th>$fs Patch<br> Desc.
      <th>$fs Product<br> Patched
      <th>$fs Product<br> Release
      <th>$fs Patch<br> Creation<br> Date
      <th>$fs Patch<br> Size
  ";
  return $z;
}

#------------------------------------------------------------------------------
sub html_hdr_1 
#------------------------------------------------------------------------------
{
  my $z = "
    <tr bgcolor=lightblue>
      <th colspan=5 bgcolor=wheat>$fs &lt;--- From \$ORACLE_HOME/patch/applied.txt ---&gt;
      <th colspan=1 bgcolor=skyblue nowrap>$fs &lt;--- From <a href='/cgi-bin/dbamon_patches.pl?,,,LD_UPDATE'>Locally Defined Patch Descriptions</a> ---&gt;
      <th colspan=6 bgcolor=pink> $fs &lt;--- From Oracle Metalink ---&gt;
    <tr bgcolor=slate>
      <th>$fs Patch Number
      <th>$fs Version At<br> The Time of<br> Patch
      <th>$fs Date Applied
      <th>$fs Person Who<br> Applied Patch
      <th>$fs Comments
      <th>$fs Patch Description
      <th>$fs Patch<br> Desc.
      <th>$fs Product<br> Patched
      <th>$fs Product<br> Release
      <th>$fs Patch<br> Creation<br> Date
      <th>$fs Patch<br> Size
  ";
  return $z;
}

#------------------------------------------------------------------------------
sub html_body_instance 
#------------------------------------------------------------------------------
{
  my $z = "
    <tr bgcolor=wheat>
      <td nowrap>$fs <b>$dp_instance 
      <td nowrap>$fs <b>$dp_patchnum 
      <td nowrap>$fs $dp_dbmsver 
      <td nowrap>$fs $dp_dateapplied
      <td nowrap>$fs $dp_whoapplied 
      <td nowrap>$fs $dp_comment 
      <td bgcolor=skyblue nowrap>$fs <b>$dl_desc 
      <td bgcolor=pink nowrap>$fs <b>$dd_desc 
      <td bgcolor=pink nowrap>$fs $dd_product 
      <td bgcolor=pink nowrap>$fs $dd_release 
      <td bgcolor=pink nowrap>$fs $dd_date 
      <td bgcolor=pink nowrap>$fs $dd_size 
  ";
  return $z;
}

#------------------------------------------------------------------------------
sub html_body_1 
#------------------------------------------------------------------------------
{
  my $z = "
    <tr bgcolor=wheat>
      <td nowrap>$fs <b>$dp_patchnum 
      <td nowrap>$fs $dp_dbmsver 
      <td nowrap>$fs $dp_dateapplied
      <td nowrap>$fs $dp_whoapplied 
      <td nowrap>$fs $dp_comment 
      <td bgcolor=skyblue nowrap>$fs <b>$dl_desc 
      <td bgcolor=pink nowrap>$fs <b>$dd_desc 
      <td bgcolor=pink nowrap>$fs $dd_product 
      <td bgcolor=pink nowrap>$fs $dd_release 
      <td bgcolor=pink nowrap>$fs $dd_date 
      <td bgcolor=pink nowrap>$fs $dd_size 
  ";
  return $z;
}

#------------------------------------------------------------------------------
sub html_body_version 
#------------------------------------------------------------------------------
{
  my $z = "
    <tr bgcolor=wheat>
      <td nowrap>$fs <b>$dp_dbmsver 
      <td nowrap>$fs <b>$dp_patchnum 
      <td nowrap>$fs <b>$dp_instance 
      <td nowrap>$fs $dp_dateapplied
      <td nowrap>$fs $dp_whoapplied 
      <td nowrap>$fs $dp_comment 
      <td bgcolor=skyblue nowrap>$fs <b>$dl_desc 
      <td bgcolor=pink nowrap>$fs <b>$dd_desc 
      <td bgcolor=pink nowrap>$fs $dd_product 
      <td bgcolor=pink nowrap>$fs $dd_release 
      <td bgcolor=pink nowrap>$fs $dd_date 
      <td bgcolor=pink nowrap>$fs $dd_size 
  ";
  return $z;
}

#------------------------------------------------------------------------------
sub html_body_patch 
#------------------------------------------------------------------------------
{
  my $z = "
    <tr bgcolor=wheat>
      <td nowrap>$fs <b>$dp_patchnum 
      <td nowrap>$fs <b>$dp_instance 
      <td nowrap>$fs $dp_dbmsver 
      <td nowrap>$fs $dp_dateapplied
      <td nowrap>$fs $dp_whoapplied 
      <td nowrap>$fs $dp_comment 
      <td bgcolor=skyblue nowrap>$fs <b>$dl_desc 
      <td bgcolor=pink nowrap>$fs <b>$dd_desc 
      <td bgcolor=pink nowrap>$fs $dd_product 
      <td bgcolor=pink nowrap>$fs $dd_release 
      <td bgcolor=pink nowrap>$fs $dd_date 
      <td bgcolor=pink nowrap>$fs $dd_size 
  ";
  return $z;
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  my $msg     = $_[0];
  my $msgflag = $_[1];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  my $br = "<br>" if ! $msgflag;
  print "$br <font size=2>$date ${P} | <b>$msg</b></font>\n";
}

#-----------------------------------------------------------------------------
sub displayError
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;


   print "</table><hr> <h3> The following database error occured - $date</h3>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: <pre>$sql</pre>";
   print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDB 
#-----------------------------------------------------------------------------
{
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub reportCompliance1
#-----------------------------------------------------------------------------
{
  print "<pre>\n";
  system("remsh $host -l dbamon '/opt/dbamon/bin/dbamon_patch_reports WWW' 2>&1");
  print "</pre>\n";
  print "
  <iframe
    src='http://dba.thecompany.com/dba/data/dbamon_patch_reports/report.html'
    width=95%
    height=95%
    frameborder=1
    >
  ";
  system("cat /opt/web/dba/data/dbamon_patch_reports/report.html");
  exit;
}

#-----------------------------------------------------------------------------
sub reportMenu
#-----------------------------------------------------------------------------
{
  print "<hr>
    <p>
    <table bgcolor=lightblue>
    <tr><th bgcolor=wheat>$fs <b>Patch Reports:</b>
    <tr><td>$fs 1. <a href='/cgi-bin/$P?,,,reportByPatch'    ><b>All Applied Patches - By Patch Number</b></a>
    <tr><td>$fs 2. <a href='/cgi-bin/$P?,,,reportByInstance' ><b>All Applied Patches - By Instance</b></a>
    <tr><td>$fs 3. <a href='/cgi-bin/$P?,,,reportByVersion'  ><b>All Applied Patches - By DBMS Version</b></a>
    <tr><td>$fs 4. <a href='/cgi-bin/$P?,,,reportCompliance1'><b>Patch Application Compliance</b></a>
    </table>
    <p>
  ";
}

#-----------------------------------------------------------------------------
sub LDUBuildForm 
#-----------------------------------------------------------------------------
{
  print "
    <FORM method='POST' action='/cgi-bin/dbamon_patches.pl?,,,LD_UPDATE,PROCESS'>
    <hr>Modify fields and click 
    <b><INPUT type=submit value=' Save Changes '></b>
    here or at the bottom of this form. 
    <p>
    To Delete an entry, blank out the <b>Patch Number</b> field.
    <br>To Cancel, click <b>BACK</b>.
    <HR>\n";

  print "
    <table border=1 bgcolor=lightblue>
    <tr bgcolor=slate>
	<th>$fs Patch Number
	<th>$fs Patch Description
	<th>$fs Entry Last Updated
    </tr>";

  for ($i = 0; $i <= ($selectcount + 20); $i++)
  {
    print "
     <tr>
      <td><b>$fs <INPUT type=text size=16 maxlength=16 name=i_patchnum_$i value='$dl_patchnum[$i]'></b>
      <td><b>$fs <INPUT type=text size=140 maxlength=140 name=i_desc_$i     value='$dl_desc[$i]'></b>
      <td>   $fs <font size=2>$dl_ts[$i] </font> \n";
  }

  print " </table><hr><p><center><input type=submit value=' Save Changes '></center></form>";
}

#-----------------------------------------------------------------------------
sub LDUSelect
#-----------------------------------------------------------------------------
{
  $sql  = "select
    dl_patchnum,
    dl_desc,
    to_char(dl_ts,\'YYYY/MM/DD-HH24:MI:SS\')
  from 
    dbamon.dbmspatches_desc_local
  order by 
    1";

  ##print "<pre>sql=$sql</pre>\n";

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    #
    # Assign var names
    #
    (
      $dl_patchnum[$selectcount],
      $dl_desc[$selectcount],
      $dl_ts[$selectcount]
    ) = @Data;
    
    ##print "Data1=$Data[1]\n";
    ##print "dl_desc=$dl_desc[$selectcount]\n";
  }
  ##print "</pre>\n";
  return $selectcount + 1;
}

#-----------------------------------------------------------------------------
sub LDUErrorCheck
#-----------------------------------------------------------------------------
{
  ## foreach $item (sort keys %rqpairs)
  ## {
  ##   #
  ##   # Any variable name that ends with _ must be in the range of 1-5
  ##   #
  ##   $len     = length($item);
  ##   $datalen = length($rqpairs{$item});
  ##   $data    = $rqpairs{$item};
  ##   print "item=$item data=$data\n";
  ## }

  for ($i=0; $i<=500; $i++)
  {
    $i_row = $i + 1;
    if ($rqpairs{"i_patchnum_$i"} ne "") 
    {
      $found = 1;

      if ($rqpairs{"i_desc_$i"} eq "") 
      {
	push (@error_list, "(Row $i_row) Description Cannot Be Blank If Patch Number Is Specified\n");
      }

      $patchnum = $rqpairs{"i_patchnum_$i"};
      $desc     = $rqpairs{"i_desc_$i"};
  
      $patchnum =~ s/\'//g;
      $desc     =~ s/\'//g;

      $sql = "insert into dbamon.dbmspatches_desc_local (dl_patchnum, dl_desc) values ('$patchnum', '$desc')";
      print "sql=$sql\n";
      push(@insert_array, $sql);
    }
  }

  if (!$found) 
  {
    push (@error_list, "In order to save anything, you must specify at least 1 DBMS \n");
  }
}

#-----------------------------------------------------------------------------
sub LDUErrorExit
#-----------------------------------------------------------------------------
{
  print "<hr><h4>Data Entry Error(s) Encountered</h4>";
  print "$fs <b>Please correct the following data input errors:</b><p><ul>";

  foreach( @error_list)
  {
     print "<li> $_\n<br>";
  }
  print "</ul>\n";
  print "<br><img src='/dba/images/stooges2.gif'><p><hr>\n";

  &msg("Click <b>BACK</b>, fix the input errors and click <b>Save</b> again");
  exit 1;
}

#-----------------------------------------------------------------------------
sub LDUDelete
#-----------------------------------------------------------------------------
{
  &msg("Deleting all rows from DBAMON.DBMSPATCHES_DESC_LOCAL");

  $sql  = "delete from dbamon.dbmspatches_desc_local";

  ##print "sql=$sql\n";
  ##system("id");

  $rc = $dbh->do($sql) || &displayError('Failed_on_DB_do_delete');
}

#-----------------------------------------------------------------------------
sub LDUInsert
#-----------------------------------------------------------------------------
{
  &msg("Inserting rows into DBAMON.DBMSPATCHES_DESC_LOCAL");

  $insertcnt = 0;

  foreach (@insert_array)
  {
    $sql = $_;
    ##print "sql=$sql \n";
    $rc = $dbh->do($sql) || &displayError('Failed_on_DB_do_insert');
    $insertcnt++;
  }

  &msg("Inserted $insertcnt Updated Rows");
}

#-----------------------------------------------------------------------------
sub localDescUpdate
#-----------------------------------------------------------------------------
{
  &msg("localDescUpdate() - Update DBAMON.DBMSPATCHES_DESC_LOCAL table");

  if ($in_verb2 eq "PROCESS")
  {
    #---- Read previous data
    print "<pre>\n";
    $zrc = &LDUErrorCheck;
    print "</pre>\n";

    &LDUErrorExit if @error_list != 0;

    #---- Delete all old rows
    &LDUDelete;

    #---- Insert new rows
    &LDUInsert;
  }
  else
  {
    #---- Read previous data
    $zrc = &LDUSelect;
    &msg("localDescUpdate() - Selected $zrc previous row(s)");

    #---- Build form 
    $zrc = &LDUBuildForm;
  }
}

#-----------------------------------------------------------------------------
sub reportOneDB
#-----------------------------------------------------------------------------
{
  &msg("reportOneDB() - Retrieving patch data for in_instance=$in_instance");
  &msg("This may take a few minutes if patch information has to be retrieved from MetaLink");

  # Create the SQL SELECT statement
  $sql  = "
    select 
      dp_patchnum, 
      dp_dbmsver, 
      to_char(dp_dateapplied,'YYYY/MM/DD') dp_dateapplied,
      dp_whoapplied, 
      dp_comment
    from 
      dbmspatches 
    where 
      dp_dbamonmode = '$in_mode'
      and dp_system   = '$in_system'
      and dp_instance = '$in_instance'
    order by
      1, 2
  ";
  ##print "$sql\n";

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $rowcount = 0;

  $z1 = &html_hdr_1;
  print "<hr><p><table bgcolor=lightblue>
    $z1
  ";

  while ($rowhash = $sth->fetchrow_hashref('NAME_lc'))
  {
    $rowcount++;

    $dp_dbmsver     = $rowhash->{dp_dbmsver};
    $dp_patchnum    = $rowhash->{dp_patchnum};
    $dp_dateapplied = $rowhash->{dp_dateapplied};
    $dp_whoapplied  = $rowhash->{dp_whoapplied};
    $dp_comment     = $rowhash->{dp_comment};

    $dl_desc = " ";

    $dd_desc = "";
    $dd_product = "";
    $dd_release = "";
    $dd_date = "";
    $dd_size = "";

    $this_patch = $dp_patchnum; &getPatchDesc;

    $z1 = &html_body_1;
    print "
      $z1
    \n";
  }

  print "</table><p>\n";
  
  if ($rowcount == 0)
  {
    &msg("ERROR: No rows found - sql=<pre>$sql</pre>");
  }
}

#-----------------------------------------------------------------------------
sub getPatchDescMetalink
#-----------------------------------------------------------------------------
{
  open (CMD, "/usr/local/dba/tools/ora_patch_info $this_patch |") || &error("Cannot run ora_patch_check -  $!");

  $dd_desc     = "?";
  $dd_product  = "?";
  $dd_release  = "?";
  $dd_date     = "?";
  $dd_size     = "?";

  while(<CMD>)
  {
    if (/^DESCRIPTION:/)  { chomp($dd_desc = substr($_,25)); }
    if (/^PRODUCT:/)      { chomp($dd_product = substr($_,25)); }
    if (/^RELEASE:/)      { chomp($dd_release = substr($_,25)); }
    if (/^LAST_UPDATED:/) { chomp($dd_date = substr($_,25)); }
    if (/^SIZE:/)         { chomp($dd_size = substr($_,25)); }

  }

  $dd_desc     =~ s/\s+$//;
  $dd_product  =~ s/\s+$//;
  $dd_release  =~ s/\s+$//;
  $dd_date     =~ s/\s+$//;
  $dd_size     =~ s/\s+$//;

  #---- Insert row into dbmspatches_desc
  $sql  = "insert 
      into dbmspatches_desc 
        (dd_patchnum, dd_desc, dd_product, dd_release, dd_date, dd_size) 
      values 
        ( \'$this_patch\', \'$dd_desc\', \'$dd_product\', \'$dd_release\', \'$dd_date\', \'$dd_size\')";
  
  $sth3 = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth3->execute || &displayError('Failed_on_DB_execute_in_chgEnt');
}

#-----------------------------------------------------------------------------
sub getPatchDescLocal
#-----------------------------------------------------------------------------
{
  $sql  = "
    select 
      dl_desc
    from 
      dbmspatches_desc_local
    where 
      dl_patchnum = '$this_patch'
  ";
  ##print "$sql\n";

  $sth2 = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $dl_rowcount = 0;

  while ($rowhash = $sth2->fetchrow_hashref('NAME_lc'))
  {
    $dl_rowcount++;
    $dl_desc    = $rowhash->{dl_desc};
  }
}

#-----------------------------------------------------------------------------
sub getPatchDesc
#-----------------------------------------------------------------------------
{
  $sql  = "
    select 
      dd_desc, 
      dd_product, 
      dd_release, 
      dd_date,
      dd_size
    from 
      dbmspatches_desc
    where 
      dd_patchnum = '$this_patch'
    order by
      1, 2
  ";
  ##print "$sql\n";

  $sth2 = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $dd_rowcount = 0;

  while ($rowhash = $sth2->fetchrow_hashref('NAME_lc'))
  {
    $dd_rowcount++;
    $dd_desc    = $rowhash->{dd_desc};
    $dd_product = $rowhash->{dd_product};
    $dd_release = $rowhash->{dd_release};
    $dd_date    = $rowhash->{dd_date};
    $dd_size    = $rowhash->{dd_size};
  }

  if ($dd_rowcount == 0)
  {
    &getPatchDescMetalink;
  }

  #---- Get possible desc from dbmspatches_desc_local
  &getPatchDescLocal;
}

#-----------------------------------------------------------------------------
sub reportByVersion
#-----------------------------------------------------------------------------
{
  &msg("reportByVersion() - Retrieving patch data");

  # Create the SQL SELECT statement
  $sql  = "
    select 
      dp_dbmsver, 
      dp_patchnum, 
      dp_instance,
      to_char(dp_dateapplied,'YYYY/MM/DD') dp_dateapplied,
      dp_whoapplied, 
      dp_comment
    from 
      dbmspatches 
    where 
      dp_dbamonmode = '$in_mode'
    order by
      1, 2
  ";
  ##print "$sql\n";

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $rowcount = 0;

  $z1 = &html_hdr_version;
  print "<hr><p><table bgcolor=lightblue>
    $z1;
  ";

  while ($rowhash = $sth->fetchrow_hashref('NAME_lc'))
  {
    $rowcount++;

    $dp_instance    = $rowhash->{dp_instance};
    $dp_dbmsver     = $rowhash->{dp_dbmsver};
    $dp_patchnum    = $rowhash->{dp_patchnum};
    $dp_dateapplied = $rowhash->{dp_dateapplied};
    $dp_whoapplied  = $rowhash->{dp_whoapplied};
    $dp_comment     = $rowhash->{dp_comment};

    ($verandpatch = "$dp_dbmsver/$dp_patchnum") =~ s/ //g;

    if ($last_verandpatch && $verandpatch ne $last_verandpatch)
    {
      print "<tr><td colspan=99><center>$fs1($last_verandpatch has been applied to $patchcnt instances)</center>\n";
      print "<tr><td colspan=99><hr>\n";
      $patchcnt = 0;
    }

    $dl_desc = "";
    $dd_desc = "";
    $dd_product = "";
    $dd_release = "";
    $dd_date = "";
    $dd_size = "";

    $this_patch = $dp_patchnum; &getPatchDesc;

    $z1 = &html_body_version;
    print "
      $z1
    \n";

    $last_verandpatch = $verandpatch;
    $patchcnt++;
  }

  print "<tr><td colspan=99><center>$fs1(Instance $last_instance has $patchcnt patches)</center>\n";
  print "<tr><td colspan=99><hr>\n";

  print "</table><p>\n";
  
  if ($rowcount == 0)
  {
    &msg("ERROR: No rows found - sql=<pre>$sql</pre>");
  }
}

#-----------------------------------------------------------------------------
sub reportByInstance
#-----------------------------------------------------------------------------
{
  &msg("reportByInstance() - Retrieving patch data");

  # Create the SQL SELECT statement
  $sql  = "
    select 
      dp_instance,
      dp_patchnum, 
      dp_dbmsver, 
      to_char(dp_dateapplied,'YYYY/MM/DD') dp_dateapplied,
      dp_whoapplied, 
      dp_comment
    from 
      dbmspatches 
    where 
      dp_dbamonmode = '$in_mode'
    order by
      1, 2
  ";
  ##print "$sql\n";

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $rowcount = 0;

  $z1 = &html_hdr_instance;
  print "<hr><p><table bgcolor=lightblue>
    $z1;
  ";

  while ($rowhash = $sth->fetchrow_hashref('NAME_lc'))
  {
    $rowcount++;

    $dp_instance    = $rowhash->{dp_instance};
    $dp_dbmsver     = $rowhash->{dp_dbmsver};
    $dp_patchnum    = $rowhash->{dp_patchnum};
    $dp_dateapplied = $rowhash->{dp_dateapplied};
    $dp_whoapplied  = $rowhash->{dp_whoapplied};
    $dp_comment     = $rowhash->{dp_comment};

    if ($last_instance && $dp_instance ne $last_instance)
    {
      print "<tr><td colspan=99>$fs1 (Instance $last_instance has $patchcnt patches)\n";
      print "<tr><td colspan=99><hr>\n";
      $patchcnt = 0;
    }

    $dl_desc = "";
    $dd_desc = "";
    $dd_product = "";
    $dd_release = "";
    $dd_date = "";
    $dd_size = "";

    $this_patch = $dp_patchnum; &getPatchDesc;

    $z1 = &html_body_instance;
    print "
      $z1
    \n";

    $last_instance = $dp_instance;
    $patchcnt++;
  }

  print "<tr><td colspan=99>$fs1 (Instance $last_instance has $patchcnt patches)\n";
  print "<tr><td colspan=99><hr>\n";

  print "</table><p>\n";
  
  if ($rowcount == 0)
  {
    &msg("ERROR: No rows found - sql=<pre>$sql</pre>");
  }
}

#-----------------------------------------------------------------------------
sub reportByPatch
#-----------------------------------------------------------------------------
{
  &msg("reportByPatch() - Retrieving patch data");

  # Create the SQL SELECT statement
  $sql  = "
    select 
      dp_patchnum, 
      dp_instance,
      dp_dbmsver, 
      to_char(dp_dateapplied,'YYYY/MM/DD') dp_dateapplied,
      dp_whoapplied, 
      dp_comment
    from 
      dbmspatches 
    where 
      dp_dbamonmode = '$in_mode'
    order by
      1, 2
  ";
  ##print "$sql\n";

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $rowcount = 0;

  $z1 = &html_hdr_patch;
  print "<hr><p><table bgcolor=lightblue>
    $z1;
  ";

  while ($rowhash = $sth->fetchrow_hashref('NAME_lc'))
  {
    $rowcount++;

    $dp_instance    = $rowhash->{dp_instance};
    $dp_dbmsver     = $rowhash->{dp_dbmsver};
    $dp_patchnum    = $rowhash->{dp_patchnum};
    $dp_dateapplied = $rowhash->{dp_dateapplied};
    $dp_whoapplied  = $rowhash->{dp_whoapplied};
    $dp_comment     = $rowhash->{dp_comment};


    if ($last_patchnum && $dp_patchnum ne $last_patchnum)
    {
      print "<tr><td colspan=99><center>$fs1(Patch $last_patchnum has been applied to $patchcnt instances)</center>\n";
      print "<tr><td colspan=99><hr>\n";
      $patchcnt = 0;
    }

    $dl_desc = " ";
    $dd_desc = "";
    $dd_product = "";
    $dd_release = "";
    $dd_date = "";
    $dd_size = "";

    $this_patch = $dp_patchnum; &getPatchDesc;

    $z1 = &html_body_patch;
    print "
      $z1
    \n";

    $last_patchnum = $dp_patchnum;
    $patchcnt++;
  }

  print "<tr><td colspan=99><center>$fs1(Patch $last_patchnum has been applied to $patchcnt instances)</center>\n";
  print "<tr><td colspan=99><hr>\n";

  print "</table><p>\n";
  
  if ($rowcount == 0)
  {
    &msg("ERROR: No rows found - sql=<pre>$sql</pre>");
  }
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#-------------------------------------------------------------------------
#
# Main
#
#-------------------------------------------------------------------------

&get_request;

@words = split(/,/,$ARGV[0]);
$in_system   = $words[0];
$in_instance = $words[1];
$in_mode     = $words[2];
$in_verb     = $words[3];
$in_verb2    = $words[4];

#---- Data repair
$in_mode = "prod" if ! $in_mode;

#---- Determine mode of this invocation
if ($in_system && ! $in_verb)
{
  $mode = "DBClick";
  $zmsg = "DBMS Patch Report For $in_instance";
}
elsif ($in_verb eq "LD_UPDATE")
{
  $mode = $in_verb;
  $zmsg = "DBMS Local Patch Description Update";
}
elsif ($in_verb =~ /^report/)
{
  $mode = $in_verb;
  $zmsg = "DBMS Patch Report: $mode";
}
else
{
  $mode = "ReportMenu";
  $zmsg = "DBMS Patch Report Menu";
}

##system("echo '' | mailx -s 'monitor--$P mode=$mode ($ENV{'REMOTE_HOST'}) [AUTO]' border\@dba.it.thecompany.com");

print "Content-type: text/html\n\n
  <title>DBAmon $zmsg</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=4>
      <center>$zmsg</center>
  </table>";

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "
</table>
<table width=750>

 $links_include

</table>
<hr>
";

print "
  $fs
  (in_system=$in_system,in_instance=$in_instance,in_mode=$in_mode,in_verb=$in_verb mode=$mode)<br>
  This transaction displays which DBMS patches have been applied to this instance. Note that this data IS NOT
<br>automatically derived from the DBMS installation, it is entered by YOU on this instance when you apply a patch.
<br>It is only as accurate as your data entry.<p> Related links:
<ul>
  <li> <a href='/cgi-bin/dbamon_patches.pl'><b>DBAmon Patch Report Menu</b></a>
  <li> <a href='http://dbamon.com/config/dbmspatches.shtml'><b>DBAmon Patch Tracking Help (dbamon.com)</b></a>
  <li> <a href='http://updates.oracle.com/ARULink/SimpleSearch/get_form'><b>Oracle&reg; MetaLink&reg; Patch Lookup</b></a>
  <li> <a href='/cgi-bin/dbamon_patches.pl?,,,LD_UPDATE'><b>Update Locally Defined Patch Descriptions</b></a>
</ul>
";

#---- Connect to DB
&connectDB;

#---- Invoke the right report 
if ($mode eq "DBClick")
{
  &reportOneDB;
}
if ($mode eq "LD_UPDATE")
{
  &localDescUpdate;
}
elsif ($mode =~ /^report/)
{
  $dyncmd = "&$mode";
  print "<hr>\n";
  &msg("Invoking report: $dyncmd");
  eval($dyncmd);
}
elsif ($mode eq "ReportMenu")
{
  &reportMenu;
}

#---- Go away
print "<hr>";
&msg("Done",1);
exit 0;
