#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
# dbamon_text_search.pl
# !*-------------------------------------------------------------------------
$P = "dbamon_text_search.pl";
$| = 1;

use DBI;
require "cgi_handlers.pl";

$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  #$dbms = "oracle";
}

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';
undef @error_fields;

#------------------------------------------------------------------------------
#
# Subroutines
#
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub msgOld
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#------------------------------------------------------------------------------
sub Include
#------------------------------------------------------------------------------
{
  $file = $_[0];
  open (FILE, "$file") || die ("Can't open input file $file");
  while ($line = <FILE>) 
  {
    print $line;
  }
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg,@error_fields) = @_;

   #print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body></table>";

   print "<p>";
   print "<h3> A Database Error Has Occured:</h3>";
 print "<h4>$errorMsg</h4>";
 print "SQL statement: <pre>$statement</pre>";
 print "Error: <pre>$DBI::errstr</pre>";

 &PrintLinks;

 print "</body>";
 print "</html>";

 exit(1);
}

#-----------------------------------------------------------------------------
sub errorCheck
{
  ##print "f-system=$f{'system'}\n";

  if ($rqpairs{'i_distlist'}    eq "") {push (@error_list, "Dist. List ID must not be blank\n");}
  if ($rqpairs{'i_distlist'} < 0 ||
      $rqpairs{'i_distlist'} > 999999) {push (@error_list, "Dist. List ID must be numeric, range 1-999999\n");}
  if ($rqpairs{'i_distlist'} == 0) {push (@error_list, "Dist. List ID must be numeric and non-zero\n");}

  if ($rqpairs{'i_recipient_1'} eq "") {push (@error_list, "Recipient #1 EMail Address  must not be blank\n");}
  ##print "1=$rqpairs{'i_recipient_1'}\n"; 
}

#-----------------------------------------------------------------------------
#sub IntHandler
#{
# local($Signal) = @_;
# close(you_fill_in_the_file_descriptor);
# unlink($you_fill_in_the_tmp_file_name);
# exit(0);
#}

#-----------------------------------------------------------------------------
sub error_html 
{
 $manyerrors = @error_list;
 $str= "" ;
 $str1="";
 $str4="<h3>Insufficient or missing information...</h3><hr>";
 $html_str=$str.$str1.$str1.$str4;
 print "$html_str\n";
 print "<h4>Please correct the following:</h4>";
 print "<p>\n";
 print "<ul>\n";
 foreach( @error_list) 
 {
    print "<li> $_\n<br>";
 }
 print "</ul>\n";
 if ($manyerrors > 3) {
    print "$manyerrors errors - Having a bad day, are we?<p>\n";
 }
 else {
    print "$manyerrors correction(s) to make.<p>\n";
 }
 print "<hr>Click <b>BACK</b> and try again.\n";
    
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
# Connect to the Mysql database
$dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
       &error('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub buildForm
#-----------------------------------------------------------------------------
{
  # Display form
  print "
  <P><FORM method='POST' action='/cgi-bin/${P}?Search'>
  <p>
  <font size=2><b>Notepad/KB Text Search String:</b>
  <INPUT type='text' size=40 name='searchstring'>
  <INPUT type=submit value='Search'></b>
  <br>
  <b> (Search Metalink Also? <input type=checkbox name=meta_search>) </b>
  <p>
  <HR>\n";
}

#-----------------------------------------------------------------------------
sub selectData
{
  $searchstring_upper = uc $searchstring;

  # Create the SQL SELECT statement
  if ($dbamon_repos eq "O")
  {
    $statement  = "select
      system,
      instance,
      text,
      to_char(ts,'YYYY/MM/DD-HH24:MI:SS'),
      seq
    from 
      dbamon.text
    where 
      upper(text) like \'%$searchstring_upper%\'
    order by 
      system, 
      instance, 
      seq";
  }
  else
  {
    $statement  = "select
      system,
      instance,
      text,
      --to_char(ts,'YYYY/MM/DD-HH24:MI:SS'),
      dbamon.dateconvert_19(ts),
      seq
    from 
      dbamon.text
    where 
      upper(text) like \'%$searchstring_upper%\'
    order by 
      system, 
      instance, 
      seq";
  }

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;

  print "<h5>DBAmon KB/Notepad Search Results For: $searchstring</h5>\n";
  print "<table border=0 bgcolor=wheat width=80%>\n";
  print "
  <tr bgcolor=slate> 
    <th $style_normal>System-Instance 
    <th $style_normal width=60%>Text
    <th $style_normal>Last Updated Timestamp
  ";

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $system   = $Data[0];
    $instance = $Data[1];
    $text     = $Data[2];
    $ts       = $Data[3];
    $seq      = $Data[4];

    $title = $system . "-" . $instance;
    $title =~ s/ //g;
    $system =~ s/ //g;

    ##print "system=$system instance=$instance text=$text ts=$ts\n";

    $bg = &bgRow;

    if ($system eq '-KB-')
    {
      print "
      <tr $bg >
	<td nowrap $style_normal><a href='/cgi-bin/dbamon_kb.pl?UpdateBuild/$instance'>KB Entry: $instance</a>
	<td $style_normal>[Line $seq] <b> $text </b>
	<td $style_normal nowrap>$ts";
    }
    else
    {
      print "
      <tr $bg  $style_normal>
	<td nowrap $style_normal><a href='/cgi-bin/dbamon_text.pl?$system?$instance'>Notepad: $title</a>
	<td $style_normal>[Line $seq] <b> $text </b>
	<td nowrap $style_normal>$ts";
    }

  }
  print" </table> \n";
  print "<p><font size=1>(Selected $selectcount Rows)</font><hr>";
}

#-----------------------------------------------------------------------------
sub custom_html 
{
   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#
# Attempt to make sure that no meta characters are entered in the form.
#
#-----------------------------------------------------------------------------
sub CheckForEvilness
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
# Main
#-----------------------------------------------------------------------------

chop($CurrentDate = `date`);

#
# Get form data
#
&get_request;

#---- Heading
&header("Notepad/KB Test Search"); 

 
print "
<font size=2>
This transaction will search the 'Notepad' text of all instances that DBAmon 
monitors for the search string that you specify here. 
<br>It will also automatically
search all DBAmon KB (Knowledge Base) entries.
It will also optionally search Oracle Metalink for the 
<br>same search string.
<font color=red><b>NOTE:</b> Only one search argument is processed. So enter <b>17059</b> , not <b>ORA-00600 [17059]</b>.</font>
<hr>
</font>
\n";

#
# Variables
#

$searchstring = $rqpairs{'searchstring'};
$meta_search  = $rqpairs{'meta_search'};

##system("echo '' | mailx -s 'monitor--$P $ARGV[0] $searchstring $meta_search ($ENV{'REMOTE_HOST'}) [AUTO]' bill.border\@thecompany.com");

$SaveFile = "/tmp/$P.log";
unlink($SaveFile);
open(LOG, ">>$SaveFile" );
print LOG "$P | $CurrentDate : \n";

##print "arg=$ARGV[0]\n";

if ($ARGV[0] eq "")
{
  &buildForm;
  exit;
}
if ($ARGV[0] eq "Search")
{
  &connectDB;
  &selectData;
}

# Optionally search metalink
if ($meta_search eq "on")
{
  $meta_url = "http://metalink.oracle.com/metalink/plsql/kno_main.preDoAdvancedQuery?p_showBack=TRUE&p_text=$searchstring&p_queryOption=and&p_product_id=-1&p_platform_id=-1&p_date=-1&p_knowledge=TRUE&p_forums=TRUE&p_numHits=100&p_listType=2&p_Sortby=103";
  print "<h5>Oracle Metalink Search Results For: $searchstring</h5>\n";
  print "\n<iframe src='$meta_url' width=98% height=800></iframe>\n";
  
}

print "<font size=2>Click <b>BACK</b> to perform another search</font>\n";

# Footer 
Include("/opt/dbamon/htm/inc/foot_small.html");

close(LOG);
exit 0;
