#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# --------------------------------------------------------------
# Changes:
#   05May05 BB - 2.00 - Added progdir logic 
#   05May05 BB - 2.01 - Fix to how sapstart process is checked 
# --------------------------------------------------------------
$version = "2.00"; 
$| = 1;

# --------------------------------------------------------------
# Variables
# --------------------------------------------------------------

use Time::Local;
use File::Basename;

##$debug = 1;

$P       = basename($0);
$progdir = dirname($0);
##$tmpdir= "$progdir";      #---- Old setting
$tmpdir  = "$progdir/tmp";  #---- FUTURE - after new dirs are implemented
system("mkdir  $tmpdir 2>&1") if ! -e $tmpdir;
chdir("$progdir") || print "chdir to $progdir failed\n";
chop($pwd = `pwd`);

#---- START Temporary code to cleanup the old software/tmp files
system("rm /tmp/dbamon_* 2>/dev/null");
#---- END   Temporary code to cleanup the old software/tmp files

chop($thisos = `uname`);
if    ($thisos eq "HP-UX") { $bdfcmd = "bdf";    }
elsif ($thisos eq "SunOS") { $bdfcmd = "df -k"; }
elsif ($thisos eq "Linux") { $bdfcmd = "df -k"; }
else                       { $bdfcmd = "df -k";    }
print "$P | Setting bdfcmd=$bdfcmd for OS=$thisos \n";

##$tmpfl = "$tmpdir/dbamon_sap_tmp.txt";
$sid  = $ARGV[0];
$verb = $ARGV[1];
$arg1 = $ARGV[2];
$arg2 = $ARGV[3];
$arg3 = $ARGV[4];
$arg4 = $ARGV[5];

chop($hostname = `hostname`);
chop($id = `whoami`);

$ENV{"SAPSYSTEMNAME"} = $sid;
$sidlc = lc $sid;
$ENV{'DIR_LIBRARY'} = "/usr/sap/$sid/SYS/exe/run";
$ENV{'PATH'} = $ENV{'PATH'} . ":/usr/sap/$sid/SYS/exe/run/";

# See if INFORMIX_FE_VERSION needs to be set
chop($fe_version = `grep -v '^#' .profile | grep INFORMIX_FE_VERSION | tail -1 | awk -F= '{ print \$2 }'`);
$ENV{'INFORMIX_FE_VERSION'} = $fe_version if $fe_version ne "";

&msg("Starting - version=$version id=$id sid=$sid verb=$verb arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4");
&msg("  progdir=$progdir tmpdir=$tmpdir pwd=$pwd"); 
&msg("  SAP Env:");
system("env | grep SAP");
print "Hostname: $hostname \n";

# --------------------------------------------------------------
# Subroutines
# --------------------------------------------------------------

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  my $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n";
}

sub error
{
  $msg = $_[0];
  print "===============================================================================\n";
  print "$P | Fatal ERROR: \n";
  print "$P | $msg \n";
  print "===============================================================================\n";
  &msg("END_OF_PROBE");
  exit 1;
}

# ----------------------------------------------------------------------
# Up
# ----------------------------------------------------------------------
sub up
{
  if (! -e "/usr/sap/$sid")
  {
    &error("SAP Instance: $sid Does Not Exist (/usr/sap/$sid Not Found)");
  }

  print "HOSTNAME:       $hostname\n";


  system("uname -a");
  system("model");
  system("echo 'MODE' `getconf SC_KERNEL_BITS 2>&1`");
  system("$progdir/dbamon_cpuinfo");

  # Measure how full SAPMNT FS is
  $bdfflag = "OK";
  chop($bdf = `$bdfcmd /usr/sap/$sid | tail -1`);
  $_ = $bdf;
  @words  = split;
  if ($#words == 5 && index($bdf,"%") > -1)
  {
    $bdfsize = int($words[1]/1000);
    $bdfused = int($words[2]/1000);
    $bdfaval = int($words[3]/1000);
    chop($bdfpct  = $words[4]);
    $bdfname = $words[5];
  }
  elsif ($#words == 4 && index($bdf,"%") > -1)
  {
    $bdfsize = int($words[0]/1000);
    $bdfused = int($words[1]/1000);
    $bdfaval = int($words[2]/1000);
    chop($bdfpct  = $words[3]);
    $bdfname = $words[4];
  }
  else
  {
    $bdfflag = "E";
  }
  $bdfflag = "E" if $bdfsize eq "";
  $bdfflag = "C" if $bdfpct >= 99;
  print "BDFUSRSAPDIR: $bdfsize $bdfused $bdfaval $bdfpct $bdfname $bdfflag \n";

  # Get SAP kernel ver
  chop($sapkern = `/usr/sap/$sid/SYS/exe/run/R3check -? | grep version | head -1 | awk '{ print \$7 }'`);

  chop($sapkernmode = `/sapmnt/$sid/exe/disp+work 2>/dev/null | grep 'compiled for' | awk '{ print \$3 }'`);
  if ($sapkernmode eq "")
  {
    $sapkernmode = "32";
  }
  $sapkern = "$sapkern($sapkernmode)";

  #$saprlse = `echo "select * from svers" | dbaccess $sapinst 2>/dev/null | tail -3 | head -1`;
  #chop $saprlse;

  print "SAPVERSION: $sapkern \n";
  print "SAPKERNMODE: $sapkernmode \n";

  print "$P | All SAP $sid processes \n";
  system("ps -ef | grep sap | grep $sid | grep -v grep");

  # Count processes
  &msg("Checking status of sapstart process");
  #---- Old 2.01
  #chop($numstart = `ps -ef | grep /usr/sap/$sid/SYS/exe/run | grep sapstart | grep -v grep | wc -l`);
  #---- New 2.01
  chop($numstart = `ps -ef | grep /usr/sap/$sid/ | grep sapstart | grep -v grep | wc -l`);
  &msg("sapstart IS Running") if $numstart >= 1;
  
  # Count dw
  chop($numdw = `ps -ef | grep dw.sap${sid}_ | grep -v grep | wc -l`);
  
  # Count ms
  chop($numms = `ps -ef | grep ms.sap${sid}_ | grep -v grep | wc -l`);
  
  # Count se
  chop($numse = `ps -ef | grep se.sap${sid}_ | grep -v grep | wc -l`);
  
  # Count co
  chop($numco = `ps -ef | grep co.sap${sid}_ | grep -v grep | wc -l`);
  print "SAPNUMCO: $numco \n";

  # Get name of SAP profile 
  chop($ps = `ps -ef | grep gwrd | grep $sid | grep -v grep`);
  @words = split(/ /,$ps);
  $pf = $words[$#words];
  if ($pf !~ /^pf=/)
  {
    &error("gwrd Not Running - Cannot determine SAP profile name");
  }
  $pf = substr($pf,3);
  print "PF: $pf \n";

  $wp_total = $wp_no_btc = $wp_no_dia = $wp_no_enq = $wp_no_spo = $wp_no_vb = $wp_no_vb2 = 0;

  # Get wp_no info from profile
  open (PAR,"sappfpar all pf=$pf |") || &error("Cannot open pf=$pf - $!");
  while(<PAR>)
  {
    @words = split;
    if ($words[1] =~ /rdisp\/wp_no_/)
    {
      $parm = substr($words[1],6);
      if ($#words == 4)   # No user specification - SAP default
      {
        $value = $words[4];
      }
      else  # User specified value
      {
        $value = $words[3];
      }
      $str = "\$$parm = '$value';"; 
      eval "$str"; 
      print "${parm}: $value \n";
    }
  }

  $wp_total = $wp_no_btc + $wp_no_dia + $wp_no_enq + $wp_no_spo + $wp_no_vb + $wp_no_vb2;

  print "wp_total: $wp_total \n";
  #$wp_shouldberunning = $wp_total + 1;
  # Test - 02Apr01 - The number that should be running for now is wp_total * 0.8
  $wp_shouldberunning = int($wp_total * 0.8);
  print "wp_shouldberunning: $wp_shouldberunning \n";

  $dwflag = "PROCESSERROR $numdw $wp_shouldberunning - There should be at least $wp_shouldberunning dw processes" if $numdw < $wp_shouldberunning;
  print "SAPNUMDW: $numdw dw $dwflag\n";
  
  $startflag = "PROCESSSTART $numstart 1 - There should be 1 startsap process" if $numstart < 1;
  print "SAPNUMSTART: $numstart startsap $startflag\n";

  $seflag = "PROCESSERROR $numse 1 - There should be at least 1 se process" if $numse < 0;
  print "SAPNUMSE: $numse se $seflag\n";

  # If wp_no_enq > 0, then the MS and CO processes must be running
  if ($wp_no_enq > 0) 
  {
    $msflag = "PROCESSERROR $numms 1 - There should be at least 1 ms process" if $numms < 1;
    $coflag = "PROCESSERROR $numco 1 - There should be at least 1 co process" if $numco < 1;
  }
  print "SAPNUMMS: $numms ms $msflag\n";
  print "SAPNUMCO: $numco co $coflag\n";

  # Determine which DBMS
  if (-e "/oracle/$sid")
  {
    $dbms = "Oracle";
    $ENV{'ORACLE_SID'} = $sid;
    $ENV{'PATH'} = "$ENV{'PATH'}:/oracle/$sid/bin";
    $ENV{'dbms_type'} = "ora";
    $ENV{'dbs_ora_tnsname'} = $sid;
    if (system("grep NLS_LANG ~${sidlc}adm/.dbenv_${hostname}.sh") == 0)
    {
      chop($nls_lang = `grep NLS_LANG ~${sidlc}adm/.dbenv_${hostname}.sh | awk -F= '{ print \$2 }' | awk '{ print \$1 }'`);
      $ENV{'NLS_LANG'} = $nls_lang;
      chop($orahome = `grep ^ORACLE_HOME ~${sidlc}adm/.dbenv_${hostname}.sh | head -1 |  awk -F= '{ print \$2 }' | awk '{ print \$1 }' | awk -F\\; '{ print \$1 }'`);
      $/ = ';';
      chomp $orahome;
      $ENV{'ORACLE_HOME'} = $orahome;
      print "$P | Setting NLS_LANG to $nls_lang \n";
    }
    $ENV{'ORACLE_HOME'} = "/oracle/$sid" if $orahome eq ""; 
  }
  elsif (-e "/informix/$sid")
  {
    $dbms = "Informix";
    $ENV{'INFORMIXDIR'} = "/informix/$sid";
    chop($dbserver = `grep ONCONFIG ~${sidlc}adm/.dbenv_${hostname}.sh | awk -F. '{ print \$2 }'`);
    $dbserver = $hostname if $dbserver eq "";

    #chop($ifmxsrvr = `grep INFORMIXSERVER ~${sidlc}adm/.dbenv_${hostname}.sh | head -1 | awk -F= '{ print \$2 }' | awk '{ print \$1 }' | awk -F\\; '{ print \$1 }'`);
    #$ENV{'INFORMIXSERVER'} = $ifmxsrvr;
    #$ENV{'INFORMIXSERVER'} = "${dbserver}${sidlc}tcp" if $ifmxsrvr eq "";

    # Count number of oninits running on this server
    chop($oninits = `ps -ef | grep oninit | grep -v grep | wc -l`);
    if ($hostname eq $dbserver || $oninits > 0)
    {
      $method = "shm";
    }
    else
    {
      $method = "tcp";
    }
    if (system("chatr \$INFORMIXDIR/bin/oninit | grep SHMEM_MAGIC") == 0)
    {
      $method = "tcp";
    }

    $ENV{'INFORMIXSERVER'} = "${dbserver}${sidlc}$method";

    print "$P | Informix dbserver=$dbserver hostname=$hostname method=$method \n";

    $ENV{'INFORMIX_DBID'} = "$sidlc";
    $ENV{'INFORMIXSQLHOSTS'} = "/informix/$sid/etc/sqlhosts.soc";
    $ENV{'ONCONFIG'} = "onconfig.$dbserver.$sidlc";
    $ENV{'PATH'} = "/informix/$sid/bin:$ENV{'PATH'}:.";
    $ENV{'dbms_type'} = "inf";
    #$ENV{'ENV'} = "/home/${sid}adm/.kshrc";
  }
  print "DBMS: $dbms \n";

  # Check DB Status
  $dbcheckout = `R3check -d -v -w $tmpdir/R3check.out 2>&1`;
  if ($dbcheckout =~ /R3check finished \(0000\)/)
  {
    $dbcheckflag = "DBCHECKOK";
  }
  else
  {
    $dbcheckflag = "DBCHECKNG";
    print "$P | dbcheckout=$dbcheckout \n";
    system("env | sort");
  }
  print "DBCHECK: $dbcheckflag \n";

  # Summarize for dbamon_check (WWW)
  if ($dbcheckflag eq "DBCHECKOK" && $startflag eq "" && $dwflag eq "" && $msflag eq "" && $seflag eq "" && $coflag eq "")
  {
    print "<table border=1>\n";
    print "<tr bgcolor=lime><th><font size=2>Because R3check worked OK and all tasks appear to be running, SAP is UP.</font>\n";
    print "</table><br>\n";
  }
  else
  {
    print "<table border=1>\n";
    print "<tr bgcolor=pink><th><font size=2>SAP is Not Up.</font>\n";
    print "</table><br>\n";
  }
}

# ----------------------------------------------------------------------
# Main
# ----------------------------------------------------------------------

$stime = time;

if ($verb eq "up") 
{
    $subrc = &up();
}
else
{
  &error("Unknown verb=$verb");
}

#
# Terminate
#
$etime = time;
$elapsed = $etime - $stime;
print "$P | Done - elapsed: $elapsed - subrc: $subrc\n";

&msg("END_OF_PROBE");
exit 0;
