#!/usr/local/bin/perl
#--------------------------------------------------------------------------
#
# dbamon_mssql.pl
#
#--------------------------------------------------------------------------
# Changes:
#      08Jun02 bb - Added event_limit code
# 1.10 25Oct02 bb - Better diag code.
# 1.11 14Jan04 bb - Recoded to not batch SQL statements
# 1.12 24Jan04 bb - Now, PERLPATH will always contain ../perl.exe
# 1.13 07Mar04 bb - New code to detect rsh service
# 1.14 19Apr04 bb - Fixed pslist code to end on error invoking 
# 1.15 14May04 bb - New NTRESKIT code. Now, try to find it in the default path
# 1.16 13Aug04 bb - New checkTLogs logic.
# 1.17 19Aug04 bb - New code for TLogs to check disk utilization
# 1.18 24Nov04 bb - Line 576 - added sort to the foreach
# 1.19 20Dcc04 bb - Added code to change color of WWW display if agent is down 
# 1.20 29Apr05 bb - New logic to query MSSQL version from db @@version 
# 1.21 11Aug05 bb - For MSSQL version, pad right node if < 4 chars (8.00.761 becomes 8.00.0761)
# 1.22 26Feb07 bb - New doubletake logic 
# 1.23 17Jul07 bb - Added dbatools to srvinfo search logic 
# 1.24 16Oct07 bb - For TEMPDB, we will now skip sp_spaceused and select max refdate
# 1.25 12Dec07 bb - New no_sp_spaceused up parm to skip sp_spaceused 
# 1.26 18Dec07 bb - Gather DB attributes (like snapshot, readonly)
# 1.27 07Jan07 bb - oldPerl - Changed hours threshold from 12 to 24 
# 1.28 16Jan07 bb - Suppress errors from cluster and srvinfo. Also recorded connect
#                     logic and new connectDB subroutine. Also, added isolation level
# 1.29 29Jan07 bb - Implement isolation level change for all servers 
# 2.00 05Jan11 bb - Massive changes.
# 2.10 08Feb11 bb - More Massive changes. New PERF collection and have to rethink TEMP
# 2.11 24Mar11 bb - Added saveConfig 
# 2.12 24Apr11 bb - diskCheck now uses WMI 
# 2.13 01Aug11 bb - New BADPARM checks in getDBAttrs 
# 2.14 15Sep11 bb - L572 - If we hist the SQL error log limit, then FINISH
# 2.15 29Sep11 bb - New code to deal with a SQL 2000 NAMED INSTANCE! (yuck) 
# 2.16 03Oct11 bb - New checkSuspectPages
# 2.17 05Oct11 bb - New LOCAL CFG concept (readCfg) 
# 2.18 11Nov11 bb - New io_delay_events logic AND new BULK SYSPERF
# 2.19 22Nov11 bb - WMI change - call CMD if WMI no-workie
# 2.20 22Nov11 bb - New countCPUs sub
# 2.21 10Dec11 bb - Improved timestamp checking in checklog
# 2.22 10Jan12 bb - New SysPerfSpecial for SQL 2000 
# 2.23 20Jan12 bb - New logic for wow6432node mode (registry) 
# 2.24 07Feb12 bb - Changed event_limit from 100 to 500
# 2.25 08Feb12 bb - Line 4957 change SYSNAME data type to LOWER CASE (Latin lang issue)
# 2.26 03Mar12 bb - New HEREITIS Changes for instance with fixed size FGs 
# 2.27 07Apr12 bb - New login around line 2595 - Look for text for 2.27. 
# 2.28 21Apr12 bb - WMI logic change in the event that it is present but returns no data 
# 2.29 30Apr12 bb - Logic to skip RESTORING DBs 
# 2.30 30Apr12 bb - Around line 1115 logic to avoid ZERO DIVIDE. 	
# 2.31 22May12 bb - Logic to skip RESTORING DBs 
# 2.32 26May12 bb - Added Synthetic trans results capture logic 
# 2.33 01Jun12 bb - backupType - We now look for /backup exec/ backups (symantec). 
# 2.34 27Jun12 bb - Removal of Win32::Registry calls and new WMIProcessor 
# 2.35 03Jul12 bb - Done now with usewin32registry code (needs to be tested/debugged) 
# 2.36 07Jul12 bb - New WMIOperatingSystem sub to get correct lastrebootdate + now using $^X
# 2.37 07Jul12 bb - Many changes (5.37.C) + I made the call to &WMIOperatingSystem switchable - can cause slowness
# 2.38 04Aug12 bb - Improved Synthetic Trans logic to include User Metrics 
# 2.39 28Aug12 bb - Line 5389 changed sp_msforeachdb to sp_MSforeachdb (thanks Darryl Heath for finding this)
# 2.40 13Sep12 bb - Changed all HTML from the old <h5>'s to $style_normal 
# 2.41 15Sep12 bb - Changed event_limit from 500 to 1000000
# 2.42 06Oct12 bb - Changed all data return calls to use dataReturn. 
# 2.43 20Oct12 bb - New Goodparm_Off Checks 
# 2.44 01Nov12 bb - New SysPerf2000Waits and new ServiceAccount logic 
# 2.45 18Nov12 bb - New checkPctGrowth and checkCFiles 
# 2.46 20Mar13 bb - Added "deadlock-list" to list of strings that indicate a deadlock. This is new for SQL Trace Flag 1222 
# 2.47 27Apr13 bb - MANY changes for 5.42.A
# 2.48 17May13 bb - Enhancement to checklog - For deadlock snapshots we now only care about the first 19 chars of the 
#                     timestamp because there are deadlock that span many millisecond periods of time.  
# 2.49 20May13 bb - Enhancement to checklog - We now monitor for STACK DUMP events. Also added NTLM remote conn checking.
# 2.50 08Jun13 bb - Trying to eliminate xp_regread - many changes. 
# 2.51 21Jun13 bb - New io_delay_count logic. 
# 3.00 27Jun13 bb - MAJOR Changes to accomodate consolidating all 3 probes (up, bkup, checklog) to the "up" probe. 
# 3.01 19Jul13 bb - Added Session_Week_Old perf metric. 
# 3.02 11Aug13 bb - Added checkTempDBContention 
# 3.03 11Aug13 bb - Added checkTempDBBalance 
# 3.04 23Aug13 bb - Had to comment checkTempDBContention because it gives syntax errors on some servers
# 3.05 11Nov13 bb - Added checkSQLPort
# 3.06 27Jan14 bb - New logic in checkFilegroups to EXCLUDE SNAPSHOT DBs 
# 3.07 09Feb14 bb - Snapshot DBs are excluded from return Space-related metrics 
# 3.08 04Mar14 bb - New checkAO (SQL2012 only)
# 3.09 04Mar14 bb - New checkSSRS
# 3.10 09May14 bb - New WMISCSI
# 3.11 14May14 bb - Changes to checkSSRS for improved error reporting
# 3.12 03Sep14 bb - Support for SQL2014
# 3.13 16Sep14 bb - The NTLM sub now checks for ALL auth_method(s). 
# 3.14 05Dec14 bb - In checkReplication() we now look for dist. agent profiles that begin with 'default%', rather than
#                     looking for the entire name of the default agent profile +
#                   checkTempDBIOBalance() capped the percent at 250.
# 3.15 28Jan15 bb - Improved query in checkAutoReorg to look for reportservertempdb in a named instance
# 3.16 21Feb15 bb - Improved RJ logic to inclued min max_login_hrs value 
# 3.17 02May15 bb - DBs in RECOVERY_PENDING will now be skipped 
# 3.18 17May15 bb - New check for SINGLE_USER
# 3.19 12Jun15 bb - The SA Session count metric now will return data, even if the count is 0 
# 3.20 06Aug15 bb - Added NUAIR logic to checklog()
# 3.21 23Aug15 bb - We are now returning more Disk Drive data
# 3.22 30Sep15 bb - For saveConfigSQL - we don't want L backups - Added: AND ba.type != 'L'
# 3.23 07Nov15 bb - checkFileGroups Had logic bug for FIXED files. Fixed.
# 3.24 13Nov15 bb - First attempt at checkCDNS and checkCDSF
# 3.25 18Dec15 bb - In checkReplication, the select for agent name now translates space to underscores 
# 3.26 20Mar16 bb - For AO backup age checking, we don't care about backup checking for ASYNC nodes
# 3.27 03Apr16 bb - Updated IDLE WAITS
# 3.28 24Oct16 bb - Improvement to NTLM_Remote & we now will only do WMINetPerf 00-02 every day (it is very slow on some servers)
#                     and new DTC Failure counting logic
# 3.29 30Oct16 bb - For 5.55.B - new checkWorkerThreads sub 
# 3.30 15Nov16 bb - Initial support for MSSQL 2016 (very few changes)
#--------------------------------------------------------------------------
$version = "3.30";

$| = 1;
$P = "dbamon_mssql.pl";

#--------------------------------------------------------------------------
#
# Global Variables
#
#--------------------------------------------------------------------------

#---- Behavior flags
$usewin32registry = 0; 
$use_mssqlregread = 1; 
$use_wmiosver     = 1; 
$use_rr_wow6432   = 0;   #---- This can be changed later

#---- Global Settings
$event_limit         = 1000000;
$typeperf_sample_dur = 1;
$debug               = 0;
$use_wmio            = 0; 
$repl_dist           = 0; 
$style_normal = "style='font-family:Arial;font-size:10pt;'";

$deadlock_flag       = 0; 
$deadlock_lastts     = '9999'; 
$dashes              = '=' x 80;

use Time::Local;
use DBI;

#---- for WMI calls
use constant wbemFlagReturnImmediately => 0x10;
use constant wbemFlagForwardOnly => 0x20;

#---- Get rid of compile warnings
$bt_desc = $tsts = $jobsupdated = $fg_fileid = $fg_growth = $char_val = $size = $usr2 = $root_fs = $hoursup = $endc = $pgm2 = $fg_file_in_group = $index_val = ""; 
$bt_dbname = $bt_type = $bt_timestamp = $bt_size  = ""; 

#------------------------------------------------------------------------------
#
# Subroutines
#
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub commify 
#------------------------------------------------------------------------------
{
  # commify a number. Perl Cookbook, 2.17, p. 64
  my $text = reverse $_[0];
  $text =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
  return scalar reverse $text;
}

#------------------------------------------------------------------------------
sub timeToNum
#------------------------------------------------------------------------------
{
  $zz_text = $_[0];
  $zz_text =~ s/-/\//g;
  $zz_text =~ s/:/\//g;
  ##print "zz_text=$zz_text\n";
  @words = split(/\//,$zz_text);

  if ($#words != 5)
  {
    &error("Input Target_End_Time ($zz_text) should be in the format: YYYY/MM/DD-HH:MM:SS","DOC116");
  }

  $zz_yyyy = $words[0];
  $zz_mon  = $words[1];
  $zz_dd   = $words[2];
  $zz_hh   = $words[3];
  $zz_mm   = $words[4];
  $zz_ss   = $words[5];
  ##print "zz_yyyy=$zz_yyyy zz_mon=$zz_mon zz_dd=$zz_dd zz_hh=$zz_hh zz_mm=$zz_mm zz_ss=$zz_ss\n";

  &error("Input Target_End_Time - YYYY must be 2002-2099","DOC116") if ($zz_yyyy < 2002 || $zz_yyyy > 2099);
  &error("Input Target_End_Time - MON  must be 1-12     ","DOC116") if ($zz_mon  <    1 || $zz_mon  >   12);
  &error("Input Target_End_Time - DD   must be 1-31     ","DOC116") if ($zz_dd   <    1 || $zz_dd   >   31);
  &error("Input Target_End_Time - HH   must be 0-23     ","DOC116") if ($zz_hh   <    0 || $zz_hh   >   23);
  &error("Input Target_End_Time - MM   must be 0-59     ","DOC116") if ($zz_mm   <    0 || $zz_mm   >   59);
  &error("Input Target_End_Time - SS   must be 0-59     ","DOC116") if ($zz_ss   <    0 || $zz_ss   >   59);

  @zz_date=($zz_ss,$zz_mm,$zz_hh,$zz_dd,--$zz_mon,$zz_yyyy);
  $zz_result = &timelocal(@zz_date);

  return $zz_result;
}

# ----------------------------------------------------------------------
sub getDBAttrs2000
# ----------------------------------------------------------------------
{
  my $dbname = $_[0];
  &msg("getDBAttrs2000 - Starting - dbname=$dbname"); 

  #---- dbamon_mssql.pl DB_ATTRS: model DBState=ONLINE,CompatibilityLevel=100,CreateDate=2003/04/08-09:13:36,DBID=3,RecoveryModel=SIMPLE

  $sth = $dbh->prepare("exec sp_helpdb \@dbname='$dbname'") || &dbError("Prepare");
  $sth->execute || &dbErrorOK("sp_helpdb db=$dbname");

  do
  {
    while(@Data = $sth->fetchrow_array)
    {
      if ($Data[0] eq $dbname) 
      { 
        my $zdata = $Data[5]; 
        $zdata =~ s/\s+//g;
        &dataReturn("DB_ATTRS: $dbname $zdata"); 
        $dbattrs{$dbname} = $zdata; 
      }
    }
  } while($sth->{odbc_more_results});
}

#------------------------------------------------------------------------------
sub getDBAttrs
#------------------------------------------------------------------------------
{
  #---- 1.26 START - Gather DB attributes (2005+ only)
  # 2012/06/26 BB - if ($ver >= 9)
  if ($vershort >= 90)
  {
    &msg("DEBUG: This is an MSSQL 2005+ DB - Checking for DB attributes") if $debug;
    $sql = "
    select
      source_database_id, 
      is_read_only ,
      compatibility_level,
      recovery_model_desc,
      database_id,
      tempdb.dbo.dateconvert_19(create_date),
      state_desc
    from sys.databases where name = '$dbname';
    ";
    &msg("DEBUG: Running sql=$sql") if $debug;

    $sth = $dbh->prepare("$sql") || &error("Prepare");
    $sth->execute || &error("Execute_Select");
    $db_attrs = ""; 
    while (@Data = $sth->fetchrow_array)
    { 
      $source_database_id = $Data[0];
      $is_read_only       = $Data[1];
      $comp_level         = $Data[2];
      $rec_model          = $Data[3];
      $database_id        = $Data[4];
      $cre_date           = $Data[5];
      $db_state           = $Data[6];
      &msg("DEBUG: source_database_id=$source_database_id is_read_only=$is_read_only") if $debug;
    }

    $db_attrs .= "DBState=$db_state,CompatibilityLevel=$comp_level,CreateDate=$cre_date,DBID=$database_id,RecoveryModel=$rec_model";

    if ($source_database_id > 0) { $db_attrs .= ",Snapshot"; }
    if ($is_read_only == 1)      { $db_attrs .= ",Readonly"; }

    $dbname_out = $dbname;
    $dbname_out =~ s/\s/[BLANK]/g;
    $dbname_out =~ s/\-/[HYPHEN]/g;

    if ($db_attrs)
    {
      ##chop $db_attrs;    #---- Remove trailing comma
      &dataReturn("DB_ATTRS: $dbname_out $db_attrs"); 
      $dbattrs{$dbname} = $db_attrs; 
    }
  }
  else
  {
    &msg("DEBUG: This is NOT a MSSQL 2005+ Instance - Calling getDBAttrs2000");
    &getDBAttrs2000($dbname); 
  }
  #---- 1.26 END

  #---- 2.13 START
  $sql = "SELECT 
  'AutoShrink', 
  DATABASEPROPERTYEX ( '$dbname' , 'isautoshrink' ) 
  UNION ALL
  select 
  'AutoClose',  
  DATABASEPROPERTYEX ( '$dbname' , 'isautoclose' ) 
  order by 1
  "; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L3546");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

  $badparms = ""; 
  while (@Data = $sth->fetchrow_array)
  {
    $colname = $Data[0]; 
    $value   = $Data[1]; 
    if ($value == 1) 
    { 
      $z = uc $colname;
      $badparms .= "$z=$value,"; 
    }
  }
  &msg("BADPARMS Results - badparms=($badparms)") if ! $WWW;
  if ($badparms)
  {
    $badparms =~ s/\,$//;  #---- Remove trailing comma
    $dbname_out = $dbname;
    $dbname_out =~ s/\s/[BLANK]/g;
    $dbname_out =~ s/\-/[HYPHEN]/g;
    &dataReturn("BADPARMS: $dbname_out $badparms"); 
  }
  #---- 2.13 END
  
  #---- 2.43 START - Look for good parms that are off but should be on
  $sql = "SELECT 
  'AutoCreateStatistics', 
  DATABASEPROPERTYEX ( '$dbname' , 'isautocreatestatistics' ) 
  UNION ALL
  select 
  'AutoUpdateStatistics',  
  DATABASEPROPERTYEX ( '$dbname' , 'isautoupdatestatistics' ) 
  order by 1
  "; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L3546");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

  my $goodparms = ""; 
  while (@Data = $sth->fetchrow_array)
  {
    $colname = $Data[0]; 
    $value   = $Data[1]; 
    if ($value == 0) 
    { 
      $z = uc $colname;
      $goodparms .= "$z=$value,"; 
    }
  }
  &msg("GOODPARMS Results - goodparms=($goodparms)") if ! $WWW;
  if ($goodparms)
  {
    $goodparms =~ s/\,$//;  #---- Remove trailing comma
    $dbname_out = $dbname;
    $dbname_out =~ s/\s/[BLANK]/g;
    $dbname_out =~ s/\-/[HYPHEN]/g;
    &dataReturn("GOODPARMS_Off: $dbname_out $goodparms"); 
  }
  #---- 2.43 END
}

#------------------------------------------------------------------------------
sub get_date
#------------------------------------------------------------------------------
{
  # Return date in format supplied as argument. Valid formats are:
  #   Y/M/D-H:M:S
  #   YMD_HMS
  #   YMD
  $format = $_[0];

  @sysdate = localtime;
  for ($i = 0; $i <= 5; $i++)
  {
    if ($sysdate[$i] < 10)
    {
      $sysdate[$i] = 0 . $sysdate[$i];
    }
  }

  if ($format eq "Y/M/D-H:M:S")
  {
    $sysdate = $sysdate[5]+1900 . "/" . ++$sysdate[4] . "/" . $sysdate[3] . "-" . $sysdate[2] . ":" . $sysdate[1] . ":" . $sysdate[0];
  }
  elsif ($format eq "YMD_HMS")
  {
    $sysdate = $sysdate[5]+1900 . ++$sysdate[4] . $sysdate[3] . "_" . $sysdate[2] . $sysdate[1] . $sysdate[0];
  }
  elsif ($format eq "YMD")
  {
    $sysdate = $sysdate[5]+1900 . ++$sysdate[4] . $sysdate[3];
  }
  else
  {
    &error("Invalid format passed to get_date. Must be Y/M/D-H:M:S or YMD_HMS");
  }
  return $sysdate;
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  $date = &get_date("Y/M/D-H:M:S");
  print "$date ${P} $version | $msgmsg\n";
  #---- Also log to a file
  print PLOG "$date ${P} $version | $msgmsg\n";
}

#------------------------------------------------------------------------------
sub dbError 
#------------------------------------------------------------------------------
{
   local($errorMsg,@error_fields) = @_;
   print "======== D B   E r r o r   E n c o u n t e r e d =========\n";
   print "Error: DB Error Encountered While: $errorMsg\n";
   print "Error: DB Error String: $DBI::errstr\n";
   print "LastSQL:  $sql\n" if $sql ne "";
   print "==========================================================\n";
   $dberror = 1;
   @errors = split ("Database",$DBI::errstr);
   $chk_str = lc($errors[1]);
   $db      = $dbname;
   if ($chk_str =~ " \'$db\' cannot be opened because it is offline")
     {
       $offline = 1;
     }
   &msg("END_OF_PROBE");
   exit 1;
}

#------------------------------------------------------------------------------
sub dbErrorOK 
#------------------------------------------------------------------------------
{
   local($errorMsg,@error_fields) = @_;
   print "======== D B   E r r o r   E n c o u n t e r e d =========\n";
   print "Error: DB Error Encountered While: $errorMsg\n";
   print "Error: DB Error String: $DBI::errstr\n";
   print "LastSQL:  $sql\n" if $sql ne "";
   print "==========================================================\n";
   $dberror = 1;
   @errors = split ("Database",$DBI::errstr);
   $chk_str = lc($errors[1]);
   $db      = $dbname;
   if ($chk_str =~ " \'$db\' cannot be opened because it is offline")
     {
       $offline = 1;
     }
}

# ----------------------------------------------------------------------
sub error
# ----------------------------------------------------------------------
{
  $msg = $_[0];
  print "$P | Fatal Error: $msg\n";
  print "***********************************************************\n";
  print "Error: $msg\n";
  print "***********************************************************\n";
  &msg("<font color=red><b>ERROR: $msg</b></font>");
  print "$P | Exiting\n";
  &msg("END_OF_PROBE");
  close(PLOG); 
  exit 1;
}

# ----------------------------------------------------------------------
sub bkbl
# ----------------------------------------------------------------------
{
  $dbname = $arg1;
  $bktype = $arg2;

  $dbname =~ s/\[HYPHEN\]/\-/g;
  $dbname =~ s/\[BLANK\]//g;
  
  if ($dbname eq "ALL")
  {
    if (-e "$SQLPATH\\dba_bkup_log\\ALL.txt")
    {
      $logpath = "$SQLPATH\\dba_bkup_log\\ALL.txt";
    }
    else
    {
      &msg("Looking for ALL.log in alternate location");
      $logpath = "\\temp\\ALL.txt";
    }
  }
  else
  {
    $logpath = "$SQLPATH\\dba_bkup_log\\${dbname}_${bktype}_backlog.txt";
  }

  &msg("bkbl1() - dbname=$dbname bktype=$bktype logpath=$logpath");

  if (! -e $logpath)
  {
    &error("Log file $logpath does not exist");
  }

  print "<table bgcolor=skyblue class=c1>
  <tr><td><pre>
<b>Start of mssql_backup Log: $logpath</b><hr>";

# - added by Scott.  I added the \" around the $logpath variable to accept spaces
# - in the file name and/or path.
  system("type \"$logpath\" 2>&1");

  print "<hr>
<b>End of mssql_backup Log: $logpath</b></table>\n"; 
}

# ----------------------------------------------------------------------
sub processDeadlocks
# ----------------------------------------------------------------------
{
  &msg("processDeadlocks - Starting"); 

  foreach $dl_ts (sort keys %deadlock_lines)
  {
    &msg("Found dl_ts=$dl_ts"); 
    foreach $dl_line (split('\n',$deadlock_lines{$dl_ts}))
    {
      &msg("  dl_line=$dl_line"); 
      print "DDP:<|>$P<|>Deadlock_DDP_Packet:<|>$dl_ts<|>$dl_line<|>\n";
    }
  }

  &msg("processDeadlocks - Done"); 
}

# ----------------------------------------------------------------------
sub checklog
# ----------------------------------------------------------------------
{
  return if $WWW; 

  #---- 2013/06/27 - New way of passing parms 
  ## $rq_mssql_log_min_sev = 17;
  ## $rq_dbc_udm_stringcheck = "?";
  &msg("(DCF) PHONEHOME: rq_dbc_udm_stringcheck_is_NULL") if ! $rq_dbc_udm_stringcheck;

  #---- OLD: Process 1st arg - Message sev
  # if ($arg1 > 1 && $arg1 < 30) { $minsev = $arg1; }
  # else                         { $minsev = 17; }
  #---- NEW: Process 1st arg - Message sev
  if ($rq_mssql_log_min_sev > 1 && $rq_mssql_log_min_sev < 30) { $minsev = $rq_mssql_log_min_sev; }
  else                                                         { $minsev = 17; }

  #---- Vars
  $cl_debug1 = 0; 
  $out_limit = 50; 

  my $io_delay_events = 0; 
  my $io_delay_count = 0; 
  my $stackdump_events = 0; 
  my $untrusted_events = 0; 
  my $mem_paged_out_events = 0; 
  my $login_18456_events = 0; 
  my $dtc_notrans_events = 0; 

  my @login_18456_event_details = (); 

  my $use_bookmark_file = 0; 
  my $udm_stringcheck = ""; 
  my $udm_varname     = ""; 
  my $udm_msgcnt    = 0; 
  my $deadlock_events = 0; 

  #---- OLD: Process 2nd arg - Should be in the format thestring/VARNAME
  # if ($arg2)  #---- UDM Stringcheck
  # {
  #   $udm_stringcheck = (split(/\//,$arg2))[0];
  #   $udm_varname     = (split(/\//,$arg2))[1];
  #   if (! $udm_stringcheck || ! $udm_varname) 
  #   {
  #     undef $udm_stringcheck ; 
  #     undef $udm_varname     ; 
  #   }
  # }
  #---- NEW: Process 2nd arg - Should be in the format thestring/VARNAME
  if ($rq_dbc_udm_stringcheck)  #---- UDM Stringcheck
  {
    $udm_stringcheck = (split(/\//,$rq_dbc_udm_stringcheck))[0];
    $udm_varname     = (split(/\//,$rq_dbc_udm_stringcheck))[1];
    if (! $udm_stringcheck || ! $udm_varname) 
    {
      undef $udm_stringcheck ; 
      undef $udm_varname     ; 
    }
  }

  &msg("checklog - Starting - event_limit=$event_limit - minsev=$minsev - udm_stringcheck=$udm_stringcheck udm_varname=$udm_varname");  
  
  &msg("The following strings will be excluded (\@cfg_chkalert_e):");  
  foreach (@cfg_chkalert_e)
  {
    &msg("  $_");
  }

  $tsfile = "dbamon_mssql_checklog_ts_$in_instance.txt";
  $events = 0;
  
  if ($use_bookmark_file)
  {
    #---- OLD - FROM File
    &msg("(TSFILE-Start) Reading ts file: $tsfile");
    ## system("dir $tsfile");
    ## system("type $tsfile");
    #---- Read TS file
    open(TS, "$tsfile") || print "$P | Can't open input $tsfile - $!\n";;
    while (<TS>)
    {
      @words = split;
      $tsdate = $words[0];
      $tstime = $words[1];
    }
    $in_rtimestamp = "$tsdate $tstime"; 
    close(TS);
    &msg("(TSFILE-End) Input timestamps - We will begin processing at: tsdate=$tsdate tstime=$tstime - in_rtimestamp=$in_rtimestamp");
  }

  #---- NEW - From DCF
  $in_rtimestamp = $dcf_data{'SQLLogBookmark'}; 
  &msg("(DCF) Input dcf_data{SQLLogBookmark}=$dcf_data{'SQLLogBookmark'} - We will begin processing at in_rtimestamp=$in_rtimestamp");
  &msg("(DCF) PHONEHOME: Input_DCF_SQLLogBookMark_is_NULL_NORMAL_FOR_FIRST_ITERATION") if ! $dcf_data{'SQLLogBookmark'};
  &msg("(DCF) PHONEHOME: Input_in_rtimestamp_is_NULL_NORMAL_FOR_FIRST_ITERATION") if ! $in_rtimestamp;

  #---- Common logic
  &msg("We will begin processing at in_rtimestamp=$in_rtimestamp - minsev=$minsev"); 

  use DBI;
  &connectDB;

  if (!$dberror)
  {
    &msg("Invoking master..xp_readerrorlog");
    $sth = $dbh->prepare("exec master..xp_readerrorlog") || &dbError("Prepare");

    $rows_raw = 0; 
    $rows_new = 0; 

    my $found_ts_good = 0; 
    my $found_ts_bad  = 0; 
    my $first_timestamp = ""; 
    my $first_timestamp_filtered = ""; 

    $sth->execute                                || &dbError("Execute_Select");
    READLOG: while (@Data = $sth->fetchrow_array)
    {
      $rows_raw++; 

      if ($vershort <= 80) 
      {
        @words = split ' ', $Data[0];
        $rdate = $words[0];
        $rtime = $words[1];
        $rpid  = $words[2];
        $verb  = $words[3];
      }
      else
      {
        @words = split ' ', $Data[0];
        $rdate = $words[0];
        $rtime = $words[1];
        @words = split ' ', $Data[1];
        $rpid  = $words[0];
        @words = split ' ', $Data[2];
        $verb  = $words[0];
      }

      #---- In case we need this later
      $deadlock_key = substr($Data[0], 0, 19); 

      if ($deadlock_key eq $deadlock_lastts)    #---- If this TS is = to last deadlock TS that we saw, then save it. 
      {
        $deadlock_lines{$deadlock_key} .= $Data[2] . "\n"; 
      }
      
      #---- NEW way
      #---- Better Date validation
      #---- Example: Most Recent Date/Time 2011-12-10/05:45:09.23
      if (length($rdate) == 10 && $rdate =~ /^2/ && substr($rdate,4,1) eq "-" 
          && substr($rtime,2,1) eq ":" && substr($rtime,5,1) eq ":")
      {
        #---- Good timestamp 
        $found_ts_good++; 
        $save_rdate = $rdate; 
        $save_rtime = $rtime;
        $first_timestamp = "$save_rdate/$save_rtime" if ! $first_timestamp;
        $rtimestamp = "$rdate $rtime"; 
      }
      else
      {
        #---- Bad timestamp 
        $found_ts_bad++; 
        #---- We only want to keep rows with a good timestamp, which will exclude 2000 CONTINUATION rows
        next;
      }

      #---- OLD way
      #if ($rdate =~ /^20/)
      #{
      #  $save_rdate = $rdate;
      #  $save_rtime = $rtime;
      #}
     
      &msg("DEBUGLOG: TS-Compare - rtimestamp=$rtimestamp in_rtimestamp=$in_rtimestamp") if $cl_debug1;

      #---- Skip rows with a timestamp lower than our minimum timestamp
      if ($rtimestamp le $in_rtimestamp)
      {
        next; 
      }

      $first_timestamp_filtered = "$save_rdate/$save_rtime" if ! $first_timestamp_filtered;
      $rows_new++; 

      #---- Count messages that are not in the proper format
      my $datawork = ""; 
      if ($vershort <= 80)  { $datawork = $Data[0]; } 
      else                  { $datawork = $Data[2]; } 

      if ($datawork =~ /The login is from an untrusted domain/i) { $untrusted_events++; } 
      if ($datawork =~ /stack dump being sent/i)                 { $stackdump_events++; } 
      if ($datawork =~ /significant part of sql server process memory has been paged out/i) { $mem_paged_out_events++; } 
      if ($datawork =~ /Wait-for graph/i)                        { $deadlock_events++; } 

      #---- SQL Server has encountered x occurrence(s) of I/O requests taking longer than 15 seconds to complete on file 
      #----   [Drive:\MSSQL\MSSQL.1\MSSQL\Data\xyz.mdf] in database [database].  The OS file handle is 0x00000000.  The offset of the latest long I/O is: 0x00000000000000
      if ($datawork =~ /requests taking longer than/i) 
      { 
        $io_delay_events++; 
        #---- Count occurrences
        $io_delay_thiscount = (split(/\s/,$datawork))[4];
        if ($io_delay_thiscount > 0) 
        {
          $io_delay_count += $io_delay_thiscount; 
        }
      } 

      #---- Count these:
      #----   Import of Microsoft Distributed Transaction Coordinator (MS DTC) transaction failed: 0x8004d00e(XACT_E_NOTRANSACTION).
      if ($datawork =~ /Import of Microsoft Distributed Transaction Coordinator/i && $datawork =~ /failed/i && $datawork =~ /XACT_E_NOTRANSACTION/i) 
      { 
        $dtc_notrans_events++; 
      } 

      if ($datawork =~ /deadlock-list/i)               
      { 
        $deadlock_events++; 
        $deadlock_lines{$deadlock_key} .= $Data[2] . "\n"; 
        $deadlock_flag   = 1;
        $deadlock_lastts = $deadlock_key;  #---- Save timestamp - we will place all rows with this TS into the hash with this timestamp as the key
      } 

      if ($datawork =~ /Error: 18456/i)                
      { 
        $login_18456_events++; 
        push(@login_18456_event_details, "$rdate $rtime $datawork") if $login_18456_events <= 100; 
      } 
      if ($datawork =~ /Login failed for user/i)                
      { 
        push(@login_18456_event_details, "$rdate $rtime $datawork") if $login_18456_events <= 100; 
      } 

      if ($udm_stringcheck)
      {
        ##&msg("DEBUG-T1 - d2=$Data[2] udm_stringcheck=$udm_stringcheck"); 
        if ( index(uc $datawork, uc $udm_stringcheck) > -1) 
        { 
          $udm_msgcnt++; 
          ##&msg("DEBUG-T2"); 
        } 
      }
      #---- 
  
      &msg("DEBUGLOG: HIT") if $cl_debug1; 

      if ($firstflag != 1)
      {
        &msg("First Date/Time $rdate/$rtime");
        $firstflag = 1;
      }

      &msg("Found New SQL Log Message - verb=$verb rdate=$rdate rtime=$rtime flag2nd=$flag2nd [Data0=$Data[0]] [Data1=$Data[1]] [Data2=$Data[2]]") if $cl_debug1;

      if ($flag2nd)
      {
        if ($vershort <= 80) 
        {
          $errmsg = substr($Data[0],32);
        }
        else
        {
          $errmsg = substr($Data[2],0);
        }
        $errmsg =~ s/\n$//;

        if ($errsev >= $minsev)
        {
          #---- Exclude "No user action is required" events
          if ($errmsg =~ /no user action is required/i)
          {
            &msg("** This is an NUAIR message - Skipping - errnum=$errnum errmsg=($errmsg)");
            next READLOG;
          }

          #---- OLD Way
          #---- Events that we don't want to report
          ## next if $errnum eq "17805";
          #---- NEW Way
          #---- See if this errnum is excluded
	  foreach $this_exclusion (@cfg_chkalert_e)
	  {
            if ($this_exclusion eq $errnum)
            {
              &msg("** This errnum=$errnum DOES match CFG File this_exclusion=$this_exclusion - NOT Reporting - Nexting to next log row");
              next READLOG;
            }
	  }

          #---- Now that we know that this row was NOT EXCLUDED, increment counter
          ++$events;
          &msg("Total Non-EXCLUDED Event Count (so far): $events");

          #---- Special handling for a few events
          if ($errnum eq "35278")   #---- AO DB role switch
          {
            &dataReturn("AO_Event: Error=$errnum Sev=$errsev Sta=$errsta Text=$errmsg"); 
          }
          else
          {
	    #---- Report this event - This is what we look for at the MASTER
	    print "Event: $rdate-$rtime Error=$errnum Sev=$errsev Sta=$errsta Text=$errmsg\n";
          }
        }
        $flag2nd = 0;
        next; 
      }

      if ($verb eq 'Error:')
      {
        &msg("Found SQL Log ERROR Message - verb=$verb rdate=$rdate rtime=$rtime flag2nd=$flag2nd [$Data[0]]");

        if ($events >= $event_limit)
        {
          &msg("Event count of $events exceeds limit of $event_limit - will not process an more events");
          last;
        }

	if ($vershort <= 80) 
	{
	  @words = split ' ', $Data[0];
	  $errnum = $words[4]; 
	  chop($errnum);
	  $errsev = $words[6];
	  chop($errsev);
	  $errsta = $words[8];
	  chop($errsta);
	}
	else
	{
	  @words = split ' ', $Data[2];
	  $errnum = $words[1]; 
	  chop($errnum);
	  $errsev = $words[3];
	  chop($errsev);
	  $errsta = $words[5];
	  chop($errsta);
        }

        $flag2nd = 1; # We want to read the next line
        &msg("  Results - errnum=$errnum errsev=$errsev errsta=$errsta flag2nd=$flag2nd [$Data[2]]");
      }
    }  #---- End of fetch while

    if ($use_bookmark_file)
    {
      #OLD - #---- Save the last timestamp that we checked
      &msg("Saving timestamps: $save_rdate $save_rtime to $tsfile");
      open(TS, "> $tsfile")    || die "Error: Can't open output file: $tsfile\n";
      print TS "$save_rdate $save_rtime\n";
      close(TS);
      &msg("Contents of tsfile=$tsfile:");
      system("type $tsfile"); 
    }

    #---- Example: Most Recent Date/Time 2011-12-10/05:45:09.23
    &msg("Results from xp_readerrorlog:");
    &msg("  TotalRows:                $rows_raw");
    &msg("  NewRows:                  $rows_new");
    &msg("  ErrorsWithSev >= $minsev:      $events");
    &msg("  found_ts_good:            $found_ts_good"); 
    &msg("  found_ts_bad:             $found_ts_bad");
    &msg("  Log Low Timestamp:        $first_timestamp");
    &msg("  Bookmark Start Timestamp: $in_rtimestamp");
    &msg("  Filtered Low Timestamp:   $first_timestamp_filtered");
    &msg("  Log High Timestamp:       $save_rdate/$save_rtime");
    &msg("  UDM_MsgCnt:               $udm_msgcnt");

    #---- Trigger event if > 1m rows
    ##print "$P SQL_Log_Rows: $rows_raw\n" if $rows_raw > 1000000; 
    &dataReturn("SQL_Log_Rows: $rows_raw") if $rows_raw > 0; 

    #---- NEW - Save the last timestamp that we checked
    $dcf_data{'SQLLogBookmark'} = "$save_rdate $save_rtime";
  }

  #---- Just incase we had to "last" out of that while
  $sth->finish || &dbErrorOK("Finish_572");

  &msg("Special events:");

  #---- Event text if we found io_delay_events
  &msg("  I/O Delay Count: $io_delay_count");
  &dataReturn("IODelayCount: $io_delay_count"); 

  &msg("  I/O Delay Events: $io_delay_events");
  &dataReturn("IODelayEvents: $io_delay_events"); 

  #---- Event text if we found stackdump_events
  &msg("  Untrusted Events: $untrusted_events");
  &dataReturn("SYSPERF: SQL_Untrusted_Domain_Events $untrusted_events"); 

  #---- Event for possible DTC NoTrans events 
  &msg("  DTC NOTRANS Events: $dtc_notrans_events");
  &dataReturn("SYSPERF: SQL_DTC_Failed_NoTrans_Events $dtc_notrans_events"); 

  #---- Event text if we found stackdump_events
  &msg("  StackDump Events: $stackdump_events");
  &dataReturn("StackDumpEvents: $stackdump_events"); 

  #---- Event text if we found mem_paged_out_events
  &msg("  Memory Paged Out Events: $mem_paged_out_events");
  &dataReturn("MemPagedOutEvents: $mem_paged_out_events"); 

  #---- Event text if we found mem_paged_out_events
  &msg("  UDM_Stringcheck=$udm_stringcheck MsgCnt: $udm_msgcnt");
  if ($udm_stringcheck) 
  {
    &dataReturn("UDMStringCheckMsgCnt: $udm_msgcnt $udm_varname"); 
  }

  #---- Deadlock count
  &msg("  Deadlock Events: $deadlock_events");
  &dataReturn("DeadlockEvents: $deadlock_events"); 

  #---- Number of invalid login events
  &msg("  Invalid Login 18456 Events: $login_18456_events");
  &dataReturn("18456_Events: $login_18456_events"); 
  foreach (@login_18456_event_details)
  {
    &dataReturn("18456_Event_Details: $_"); 
  }

  #---- Extract the last 30 lines of the SQL log for the drilldown page
  $sth = $dbh->prepare("exec master..xp_readerrorlog") || &dbError("Prepare");
  $sth->execute                                || &dbError("Execute_Select");

  undef %clog_hash; 
  $row_cnt   = 0; 
  $out_cnt   = 0; 
  &msg("Reading the last $out_limit lines of xp_errorlog for display at the MASTER"); 

  while (@Data = $sth->fetchrow_array)
  {
    $row_cnt++;  #---- For uniqueness in keynum

    if ($vershort <= 80)  #---- SQL 2000 & lower (less than 2005)
    {
      $keynum = substr($Data[0],0,23) . $row_cnt; 
      ##$zline = "<td><b> $Data[0] </b></td> "; 
      @words = split ' ', $Data[0];
      $ts1 = shift @words; 
      $ts2 = shift @words; 
      $spid = shift @words; 
      $text = ""; 
      foreach (@words) { $text .= "$_ "; }
      $zline = "
	<td nowrap> &nbsp; $ts1 $ts2 &nbsp; </td>
	<td nowrap> &nbsp; $spid &nbsp; </td>
	<td><b> $text </b></td>
      "; 
    }
    else   #---- > SQL 2000
    {
      $keynum = $Data[0] . $row_cnt; 
      $zline = "
	<td nowrap> &nbsp; $Data[0] &nbsp; </td>
	<td nowrap> &nbsp; $Data[1] &nbsp; </td>
	<td><b> $Data[2] </b></td>
      "; 
    }

    $keynum =~ s/\-//g;
    $keynum =~ s/\ //g;
    $keynum =~ s/\://g;
    $keynum =~ s/\.//g;

    ##&msg("DEBUG - keynum=$keynum"); 
    $zline =~ s/\n//g; 
    $clog_hash{$keynum} = $zline; 
  }

  foreach $key (sort hashDescTS (keys(%clog_hash))) 
  {
    last if $out_cnt > $out_limit;
    &dataReturn("CurrentLog: " . $clog_hash{$key}); 
    $out_cnt++; 
  }
  &msg("checklog - Done"); 
}

# ----------------------------------------------------------------------
sub checkAgentLog
# ----------------------------------------------------------------------
{
  return if $WWW; 

  # Vars
  $cl_debug1 = 0; 
  $out_limit = 50; 
  my $use_bookmark_file = 0; 

  &msg("checkAgentLog - Starting - event_limit=$event_limit");  
  
  #&msg("The following strings will be excluded (\@cfg_chkalert_e):");  
  #foreach (@cfg_chkalert_e)
  #{
  #  &msg("  $_");
  #}

  $events = 0;

  if ($use_bookmark_file)
  {
    #---- Old
    $tsfile = "dbamon_mssql_checkAgentLog_ts_${in_instance}.txt";
    &msg("Reading ts file: $tsfile");
    system("dir $tsfile");
    system("type $tsfile");
    #---- Read TS file
    open(TS, "$tsfile") || print "$P | Can't open input $tsfile - $!\n";;
    while (<TS>)
    {
      $ts = $_;
    }
    $in_rtimestamp = $ts; 
    &msg("Input timestamps - We will begin processing at: in_rtimestamp=$in_rtimestamp");
    close(TS);
  }

  if ($vershort < 90)
  {
    if (-e "$rr_sql_agent_log") 
    {
      $sql_agent_log = $rr_sql_agent_log; 
    }
    else
    {
      $sql_agent_log = "${SQLPATH}\\log\\sqlagent.out"; 
    }

    if (-e "$sql_agent_log")
    {
      $sql = "exec xp_readerrorlog 1,'$sql_agent_log'"; 
    }
    else
    {
      &msg("SQL agent log path is non-standard - Cannot find file:"); 
      &msg("  sql_agent_log=$sql_agent_log"); 

      #---- See if we can find it in the registry
      &msg("Attempting to read agent log location from registry"); 
      &msg("MSSQL_REGREAD - agentlogloc"); 
      $sql2 = "EXECUTE master.dbo.xp_instance_regread N'HKEY_LOCAL_MACHINE',
        N'SOFTWARE\\Microsoft\\MSSQLServer\\SQLServerAgent', N'ErrorLogFile'";
      $sth = $dbh->prepare("$sql2") || &dbError("Prepare");
      $sth->execute                || &dbError("Execute_Select");
      while (@Data = $sth->fetchrow_array)
      {
	$sql_agent_log = $Data[1];
      }
      &msg("Resulting sql_agent_log=$sql_agent_log"); 

      if ($sql_agent_log && -e "$sql_agent_log")
      {
	$sql = "exec xp_readerrorlog 1,'$sql_agent_log'"; 
      }
      else
      {
	&msg("SQL agent log path STILL not found - I GIVE UP - sql_agent_log=$sql_agent_log"); 
	return;
      }
    }
  }
  else
  {
    $sql = "exec xp_readerrorlog 0,2"; 
  }
   
  #---- New - DCF
  $in_rtimestamp = $dcf_data{'AgentLogBookmark'}; 
  &msg("Input timestamps - DCF - dcf_data{'AgentLogBookmark'}=$dcf_data{'AgentLogBookmark'} - We will begin processing at in_rtimestamp=$in_rtimestamp");
  &msg("(DCF) PHONEHOME: Input_DCF_AgentLogBookMark_is_NULL_NORMAL_FOR_FIRST_ITERATION") if ! $dcf_data{'AgentLogBookmark'};

  &msg("Invoking master:xp_readerrorlog - sql=$sql");
  $dbh->do("use master")     || &dbError("Use_Master_1");
  $sth = $dbh->prepare($sql) || &dbError("Prepare");

  $rows_raw = 0; 
  $rows_new = 0; 

  $sth->execute                                || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
    $rows_raw++; 

    if ($vershort < 90) 
    {
      $ag_ts         = substr($Data[0],0,19);
      $ag_text       = substr($Data[0],21);
      $ag_errorlevel = "";  
    }
    else
    {
      $ag_ts         = $Data[0];
      $ag_errorlevel = $Data[1];
      $ag_text       = $Data[2];
    }

    &msg("DEBUGLOG-AG: TS-Compare - ag_ts=$ag_ts in_rtimestamp=$in_rtimestamp") if $cl_debug1;

    if ($ag_ts le $in_rtimestamp)
    {
      next; 
    }
    $rows_new++; 
    &msg("DEBUGLOG: HIT - rows_new=$rows_new") if $cl_debug1; 

    if ($firstflag != 1)
    {
      &msg("First ag_ts=$ag_ts");
      $firstflag = 1;
    }

    &msg("Found New SQL Log Message - ag_ts=$ag_ts ag_errorlevel=$ag_errorlevel ag_text=$ag_text") if $cl_debug1;

    #---- REPORT any errors
    #---- 2012/07/27 BB 2.37: Add "unable to"
    if (
      $ag_text =~ /error/i || 
      $ag_text =~ /unable to/i || 
      $ag_text =~ /no email session/i
    )
    {
      ++$events;
      &msg("Total Event Count (so far): $events");

      #---- Events that we don't want to report
      next if $ag_text =~ /idunno/i;

      #---- Report this event 
      print "EventAgent: TS=$ag_ts ErrorLevel=$ag_errorlevel - $ag_text\n";
    }
  } 

  &msg("Most Recent ag_ts=$ag_ts");

  &msg("From xp_readerrorlog - TotalRows: $rows_raw NewRows: $rows_new Errors: $events - ag_ts=$ag_ts");

  if ($use_bookmark_file)
  {
    #---- Save the last timestamp that we checked
    &msg("Saving timestamp: $ag_ts to $tsfile");
    open(TS, "> $tsfile")    || die "Error: Can't open output file: $tsfile\n";
    print TS "$ag_ts\n";
    close(TS);
    &msg("Contents of tsfile=$tsfile:");
    system("type $tsfile"); 
  }

  #----NEW - DCF #---- Save the last timestamp that we checked
  $dcf_data{'AgentLogBookmark'} = "$ag_ts";
  
  #---- Extract the last 30 lines of the SQL log for the drilldown page

  $dbh->do("use master")     || &dbError("Use_Master_1");
  $sth = $dbh->prepare($sql) || &dbError("Prepare");
  $sth->execute              || &dbError("Execute_Select");

  undef %clog_hash; 
  $row_cnt   = 0; 
  $out_cnt   = 0; 
  &msg("Reading the last $out_limit lines of xp_errorlog for display at the MASTER"); 

  while (@Data = $sth->fetchrow_array)
  {
    $row_cnt++;  #---- For uniqueness in keynum

    $keynum = substr($Data[0],0,23) . $row_cnt;    #---- Timestamp
    $zline = "
      <td nowrap> &nbsp; $Data[0] &nbsp; </td>
      <td nowrap> &nbsp; $Data[1] &nbsp; </td>
      <td><b> $Data[2] </b></td>
      "; 

    $keynum =~ s/\-//g;
    $keynum =~ s/\ //g;
    $keynum =~ s/\://g;
    $keynum =~ s/\.//g;

    &msg("DEBUG - keynum=$keynum") if $cl_debug1; 
    $zline =~ s/\n//g; 
    $clog_hash{$keynum} = $zline; 
  }

  foreach $key (sort hashDescTS (keys(%clog_hash))) 
  {
    last if $out_cnt > $out_limit;
    print "$P CurrentLogAgent: " . $clog_hash{$key} . "\n"; 
    $out_cnt++; 
  }
  &msg("checkAgentLog - Done");  
}

# ----------------------------------------------------------------------
sub hashDescTS 
# ----------------------------------------------------------------------
{
  $b <=> $a
}

# ----------------------------------------------------------------------
sub checkTLog
# ----------------------------------------------------------------------
{
  &msg("Checking transaction logs for all databases");

  if ($WWW)
  {
    print "<br>\n";
    &msg("Transaction Log Status:");
    print "<br><table border=1 bgcolor=skyblue class=c1>\n";
    print "<tr bgcolor=slate>
      <th $style_normal>Database<br>(One Row Per TLOG)
      <th $style_normal>TLog Size<br>(mB)
      <th $style_normal>TLog<br>Percent<br>Full<br>Internal
      <th $style_normal>TLog<br>Percent<br>Full<br>vs. Max
      <th $style_normal>Is DB In<br>Trunc-Log-<br>On-Ckpt<br>Mode?
      <th $style_normal>TLog<br>Max<br>Size
      <th $style_normal>TLog<br>Path
      <th $style_normal>TLog<br>Drive
      <th $style_normal>TLog<br>Drive<br>Size<br>(Mb)
      <th $style_normal>TLog<br>Drive<br>Free<br>(Mb)
      <th $style_normal>TLog<br>Drive<br>Used<br>(Mb)
      <th $style_normal>TLog<br>Drive<br>Percent<br>Full
    \n";
  }

  $sql = "exec ('DBCC SQLPERF (LOGSPACE)')";

  $dbh->do("use master") || &dbError("Use_Master");
  $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
  $sth3->execute() || &error("Could not execute sql=$sql");
  while (@Data = $sth3->fetchrow_array)
  {
    $selectcount++;

    $ctl_dbname  = $Data[0];
    $ctl_size{"$ctl_dbname"}    = sprintf("%.2f",$Data[1]);
    $ctl_pctused{"$ctl_dbname"} = sprintf("%.2f",$Data[2]);
  }
  $sth3->finish() || &dbError("Could not execute FINISH");

  ##@sorted = sort keys %ctl_size;
  ##foreach (sort keys %ctl_size)
  foreach (sort { lc $a cmp lc $b } keys %ctl_size)
  {
    $dbname = $_;   
    $size    = $ctl_size{"$dbname"};
    $pctused = $ctl_pctused{"$dbname"};

    &dbProperties($dbname);

    $dbp_rawdata = "";
    &dbProperties2($dbname);
    foreach (split('\n',$dbp_rawdata))
    {
      @words = split;

      ##$dbp_rawdata .= "$dbp_log_fname $dbp_log_space $dbp_log_fsize\n";

      $dbp_log_fname = $words[0];
      $dbp_log_space = $words[1];
      $dbp_log_fsize = $words[2];

      #---- Start
      if ($dbp_trunc_on_ckpt == 1)
      {
	$trunc = "Yes";
      }
      else
      {
	$trunc = "No";
      }

      #---- See how full the TLog disk is
      $this_drive_letter = uc substr($dbp_log_fname,0,1);

      #---- Old
      #$this_drive_size   = (split(" ",$disks{"$this_drive_letter"})) [2];
      #$this_drive_free   = (split(" ",$disks{"$this_drive_letter"})) [3];
      #$this_drive_used   = (split(" ",$disks{"$this_drive_letter"})) [4];
      #$this_drive_pctused = sprintf("%.2f",($this_drive_used / $this_drive_size) * 100) if $this_drive_size > 0;

      #---- New
      $this_drive_size   = commify($disk_size_mb{"$this_drive_letter"}); 
      $this_drive_free   = commify($disk_free_mb{"$this_drive_letter"}); 
      $this_drive_used   = commify($disk_used_mb{"$this_drive_letter"}); 
      $this_drive_pctused = $disk_pct_full{"$this_drive_letter"}; 

      $dbname_out = $dbname;
      $dbname_out =~ s/\s/[BLANK]/g;
      $dbname_out =~ s/\-/[HYPHEN]/g;

      if ($WWW)
      {
	if    ($trunc eq "Yes") { $color = "skyblue"; }
	elsif ($pctused >= 90 || $this_drive_pctused >= 90)  { $color = "pink"; }
	elsif ($pctused >= 80 || $this_drive_pctused >= 80)  { $color = "yellow"; }
	else                    { $color = "lime"; }

        if ($dbp_log_space ne "Unlimited")
        {
          #---- 2012/05/10 - 2.30 
          if ($dbp_log_space == 0) 
          {
            &msg("ERROR: Zero divide avoided - dbp_log_space=$dbp_log_space"); 
	    $pctused_vs_max = -1; 
            $color = "white";  
          }
          else
          {
	    $pctused_vs_max = sprintf "%.2f", ($dbp_log_fsize / $dbp_log_space) * 100;
	    if    ($pctused_vs_max >= 99) { $color = "pink"; }
	    elsif ($pctused_vs_max >= 95) { $color = "yellow"; }
          }
        }
        else
        {
          $pctused_vs_max = "N/A";
        }
	
	print "<tr bgcolor=$color>
	  <td $style_normal><b> $dbname_out </b>
	  <td $style_normal align=right>$dbp_log_fsize
	  <td $style_normal align=right>${pctused}%
	  <td $style_normal align=right>${pctused_vs_max}%
	  <td $style_normal>$trunc
	  <td $style_normal>$dbp_log_space
	  <td $style_normal>$dbp_log_fname
	  <td $style_normal>$this_drive_letter
	  <td $style_normal align=right>$this_drive_size
	  <td $style_normal align=right>$this_drive_free
	  <td $style_normal align=right>$this_drive_used
	  <td $style_normal align=right>${this_drive_pctused}%
	\n";
      }
      else
      {
        $this_drive_pctused = "." if $this_drive_pctused eq ""; 
        if ($dbp_log_space == 2147483.65) { $dbp_log_space = "Unlimited"; }
        if ($dbp_log_space eq "2147483.65") { $dbp_log_space = "Unlimited"; }

	&dataReturn("TLOG: $dbname_out $trunc $dbp_log_fsize $pctused $this_drive_letter $this_drive_pctused $dbp_log_fname $dbp_log_space");
      } 

      #---- End
    }
  }

  if ($WWW)
  {
    print "</table><br>\n";
  }

  &msg("Found $selectcount databases");

  if ($WWW)
  {
    print "<br>\n";
    &msg("Drives Which Contain MSSQL Data Files:");
    print "<br><table border=1 bgcolor=skyblue class=c1>\n";
    print "<tr bgcolor=slate>
	<th $style_normal>Drive 
	<th $style_normal>Size (mB)
	<th $style_normal>Used (mB)
	<th $style_normal>Free (mB)
	<th $style_normal>Percent<br>Full
    ";
  }

  #---- Drives
  foreach (sort @db_drivelist)
  {
    $this_drive = $_;
    if ($_ ne $last)
    {
      #---- Old
      #$this_drive_size   = t(" ",$disk_size_gb{"$this_drive"})) [2];
      #$this_drive_free   = (split(" ",$disks{"$this_drive"})) [3];
      #$this_drive_used   = (split(" ",$disks{"$this_drive"})) [4];
      #$this_drive_pctused = sprintf("%.2f",($this_drive_used / $this_drive_size) * 100) if $this_drive_size > 0;
      #---- New
      &msg("Checking drive: $this_drive"); 

      $this_drive_size   = commify($disk_size_mb{"$this_drive"}); 
      $this_drive_free   = commify($disk_free_mb{"$this_drive"}); 
      $this_drive_used   = commify($disk_used_mb{"$this_drive"});  
      $this_drive_pctused = $disk_pct_full{"$this_drive"}; 

      if    ($this_drive_pctused >= 90) { $color = "pink"; }
      elsif ($this_drive_pctused >= 80) { $color = "yellow"; }
      else                              { $color = "lime"; }

      if ($WWW)
      {
	print "<tr bgcolor=$color>
	    <td $style_normal> $this_drive
	    <td $style_normal align=right> $this_drive_size
	    <td $style_normal align=right> $this_drive_used
	    <td $style_normal align=right> $this_drive_free
	    <td $style_normal align=right> ${this_drive_pctused}%
	";
      }
      else
      {
	&dataReturn("DRIVESTATUS: $this_drive $this_drive_size $this_drive_used $this_drive_free $this_drive_pctused");
      }
    }
    $last = $_;
  }

  if ($WWW)
  {
    print "</table><br>\n";

    #&msg("WWWTEST");
    #&test;
  }

  return 0;
}

# ----------------------------------------------------------------------
sub dbProperties2
# ----------------------------------------------------------------------
{
   my $dbname = $_[0];
   $dbname_uc = uc $dbname;

   &msg("dbProperties2 - Executing sp_helpdb \@dbname='$dbname'"); 

   $sth = $dbh->prepare("exec sp_helpdb \@dbname='$dbname'") || &dbError("Prepare");
   $sth->execute || &dbErrorOK("sp_helpdb db=$dbname");

   $dbp_log_space = "";

   do
   {
     ##print "BEFORE WHILE\n";
     while(@Data = $sth->fetchrow_array)
     {

       #---- Look for updateability:
       if ($Data[5] =~ /Updateability=READ_ONLY/) 
       { 
         $readOnlyDBs{$dbname_uc} = 1; 
       }

       if ($Data[7] eq "log only") 
       { 
         $dbp_log_fname  = $Data[2]; 
         $dbp_log_fsize  = $Data[4]; 
         $dbp_log_space  = $Data[5]; 
         $dbp_log_growth = $Data[6]; 

	 $dbp_log_fname =~ s/ //g;
	 $dbp_log_fsize =~ s/ //g;
	 $dbp_log_space =~ s/ //g;

         if ($dbp_log_space =~ /2147483648/) 
         { 
           if ($dbp_log_growth eq "0 KB") { $dbp_log_space = "FixedSize"; }
           else                           { $dbp_log_space = "Unlimited"; }
         }

         ##print "TLOG_DEBUG: dbname=$dbname dbp_log_space=$dbp_log_soace dbp_log_growth=$dbp_log_growth\n"; 

	 if ($dbp_log_space =~ /KB$/)
	 {
	   chop $dbp_log_space;
	   chop $dbp_log_space;
	   $dbp_log_space = sprintf "%.2f", ($dbp_log_space * 1024) / (1024*1024);
	 }
	 if ($dbp_log_fsize =~ /KB$/)
	 {
	   chop $dbp_log_fsize;
	   chop $dbp_log_fsize;
	   $dbp_log_fsize = sprintf "%.2f", ($dbp_log_fsize * 1024) / (1024*1024);
	 }

         $dbp_rawdata .= "$dbp_log_fname $dbp_log_space $dbp_log_fsize\n";
         ##print "<tr bgcolor=white><td colspan=99>dbp_log_fname=$dbp_log_fname dbp_log_space=$dbp_log_space dbp_log_fsize=$dbp_log_fsize\n";
       }
     }
   } 
   while($sth->{odbc_more_results} && $dbp_log_space eq "");

   $sth->finish || &dbErrorOK("Finish1");

   &msg("dbProperties2 - Done"); 
   return;
}

# ----------------------------------------------------------------------
sub dbFiles
# ----------------------------------------------------------------------
{
   my $dbname = $_[0];

   push(@db_drivelist,"C");

   $sth = $dbh->prepare("exec sp_helpdb \@dbname='$dbname'") || &dbError("Prepare");
   $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

   my $db_filelist = "";

   do
   {
     while(@Data = $sth->fetchrow_array)
     {
       #$i = -1;
       #foreach (@Data)
       #{
       #  $i++;
       #  $z = $_;
       #  print "Data[$i]=$z\n"; 
       #}
       
       if ($Data[7] eq "data only") 
       { 
         $db_filelist .= "<br>$Data[2]"; 
         my $db_filesize =  $Data[4]; 

	 my $db_filedrive = substr($Data[2],0,1);
         push(@db_drivelist,uc $db_filedrive);

         $db_filesize =~ s/ KB//;
         $db_filesize_mb = sprintf("%.2f", ($db_filesize / 1024)); 
         $db_tot_datafile_size_mb{$dbname} += $db_filesize_mb; 
         $db_tot_datafile_count{$dbname}++; 
       }
       if ($Data[7] eq "log only") 
       { 
         my $log_filesize =  $Data[4]; 

	 my $db_filedrive = substr($Data[2],0,1);
         push(@db_drivelist,uc $db_filedrive);

         $log_filesize =~ s/ KB//;
         $log_filesize_mb = sprintf("%.2f", ($log_filesize / 1024)); 
         $db_tot_log_size_mb{$dbname} += $log_filesize_mb; 
       }

     }
   } 
   while($sth->{odbc_more_results});
   $sth->finish || &dbErrorOK("Finish1");

   $tlog_db_ratio{$dbname} = sprintf("%.2f", ($db_tot_log_size_mb{$dbname} / $db_tot_datafile_size_mb{$dbname})) if $db_tot_datafile_size_mb{$dbname} > 0; 

   return $db_filelist;
}

# ----------------------------------------------------------------------
sub dbProperties
# ----------------------------------------------------------------------
{
   my $dbname = $_[0];

   $dbp_trunc_on_ckpt = -999;

   ##&msg("  Checking logging option for: $dbname...");

   my $sth4 = $dbh->prepare(<<End_SQL) or die "COULD NOT PREPARE SQL";
   select databaseproperty('$dbname','IsTruncLog') as log_option
End_SQL
   $sth4->execute() || &dbError("COULD NOT EXECUTE SQL STATEMENT");

   while (($log_option) = $sth4->fetchrow_array() )
   {
      $dbp_trunc_on_ckpt = $log_option;
   }
   $sth4->finish() || &dbError("COULD NOT EXECUTE SQL STATEMENT");

   return;
}

# ----------------------------------------------------------------------
sub getNetInfo
# ----------------------------------------------------------------------
{
  &msg("getNetInfo - Starting - Querying net properties"); 

  #---- IP and VLAN
  open(NET, 'ipconfig|') || print "Error: Running net start - $!\n";
  while(<NET>)
  {
    ##print;
    @words = split;

    if (/IPv4 Address/) 
    {
      $net_ip = $words[$#words]; 
      last;
    }
    if (/IP Address/) 
    {
      $net_ip = $words[$#words]; 
      last;
    }
  }
  close(NET); 

  #---- Extract VLAN 
  @net_vlan_ary = split (/\./,$net_ip); 
  $net_vlan = $net_vlan_ary[0] . "." . $net_vlan_ary[1] . "." . $net_vlan_ary[2]; 

  &dataReturn("NET_IP:      $net_ip");
  &dataReturn("NET_VLAN:    $net_vlan");
  &dataReturn("NET_COMPANY: $company");

  &msg("getNetInfo - Done - net_ip=$net_ip net_vlan=$net_vlan"); 
}

# ----------------------------------------------------------------------
sub up
# ----------------------------------------------------------------------
{
  &msg("up() Starting - arg1=$arg1 arg2=$arg2"); 
  
  #---- Get Network stuff
  &getNetInfo;

  #---- See if this is a PHYSICAL or VIRTUAL server (presence of c:\program files\vmware folder)
  if ( -e "c:\\program files\\vmware") { $server_type = "VMWare"; }
  else                                 { $server_type = "Physical"; }
  &dataReturn("ServerType: $server_type");

  #---- See if this file exists (this logic is for the lightbulb)
  $sp_file = "DBAmon_no_sp_spaceused.txt";
  $sp_hours = 24;
  if (-e "$sp_file")
  {
    system("dir $sp_file"); 
    $sp_file_mtime = ( stat $sp_file )[9];
    $sp_file_age_hrs = (time - $sp_file_mtime) / 3600;
    &msg("up() sp_file=$sp_file Does exist - sp_file_age_hrs=$sp_file_age_hrs sp_file_mtime=$sp_file_mtime"); 
    if ($sp_file_age_hrs <= $sp_hours)
    {
      $arg2 = "no_sp_spaceused"; 
      &msg("  Since sp_file has been updated within the last $sp_hours hours, I will set arg2=$arg2"); 
    }
    else
    {
      &msg("  Since sp_file has NOT been updated within the last $sp_hours hours, no action taken"); 
    }
  }

  &msg("Checking DB up and collecting space data - arg1=$arg1 arg2=$arg2"); 

  if ($usewin32registry)   
  {
    #---- CPU and OSVER info from REGISTRY - START
    %values="";
    $Register = "Hardware\\Description\\System\\CentralProcessor\\0";
    $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
    $hkey->GetValues(\%values);
    foreach $value (keys(%values))
    {
      $RegType      = $values{$value}->[1];
      $RegValue     = $values{$value}->[2];
      $RegKey       = $values{$value}->[0];
      $MHz = $RegValue if $RegKey eq "\~MHz";
      $vendor = $RegValue if $RegKey eq "VendorIdentifier";
      $identifier = $RegValue if $RegKey eq "Identifier";
    }
    $hkey->Close();
    @cpu_ident = split (' ',$identifier); 
    $cpumodel = ${cpu_ident[0]} . "/" . ${cpu_ident[2]};
    $cpu = $vendor . " " . " " . $MHz . " MHz ";

    %values="";
    $Register = "Software\\Microsoft\\Windows NT\\CurrentVersion";
    $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
    $hkey->GetValues(\%values);
    foreach $value (keys(%values))
    {
      $RegType      = $values{$value}->[1];
      $RegValue     = $values{$value}->[2];
      $RegKey       = $values{$value}->[0];
      $CurrentVersion = $RegValue if $RegKey eq "CurrentVersion";
      $CSDVersion = $RegValue if $RegKey eq "CSDVersion";
    }

    if ($CSDVersion ne "")
    {
      @sp_info = split(' ',$CSDVersion);
      $osver = $CurrentVersion . ",SP" . ${sp_info[2]};
    }
    else
    {
      $osver = $CurrentVersion;
    }

    &dataReturn("OSVer: $osver $osname");
    &dataReturn("CPU: $cpu");
    &dataReturn("CPUModel: $cpumodel");

    #---- CPU info from REGISTRY - END
  }

  #---- OS Version Info from WMI 
  &WMIOSVer; 

  #---- Product info from WMI
  ## &WMIProduct;  #---- Very slow, so it's turn off 
  
  #---- OS Info from WMI (Last reboot) 
  &WMIOperatingSystem if $use_wmio; 

  #---- Services Info from WMI. Stored in a hash for other calls to use
  &WMIService; 

  #---- CPU Info from WMI
  &WMIProcessor; 

  #---- CPU Info from WMI
  &WMIComputerSystem; 

  #---- Gather network perf data
  &WMINetPerf; 
  
  #---- Gather top CPU consumers
  &WMITopProcessesCPU; 
  
  #---- Gather SCSI Controller info
  &WMISCSI; 
  
  #---- Count CPUs IF we didn't already
  &countCPUs if $numcpus eq "" || $numcpus == 0;

  #---- 3.10: Optionally add some drives to the list of drives that we will monitor
  if ($rq_mssql_addtl_drives ne "") 
  {
    @zchars = split(//, $rq_mssql_addtl_drives);
    foreach $this_drive (sort @zchars)
    {
      &msg("Adding drive this_drive=$this_drive to \@db_drivelist");
      push(@db_drivelist, $this_drive);
    }
  }

  #---- See if the MSSQLServer is running
  $rsh_service = "?";
  &msg("Running 'net start' to view running services - Looking for MSSQL running for this instance"); 
  open(NET, 'net start|') || print "Error: Running net start - $!\n";
  while(<NET>)
  {
    ##print;
    print if /sql/i;
    @words = split;

    if ($rsh_service eq "?")
    {
      if (/Remote Shell Daemon/)  { $rsh_service="RSD"; }
      if (/Remote Shell Service/) { $rsh_service="RSS"; }
      if (/CYGWIN sshd/)          { $rsh_service="CYGWIN"; }
      if (/openssh/i)             { $rsh_service="OpenSSH"; }
    }

    if (lc($words[0]) eq "mssqlserver") { print; $servicestat="[Running]"; }
  
    if ($vershort < 90)
    {
      if ($default_instance)
      {
        if (/^MSSQLSERVER/) { print; $servicestat="[Running]"; }
      }
      else
      {
        if (/MSSQL\$$in_instance/i) { print; $servicestat="[Running]"; }
      }
    }
    else
    {
      if (/SQL Server \(/ && /$in_instance/) { print; $servicestat="[Running]"; }
    }
  }
  close(NET);
  &msg("Read through running services - default_instance=$default_instance - servicestat=$servicestat"); 

  if ($servicestat eq "")
  {
    $servicestat="[Not Running]";
  } 

  &dataReturn("SQLVer: $ver");
  &dataReturn("MSSQLServiceStatus: $servicestat");
  &dataReturn("HOSTNAME: $host");
  &dataReturn("RSHService: $rsh_service");

  if ($servicestat =~ /not running/i)
  {
    &msg("Since SERVICE for this MSSQL instance ($in_instance) is NOT RUNNING, I will not try to connect to the DB"); 
    &dataReturn("DBStatus: DOWN");
    return;
  }
   
  #---- Connect to SQL
  &connectDB if ! $dbh;

  #---- Query the drive letter for TEMPDB - this will be used in SysPerfBulk
  &checkDrivesForPerf; 

  #---- Get SysPerf data here... 
  #if (! $WWW) 
  #---- 2012/08/14 BB: We now will do this for WWW because it is faster than waiting 5 seconds for systeminfo
  if (1) 
  {
    $perf_newway = 1; 
    if ($perf_newway)
    {
      &SysPerfBulk; 
      &SysPerfSpecial; 
    }
    else
    {
      &SysPerf; 
      &SysPerfBulk; 
      &SysPerfCompare; 
      &SysPerfSpecial; 
    }
  }

  #---- Get memory Info
  $mem = $dbh->prepare("exec master..xp_msver") || &dbError("Prepare_L1673");
  $mem->execute                                 || &dbError("Execute_Select_L1674");

  while (($index_val,$name,$internal_val,$char_val) = $mem->fetchrow_array() )
  {
     if (lc($name) eq "physicalmemory")
     {
        $ram = $internal_val;
        last;
     }
  }
  $mem->finish() || &dbError("Could not execute FINISH");

  if (defined($ram) && !$WWW)
  {
     &dataReturn("RAM: $ram MB");
     &dataReturn("SYSPERF: MemTotal_MB  $ram"); 
  }

  #---- Get the SQL server version, patch level and edition
  &msg("Querying SQL for patchlevel and edition"); 

  $sth = $dbh->prepare("
    SELECT SERVERPROPERTY('productversion'), 
    SERVERPROPERTY ('productlevel'), 
    SERVERPROPERTY ('edition'), 
    SERVERPROPERTY ('licensetype'), 
    SERVERPROPERTY ('numlicenses') ") || &dbError("Prepare_SQLVER_L1077");
  $sth->execute                         || &dbError("Execute_Select");

  $sql_version = $sql_patchlevel = $sql_edition = $sql_licensetype = $sql_numlicenses = "?"; 

  while (@Data = $sth->fetchrow_array)
  {
    $sql_version      = $Data[0]; 
    $sql_patchlevel   = $Data[1]; 
    $sql_edition      = $Data[2]; 
    $sql_licensetype  = $Data[3]; 
    $sql_numlicenses  = $Data[4]; 
  }
  $sth->finish() || &dbError("Could not execute FINISH");
  &msg("Results - sql_version=$sql_version sql_patchlevel=$sql_patchlevel sql_edition=$sql_edition sql_licensetype=$sql_licensetype sql_numlicenses=$sql_numlicenses"); 

  $sql_edition =~ s/\s//g if $sql_edition;
  $sql_numlicenses = -1 if ! $sql_numlicenses; 

  if ($sql_edition =~ /64-bit/) { $mssql64bit = 1; }

  if (defined($sql_version) && defined($sql_patchlevel) && defined($sql_edition) && !$WWW)
  {
    &dataReturn("SQL_Details: $sql_version $sql_patchlevel $sql_edition $sql_licensetype $sql_numlicenses");
  }

  #---- See if the agent is running

  &msg("Running 'net start' to see if the Agent is running");
  open(NET, 'net start|') || print "Error: Running net start";
  $agentrunning = 0; 
  while(<NET>)
  {
    print if /SQL/ && /agent/i;
    @words = split;

    if ($vershort < 90)  #---- SQL 2000 & lower (less than 2005)
    {
      if ($default_instance)
      {
	if (lc($words[0]) eq "sqlserveragent") { $agentrunning = 1; last; }
	if (lc($words[0]) eq "sqlexecutive") { $agentrunning = 1; last; }
      }
      else
      {
	if ($words[0] =~ /sqlagent\$${in_instance}/i) { $agentrunning = 1; last; }
      }
    }
    else  #---- 2005 or higher -- will always have the instance name as part of the service name
    {
      if (/SQL Server Agent \($in_instance\)/) { $agentrunning = 1; last; }
    }
  }
  close(NET);
  &msg("Resulting agentrunning=$agentrunning"); 

  #---- This is probably not necessary any more... 
  &connectDB if ! $dbh; 

  if (!$dberror)
  {
    &msg($dashes);
    &msg("Checking database=master");

    #---- Read from master and create a list of DBs that we'll use for the entire probe
    $sql = "select name from master..sysdatabases order by 1; ";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute                || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $dbname = $Data[0];
      push(@dblist,$dbname);
      ++$numdbs;
    }

    #---- 3.18 Create a list of DB attributes from master.sys.databases - these are not avail. from sysdatabases
    if ($vershort >= 90)  #---- SQL 2005 and higher
    {
      $debug_sd = 0;
      $sql = "select 
      name, 
      user_access_desc,
      snapshot_isolation_state_desc,
      is_read_committed_snapshot_on,
      log_reuse_wait_desc
      from master.sys.databases order by 1; ";
      $sth = $dbh->prepare("$sql") || &dbError("Prepare");
      $sth->execute                || &dbError("Execute_Select");
      while (@Data = $sth->fetchrow_array)
      {
	$dbname      = $Data[0];
        $dbattrs_ext{$dbname}{user_access}     = $Data[1];
        $dbattrs_ext{$dbname}{snapshot_on}     = $Data[2];
        $dbattrs_ext{$dbname}{rcsi_on}         = $Data[3];
        $dbattrs_ext{$dbname}{log_reuse_wait}  = $Data[4];
        &msg("DEBUG1939 - dbname=$dbname user_access=$user_access hash: $dbattrs_ext{$name}{user_access}") if $debug_sd; 
      }

      if ($debug_sd)
      {
	use Data::Dumper qw(Dumper);
	print Dumper \%dbattrs_ext;
	foreach $zkey (sort keys %dbattrs_ext)
	{
	  print "zkey=($zkey)\n"; 
	}
      }
    }

    &msg("DEBUG - selecting current_user") if $debug; 
    #---- Get session userid
    $sql = "select current_user;";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare_L1775");
    $sth->execute                || &dbError("Execute_Select_L1776");
    while (@Data = $sth->fetchrow_array)
    {
      $user = $Data[0];
    }

    $dbs_single_user_names = ""; 
    $dbs_single_user_cnt   = 0; 

    #---- Process DB names
    foreach $dbname (@dblist)
    {
      &msg($dashes); 
      &msg("Processing dbname=$dbname"); 

      ##$dbname_out = lc $dbname;  #---- 2010/11/25 - Let's try to leave it mixed case
      $dbname_out = $dbname;
      $dbname_out =~ s/\s/[BLANK]/g;
      $dbname_out =~ s/\-/[HYPHEN]/g;

      #---- Get info for this DB   
      &getDBAttrs;
      ##&msg("DEBUG2014 - dbname=$dbname db_attrs=$db_attrs"); 

      #---- 3.18 - New logic to SKIP SINGLE_USER DBs 
      &msg("Checking dbname=$dbname for SINGLE_USER ($dbattrs_ext{$dbname}{user_access})"); 
      if ($dbattrs_ext{$dbname}{user_access} eq "SINGLE_USER")
      {
        &msg("This DB ($dbname) is in SINGLE_USER Mode - Skipping remaining checks"); 
        #---- DB:     bbtest4 10.00 8.17 2010-04-02 16:59:23.653 BillB\MSSQL
        &dataReturn("DB:     $dbname_out 0 0 ? ? ?"); 
        $dbs_single_user_names .= "$dbname_out ";
        $dbs_single_user_cnt++;
        next; 
      }

      #---- 3.07 - New logic to SKIP SnapshotDB - this data skews trend metrics 
      if ($db_attrs =~ /,snapshot,/i) 
      {
        &msg("This DB ($dbname) is a SNAPSHOT DB - Skipping remaining checks"); 
        #---- DB:     bbtest4 10.00 8.17 2010-04-02 16:59:23.653 BillB\MSSQL
        &dataReturn("DB:     $dbname_out 0 0 ? ? ?"); 
        next; 
      }

      #---- 2.29 - New logic to SKIP restoring DB - they used to BLOW UP the probe
      if ($db_attrs =~ /state=restoring/i) 
      {
        &msg("This DB ($dbname) is in a RESTORING state - Skipping remaining checks"); 
        #---- DB:     bbtest4 10.00 8.17 2010-04-02 16:59:23.653 BillB\MSSQL
        &dataReturn("DB:     $dbname_out 0 0 ? ? ?"); 
        next; 
      }

      #---- 2.30 - New logic to SKIP OFFLINE DB - they used to BLOW UP the probe
      if ($db_attrs =~ /state=offline/i) 
      {
        &msg("This DB ($dbname) is in an OFFLINE state - Skipping remaining checks"); 
        #---- DB:     bbtest4 10.00 8.17 2010-04-02 16:59:23.653 BillB\MSSQL
        &dataReturn("DB:     $dbname_out 0 0 ? ? ?"); 
        next; 
      }

      #---- 3.17 - New logic to SKIP RECOVERY_PENDING DB - they used to BLOW UP the probe
      if ($db_attrs =~ /state=recovery_pending/i) 
      {
        &msg("This DB ($dbname) is in an RECOVERY_PENDING state - Skipping remaining checks"); 
        #---- DB:     bbtest4 10.00 8.17 2010-04-02 16:59:23.653 BillB\MSSQL
        &dataReturn("DB:     $dbname_out 0 0 ? ? ?"); 
        next; 
      }

      $sth->finish()        || &dbError("Finish");

      #---- Query space 
      $dbh->do("use \"$dbname\"") || &dbError("Use_$dbname");
      $sth = $dbh->prepare("exec sp_helpdb \@dbname='$dbname'") || &dbError("Prepare");
      $sth->execute || &dbErrorOK("sp_helpdb db=$dbname");

      $db_status = "";
      $db_created = "";
      $db_owner = "";

      while (@Data = $sth->fetchrow_array)
      {
        $db_owner   = $Data[2];
        $db_created = $Data[4];
        $db_status  = $Data[5];
        ##msg "dbname=$dbname db_owner=$db_owner db_status=$db_status db_created=$db_created\n";   # Test
      }

      $db_spacealloc = "?";
      $db_spacefree  = "?";
      $db_spaceused  = "?";

      if ($arg2 eq "no_sp_spaceused")
      {
        &msg("Skipping sp_spaceused for dbname=$dbname since Probe_Parm: = no_sp_spaceused"); 
        #TEMP#$sp_file = "C:\\temp\\DBAmon_no_sp_spaceused.txt";
        $sp_file = "DBAmon_no_sp_spaceused.txt";
        &msg("Touching file $sp_file for other utilities"); 
        system("echo x > $sp_file"); 
      }
      elsif ($dbname eq "tempdb")
      {
        &msg("Skipping sp_spaceused for tempdb (hostname/DB $host/$dbname)"); 
      }
      else
      {
	&msg("Running exec sp_spaceused for dbname='$dbname'") unless $WWW; 
	$sth = $dbh->prepare("exec sp_spaceused") || &dbError("Prepare");
	$dberror = 0;
	$sth->execute || &dbErrorOK("sp_spaceused db=$dbname");
	if ($dberror)
	{
	  ++$numdbsoffline;
	  &dataReturn("DB:     $dbname_out CONNECTERROR");
	  next;
	}
	## while (@Data = $sth->fetchrow_array)
        while (@Data = $sth->fetchrow_array or $sth->{odbc_more_results})
	{
	  ##msg "Data0=$Data[0]\n";   # Test
	  ##@words = split ' ', $Data[0];
	  ##$verb = $words[0];
	  ##if ($verb eq $dbname)
	  if (uc $Data[0] eq uc $dbname)
	  {
	    $db_spacealloc = $Data[1];
	    chop $db_spacealloc ; chop $db_spacealloc ;chop $db_spacealloc ;
	    $db_spacefree  = $Data[2];
	    chop $db_spacefree ; chop $db_spacefree ;chop $db_spacefree ;
	    $db_spaceused  = $db_spacealloc - $db_spacefree;
	  }
          #---- Read 2nd block of output which was previously unread
          if (uc $Data[0] =~ / KB$/)
	  {
	    my $su_reserved_kb = $Data[0];
	    my $su_tables_kb   = $Data[1];
	    my $su_indexes_kb  = $Data[2];
	    my $su_unused_kb   = $Data[3];

	    $su_reserved_kb =~ s/ KB$//; 
	    $su_tables_kb   =~ s/ KB$//; 
	    $su_indexes_kb  =~ s/ KB$//; 
	    $su_unused_kb   =~ s/ KB$//; 

	    my $su_reserved_mb = sprintf("%.2f", $su_reserved_kb / 1024); 
	    my $su_tables_mb   = sprintf("%.2f", $su_tables_kb / 1024) ;
	    my $su_indexes_mb  = sprintf("%.2f", $su_indexes_kb / 1024) ;
	    my $su_unused_mb   = sprintf("%.2f", $su_unused_kb / 1024) ;

            $su_reserved_mb = -1 if $su_reserved_mb eq ""; 
            $su_tables_mb   = -1 if $su_tables_mb eq ""; 
            $su_indexes_mb  = -1 if $su_indexes_mb eq ""; 
            $su_unused_mb   = -1 if $su_unused_mb eq ""; 

	    ##&msg("DEBUG - su_tables_mb=$su_tables_mb su_tables_kb=$su_tables_kb"); 

	    &dataReturn("DB_Space_Reserved_MB: $dbname_out $su_reserved_mb"); 
	    &dataReturn("DB_Space_Tables_MB:   $dbname_out $su_tables_mb"); 
	    &dataReturn("DB_Space_Indexes_MB:  $dbname_out $su_indexes_mb"); 
	    &dataReturn("DB_Space_Unused_MB:   $dbname_out $su_unused_mb"); 
	  }
	}
        $db_spacealloc = sprintf("%.2f", $db_spacealloc);
        $db_spaceused  = sprintf("%.2f", $db_spaceused );
      }

      $db      = $dbname;

      #---- Check last-accessed date
      $db_lastrefdate = "?"; 
      if ($dbname eq "tempdb")
      {
        &msg("Skipping select max refdate for tempdb (hostname/DB $host/$dbname)"); 
      }
      else
      {
	&msg("  Running 'select max(refdate) from sysobjects (nolock)' for dbname='$dbname'"); 
	$sth = $dbh->prepare("select max(refdate) from sysobjects (nolock)") || &dbError("Prepare");
	$sth->execute || &dbErrorOK("select sysobjects to db=$dbname");
	$db_lastrefdate = "?";
	while (@Data = $sth->fetchrow_array)
	{
	  $db_lastrefdate = $Data[0]; 
	}
      }

      $db_lastrefdate = "? ?" if $db_lastrefdate eq "?"; 
      $db_spacealloc = 0 if ! $db_spacealloc ; 
      $db_spaceused  = 0 if ! $db_spaceused  ; 
      $db_spaceused  = "?" if ! $db_spaceused  ; 

      &dataReturn("DB:     $dbname_out $db_spacealloc $db_spaceused $db_lastrefdate $db_owner");

      $dbfilelist = &dbFiles($dbname);

      push @www_dbs,"<td $style_normal><b>$dbname_out</b>
                     <td $style_normal nowrap align=right> &nbsp; $db_spacealloc &nbsp; </td>
                     <td $style_normal nowrap align=right> &nbsp; $db_spaceused &nbsp; </td>
                     <td $style_normal nowrap align=right> &nbsp; $db_tot_datafile_size_mb{$dbname} &nbsp; </td>
                     <td $style_normal nowrap align=right> &nbsp; $db_tot_log_size_mb{$dbname} &nbsp; </td>
                     <td $style_normal nowrap align=right> &nbsp; $tlog_db_ratio{$dbname} &nbsp; </td>
                     <td $style_normal nowrap> &nbsp; $db_created &nbsp; </td>
                     <td $style_normal nowrap> &nbsp; $db_lastrefdate &nbsp; </td>
                     <td $style_normal nowrap> &nbsp; $db_owner &nbsp; </td>
                     <td $style_normal nowrap> &nbsp; $dbfilelist &nbsp; </td>
                     <td $style_normal nowrap> &nbsp; $db_status &nbsp; </td>
      ";

      $tot_spacealloc += $db_spacealloc if $db_spacealloc ne "?";
      $tot_spaceused  += $db_spaceused  if $db_spaceused  ne "?";
    }

    &dataReturn("NUMDBs: $numdbs");
    &dataReturn("SYSPERF: SQL_DB_Count $numdbs"); 
    &dataReturn("SpaceAlloc: $tot_spacealloc");
    &dataReturn("SYSPERF: SQL_Tot_Space_Alloc_MB $tot_spacealloc"); 
    &dataReturn("SpaceUsed: $tot_spaceused");
    &dataReturn("SYSPERF: SQL_Tot_Space_Used_MB $tot_spaceused"); 

    &msg("DB Datafile Counts:"); 
    foreach (sort keys %db_tot_datafile_count)
    {
      &dataReturn("DBDFCount: $_ $db_tot_datafile_count{$_}"); 
    }
  }

  #---- Take 1st sp_monitor sample
  #---- 2011/02/10 BB - We don't need this any more since i now use typeperf
  ## &runSPMonitor;

  #---- Check for single_user DBs
  if ($dbs_single_user_cnt > 0) 
  {
    &dataReturn("DBsSingleUser: $dbs_single_user_cnt $dbs_single_user_names");
  }

  #---- SQL Instance Decide status
  if ($numdbs > 0) 
  {
    $num_up = $numdbs - $numdbsoffline;
    my $zstatus = ""; 
    $zstatus .= "DBStatus: UP \($num_up\)"; 
    if ($offline) { $zstatus .= "; DOWN \($numdbsoffline\)"; }
    &dataReturn($zstatus); 
  }
  else
  {
    &dataReturn("DBStatus: DOWN"); 
  }

  if ($agentrunning) 
  {
    &dataReturn("AgentStatus: UP"); 
    $www_agent_status = "Up";
  }
  else
  {
    &dataReturn("AgentStatus: DOWN"); 
    $www_agent_status = "Down";
  }

  #---- Collect info about local drives
  &driveCheck; 
  &msg("Disk info:");
  foreach $drive (sort keys %disks)
  {
    &msg("  Disk: $drive - Size=$disk_size_gb{$drive} Free=$disk_free_gb{$drive} Used=$disk_used_gb{$drive}  PctF=$disk_pct_full{$drive}"); 
  }

  #---- 2011/04/08 - We only want to run SYSTEMINFO if we did not collect $mem_avail in SysPerf - it takes way too long
  #---- 2011/04/08 -   Note that i don't care about system_hardware_info - it isn't passed back to MASTER 
  if ($mem_avail eq "") 
  {
    #---- Systeminfo START - gather MEM usage info
    if ($osver >= 5.2 && -e "$ENV{'windir'}\\system32\\systeminfo.exe")
    {
      &msg("Running systeminfo to gather memory usage information"); 
      $system_hardware_info = ""; 
      open(SYSINFO, "systeminfo 2>&1 |") || &msg("Error: Running systeminfo - $!");
      while(<SYSINFO>)
      {
	##print;
	@words = split;
	if (/^Available Physical Memory:/)
	{
	  $mem_avail_raw = $words[$#words - 1] . $words[$#words];
	  $mem_avail = $words[$#words - 1] if $words[$#words] eq "MB";
	  $mem_avail =~ s/\,//g;
	} 
	if (/^System Boot Time:/) { $system_boot_time = $words[3] . $words[4] . $words[5]; }
	##if (/^System Manufacturer:/) { $system_hardware_info .= $words[2] . ":"; }
	if (/^System Model:/)     { $system_hardware_info .= "$words[2]_$words[3]_$words[4]_$words[5]";  }
	if (/^System Type:/)      { $system_hardware_info .= "_$words[2]_$words[3]";  }
      }
      close(SYSINFO); 
      
      &msg("DEBUG - mem_avail=$mem_avail mem_avail_raw=$mem_avail_raw ram=$ram mem_used=$mem_used mem_pct=$mem_pct"); 
      if ($mem_avail_raw ne "")
      {
	#TEMP#open(MEM, ">>c:\\temp\\MemAvail.txt") || &msg("Error: Cannot open output file: MemAvail.txt - $!");
	open(MEM, "MemAvail.txt") || &msg("Error: Cannot open output file: MemAvail.txt - $!");
	print MEM "$date $mem_avail_raw\n";
	close(MEM);
      }
    }
    #---- Systeminfo END - gather MEM usage info
  }

  #---- This could have come from SysPerf or from the above SYSTEMINFO
  #print "DEBUG28 - ram=$ram mem_avail=$mem_avail\n"; 
  if ($ram > 0 && $mem_avail ne "")
  {
    $mem_used = $ram - $mem_avail;
    $mem_pct  = sprintf("%.2f",($mem_used / $ram) * 100); 
  }
  print "DEBUG28B - mem_used=$mem_used mem_pct=$mem_pct\n"; 

  #---- Cluster status - START
  $cluster_name = "";
  open(CLUSTERV, "cluster /ver 2>&1 |"); 
  while(<CLUSTERV>)
  {
    ##print;
    #Cluster Name:     LSCASQLC
    @words = split;
    $cluster_name = $words[2] if (/^Cluster Name:/)
  }
  close(CLUSTERV); 
  &msg("cluster /ver Shows cluster_name=$cluster_name"); 
  if ($cluster_name ne "") 
  {
    &msg("Querying cluster status - $cluster_name"); 
    open(CLUSTER, "cluster /cluster:$cluster_name res |") || &error("Error: Running cluster");
    $cluster_status = "";
    while(<CLUSTER>)
    {
      ##print;
      @words = split;
      if (/^SQL Server  /)
      {
        $cluster_status = $words[$#words - 0];
        $cluster_node   = $words[$#words - 1];
        if ($cluster_status ne "Online")
        {
          $cluster_thisnodestatus   = "Offline"; 
        }
        else
        {
	  if ($cluster_node eq uc $host) { $cluster_thisnodestatus   = "Active"; }
	  else                           { $cluster_thisnodestatus   = "Passive"; }
    
        }
        ##&msg("  cs=$cluster_status cn=$cluster_node"); 
        ##print;
      }
    }
    close(CLUSTER); 

    &dataReturn("CLUSTERNAME: $cluster_name"); 
    &dataReturn("CLUSTERSTATUS: $cluster_status"); 
    &dataReturn("CLUSTERONNODE: $cluster_node"); 
    &dataReturn("CLUSTERTHISNODESTATUS: $cluster_thisnodestatus"); 
  }
  #---- Cluster status - END

  #---- SQL Version
  &msg("Querying MSSQL for MSSQL software version");
  $sth->finish()                || &dbError("Finish2");
  $sth = $dbh->do("use master") || &dbError("Use_Master");
  $sql = "select \@\@version; ";
  $sth = $dbh->prepare("$sql")  || &dbError("Prepare");
  $sth->execute                 || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
    $mssql_version_raw  = $Data[0];
    $mssql_version_from_db = (split(/ /,$mssql_version_raw))[6];
    if (length((split(/\./,$mssql_version_from_db)) [2]) == 3)
    {
      $mssql_version_from_db =
             (split(/\./,$mssql_version_from_db)) [0] . '.' .
	     (split(/\./,$mssql_version_from_db)) [1] . '.' .
	     "0" . (split(/\./,$mssql_version_from_db)) [2];
      &msg("DEBUG = Padding right node of version with 0 - mssql_version_from_db=$mssql_version_from_db"); 
    }
  }
  $sth->finish || &dbError("Execute_Finish");
  &msg("DEBUG ver=$ver mssql_version_from_db=$mssql_version_from_db");

  if ($mssql_version_from_db gt $ver && $mssql_version_from_db)
  {
    &msg("Overriding MSSQL version from db since it is higher - mssql_version_from_db=$mssql_version_from_db");
    $ver = $mssql_version_from_db; 
    &dataReturn("SQLVer: $ver") if ! $WWW;
  }

  #---- SQL Startup time
  &msg("Querying MSSQL startup time");
  $sql = "select 
      login_time,
      datediff(hour,login_time, getdate()) as hours_since
    from  
      master..sysprocesses 
    where
      status = 'background' 
    order by spid; ";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
    $mssql_started  = $Data[0];
    $mssql_hours_up = $Data[1];
    last;
  }
  $sth->finish || &dbError("Execute_Finish");
  &msg("mssql_started=$mssql_started mssql_hours_up=$mssql_hours_up");

  $daysup = $mssql_hours_up / 24;
  $daysup = sprintf("%.2f", $daysup);
  &dataReturn("SYSPERF: SQL_Instance_Up_Hours $mssql_hours_up"); 
  &dataReturn("SYSPERF: SQL_Instance_Up_Days $daysup"); 

  $mssql_started_fix = substr($mssql_started,0,19);
  $mssql_started_fix =~ s/\-/\//g;
  $mssql_started_fix =~ s/ /-/g;
  if ($mssql_started_fix =~ /^1900/)
  {
    $mssql_started_fix =~ s/^1900/2002/;
  }

  &msg("mssql_started_fix=$mssql_started_fix");
  $str_c = $mssql_started_fix;
  if ($str_c)
  {
    $str_n = &timeToNum($str_c);
    $endc = $str_c;
    $calc_date = $date;
    $calc_time = time;

    ##&msg("DEBUG - mem_avail=$mem_avail mem_avail_raw=$mem_avail_raw ram=$ram mem_used=$mem_used mem_pct=$mem_pct"); 
    &msg("DEBUG28C - mem_avail=$mem_avail mem_used=$mem_used mem_pct=$mem_pct"); 

    &dataReturn("UPTIME:      $str_c $str_n $calc_date $calc_time");
    &dataReturn("MSSQL64BIT:  1") if $mssql64bit;
    &dataReturn("OS64BIT:     1") if $os64bit;
    &dataReturn("RAM:       $ram")         if $ram > 0;
    &dataReturn("SYSPERF: MemTotal_MB  $ram") if $ram > 0; 
    &dataReturn("MEM_AVAIL: $mem_avail")   if $mem_avail > 0;
    &dataReturn("MEM_USED:  $mem_used")    if $mem_used > 0;
    &dataReturn("MEM_PCT:   $mem_pct")     if $mem_pct > 0;
  }

  #---- Calc CPU BUSY - We did this earlier also
  #---- 2011/11/14 BB - Let's not do this any more - arithmetic exceptions on servers that have been up for a long time
  ##&runSPMonitor; 
  ##msg "$P CPU_BUSY_WITH_SQL: $cpu_busy\n"; 

  if ($WWW)
  {
    $www_bgcolor = "pink";
    $www_bgcolor = "lime" if $numdbs > 0;

    #---- Exceptions
    $www_bgcolor = "pink" if $www_agent_status ne "Up";

    $www_status = "Down";
    $www_status = "Up" if $numdbs > 0;

    $daysup = $hoursup / 24;
    $daysup = sprintf("%.2f", $daysup);

    $mssql64bit_out = "64bit" if $mssql64bit;
    $os64bit_out = "64bit"    if $os64bit;

    &msg("WWW Status Summary:");
    print " <style type='text/css'>
	table.c1 {font-family:consolas; font-size:10pt; }
      </style> 
    <table border=0 bgcolor=wheat class=c1>
    <tr bgcolor=cadetblue>
      <th $style_normal>Item
      <th $style_normal>Status
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>Hostname:
      <td $style_normal><b>$host</b>
    <tr bgcolor=$www_bgcolor>
       <td $style_normal>OS Version:
       <td $style_normal><b>$osver $os64bit_out $osname</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>MSSQL Instance Name:
      <td $style_normal><b>$in_instance</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>MSSQL Status:
      <td $style_normal><b>$www_status</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>MSSQL Service Status:
      <td $style_normal><b>$servicestat</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>MSSQL Agent Status:
      <td $style_normal><b>$www_agent_status</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>MSSQL Start Date:
      <td $style_normal><b>$mssql_started_fix</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>MSSQL Hours Active:
      <td $style_normal><b>$mssql_hours_up</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>Database Count:
      <td $style_normal><b>$numdbs</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>Database Space Alloc.:
      <td $style_normal><b>$tot_spacealloc mB</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>Database Space Used:
      <td $style_normal><b>$tot_spaceused mB</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>MSSQL Version:
      <td $style_normal><b>$ver $mssql64bit_out</b>
    "; 

    if ($cpu || $cpumodel) 
    {
      print "
      <tr bgcolor=$www_bgcolor>
        <td $style_normal>CPU Info:
        <td $style_normal>$cpu $cpumodel</b>
      "; 
    }
   
    print "
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>CPU Count:
      <td $style_normal><b>$numcpus</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>RAM Total:
      <td $style_normal><b>$ram mB</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>RAM Available:
      <td $style_normal><b>$mem_avail mB</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>RAM Used:
      <td $style_normal><b>$mem_used mB</b>
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>RAM % Used:
      <td $style_normal><b>${mem_pct}%</b>
    "; 

    if ($owmr_lr_age_days ne "") 
    {
      print "
      <tr bgcolor=$www_bgcolor>
	<td $style_normal>Server Uptime:
	<td $style_normal><b>$owmi_lr_age_days</b>
      ";
    }

    print "
    <tr bgcolor=$www_bgcolor>
      <td $style_normal>Remote Shell Service:
      <td $style_normal><b>$rsh_service</b>
    "; 

    if ($cluster_name ne "") 
    {
      print 
      "<tr bgcolor=$www_bgcolor>
	<td $style_normal>Cluster Name (If Any):
	<td $style_normal>$cluster_name
      <tr bgcolor=$www_bgcolor>
	<td $style_normal>Cluster Global Status (If Any):
	<td $style_normal>$cluster_status
      <tr bgcolor=$www_bgcolor>
	<td $style_normal>Cluster Active On Node (If Any):
	<td $style_normal>$cluster_node
      <tr bgcolor=$www_bgcolor>
	<td $style_normal>Cluster This-Node Status (If Any):
	<td $style_normal>$cluster_thisnodestatus
      "; 
    }
    
    if ($doubletake_status ne "") 
    {
      print "
	<tr bgcolor=$www_bgcolor>
	  <td $style_normal>DoubleTake Status:
	  <td $style_normal>$doubletake_status
	<tr bgcolor=$www_bgcolor>
	  <td $style_normal>DoubleTake Dir:
	  <td $style_normal>$doubletake_dir
	<tr bgcolor=$www_bgcolor>
	  <td $style_normal>DoubleTake File:
	  <td $style_normal>$doubletake_file
	<tr bgcolor=$www_bgcolor>
	  <td $style_normal>DoubleTake FileAge Mins:
	  <td $style_normal>$doubletake_fileage_mins
	"; 
    }

    print "
    </table><br>
    ";
  
    &msg("Databases:");
    print "<br><table border=0 bgcolor=wheat class=c1>\n";
    print "
    <tr bgcolor=cadetblue>
      <th $style_normal>Database<br>Name
      <th $style_normal>Alloc.<br>(mB)<br>DB+TLog
      <th $style_normal>Used<br>(mB)<br>DB+TLog
      <th $style_normal>Total Size (mB) Of DB File(s) 
      <th $style_normal>Total Size (mB) Of TLog File(s) 
      <th $style_normal>TLog Size to <br>DB Size <br>Ratio
      <th $style_normal>Date<br>Created
      <th $style_normal>Most Recent Object <br>Created Date
      <th $style_normal>Owner
      <th $style_normal>Datafile(s)
      <th $style_normal>Status
    \n";
    foreach (@www_dbs)
    {
      ##print "<tr bgcolor=$www_bgcolor>$_ \n";
      print "<tr bgcolor=white>$_ \n";
    }
    print "<tr bgcolor=cadetblue><td $style_normal><b> $fs Total:
      <td $style_normal align=right><b> $fs $tot_spacealloc
      <td $style_normal align=right><b> $fs $tot_spaceused 
      <td colspan=8> &nbsp;
    </table><br>";
  
    #---- Check TLOGs for all DBs
    #&checkTLog;
    #---- Check all filegroups for all DBs
    #&checkFilegroups;

    #&msg("TEST"); 
    #&bkup;
    ##&msg("Done");
    ##&msg("END_OF_PROBE");
    ##exit 0;
  }
}

#------------------------------------------------------------------------------
sub runSPMonitor
#------------------------------------------------------------------------------
{
  &msg("runSPMonitor - Sampling CPU_BUSY from sp_monitor ");

  $sql = "exec sp_monitor";
  ##&msgl("Running DB=master sql=$sql");
  $sth = $dbh->prepare("$sql") || &error("Prepare");
  $sth->execute || &error("Execute_Select");
  while($href = $sth->fetchrow_hashref or $sth->{odbc_more_results})
  {
    # got what we needed, stop asking
    last if (defined $href->{cpu_busy});
  }
  $cpu_raw  = $href->{cpu_busy};
  $cpu_busy = (split(/\-/,$cpu_raw)) [1];
  $cpu_busy =~ s/\%//;
  &msg("runSPMonitor - Done - cpu_raw=$cpu_raw cpu_busy=$cpu_busy");
  $sth->finish || &error("Execute_FINISH");
}

#------------------------------------------------------------------------------
sub perfSample
#------------------------------------------------------------------------------
{
  $perfmode = $_[0];
  &msg("  perfSample - Starting - perfmode=$perfmode");

  #---- 1 Start. Total transaction count

  &msg("  Collecting TransRate sample"); 
  if ($vershort == 80) 
  {
    $sql = "select cntr_value from master.dbo.sysperfinfo 
      where counter_name = 'Transactions/sec' and instance_name = '_Total' "; 
  }
  else
  {
    $sql = "select cntr_value from master.sys.sysperfinfo 
      where counter_name = 'Transactions/sec' and instance_name = '_Total' "; 
  }

  $sth = $dbh->prepare("$sql") || &error("Prepare");
  $sth->execute || &error("Execute_Select");
  while(@Data = $sth->fetchrow_array)
  {
    $perf_all{"TransRate"} = $Data[0]; 
  }
  $sth->finish || &error("Execute_FINISH");

  #---- 1 End.   Total transaction count

  #---- 1 Start. Blocked sessions 
  $dbh->do("if OBJECT_ID('tempdb..#dbamon_spwho2') > 0 drop table #dbamon_spwho2") || &dbError("Drop_If_L1697");
  
  if ($vershort == 80) 
  {
    $dbh->do("create table #dbamon_spwho2 (
        SPID int not null
      , Status varchar (255) not null
      , Login varchar (255) not null
      , HostName varchar (255) not null
      , BlkBy varchar(10) not null
      , DBName varchar (255) null
      , Command varchar (255) not null
      , CPUTime int not null
      , DiskIO int not null
      , LastBatch varchar (255) not null
      , ProgramName varchar (255) null
      , SPID2 int not null
     )") || &dbError("Drop_If_L1697");
  }
  else
  {
    $dbh->do("create table #dbamon_spwho2 (
        SPID int not null
      , Status varchar (255) not null
      , Login varchar (255) not null
      , HostName varchar (255) not null
      , BlkBy varchar(10) not null
      , DBName varchar (255) null
      , Command varchar (255) not null
      , CPUTime int not null
      , DiskIO int not null
      , LastBatch varchar (255) not null
      , ProgramName varchar (255) null
      , SPID2 int not null
      , requestid int
     )") || &dbError("Drop_If_L1697");
  }
  $dbh->do("insert #dbamon_spwho2 exec sp_who2") || &dbError("Drop_If_L1697");
  
  $sql = "select COUNT(*)
    from #dbamon_spwho2
    where
    SPID > 50 and BlkBy != '  .  '
  "; 
  $sth = $dbh->prepare("$sql") || &error("Prepare");
  $sth->execute || &error("Execute_Select");
  while(@Data = $sth->fetchrow_array)
  {
    $perf_all{"BlockedSessions"} = $Data[0]; 
  }
  $sth->finish || &error("Execute_FINISH");
  
  $dbh->do("if OBJECT_ID('tempdb..#dbamon_spwho2') > 0 drop table #dbamon_spwho2") || &dbError("Drop_If_L1743");
 
  #---- 1 End.   Blocked sessions

  #---- Copy hash to the correct name
  if ($perfmode eq "Before") 
  { 
    %perf_before_all = %perf_all;
  }
  elsif ($perfmode eq "After") 
  {
    %perf_after_all = %perf_all;
  }
  else { &error("perfSample - Impossible perfmode=$perfmode") } 

  &msg("  perfSample - Done");
}

#------------------------------------------------------------------------------
sub SysPerfSample
#------------------------------------------------------------------------------
{
  $sps_counter = $_[0];
  $sps_label   = $_[1];
  &msg("  SysPerfSample - Starting - sps_counter=$sps_counter sps_label=$sps_label"); 
  $sps_file = "dbamon_typeperf_in.txt"; 
  $sps_val = "?"; 

  open(SPSFILE,">$sps_file") || &error("Cannot open output $sps_file - $!"); 
  print SPSFILE "$sps_counter\n"; 
  close(SPSFILE); 

  $sps_cmd = "typeperf.exe -cf $sps_file -sc 1"; 
  ##&msg("  Running sps_cmd=$sps_cmd"); 
  ##open(SPSCMD,"$sps_cmd|") || &error("Cannot run typeperf - $!"); 
  open(SPSCMD,"$sps_cmd|"); 
  while(<SPSCMD>)
  {
    next if /CSV/ || /^The command/ || /^Exiting/ || /^$/ || /^\s$/; 
    print;
    @sps_words = split (/\,/,$_) ; 
    if ($#sps_words == 1 && $sps_words[1] =~ /^\"/) 
    {
      $sps_val = $sps_words[1]; 
      $sps_val =~ s/\n//g;
    }
    last;
  }
  &msg("  Resulting sps_val=$sps_val"); 

  if ($sps_val eq "?") 
  {
    &msg("  Since not value was returned by TYPEPEF, returning prematurely"); 
    return;
  }

  $sps_val =~ s/\"//g; 
  $sps_val = sprintf("%.2f", $sps_val); 

  &msg("  SysPerfSample - Done - Displaying $sps_label $sps_val"); 
  &dataReturn("SYSPERF: $sps_label $sps_val"); 
  $sysperf{$sps_label} = $sps_val; 

  &msg("  SysPerfSample - Done"); 
  return; 
}

#------------------------------------------------------------------------------
sub SysPerf
#------------------------------------------------------------------------------
{
  &msg("SysPerf - Starting");
  $sp_start = time; 

  #---- Sample
  #typeperf "\MSSQL$MSSQL1:Buffer Manager\Buffer cache hit ratio" -sc 1
  
  #---- Each DB seems to have a different way of specifying the first part of the verb 
  #---- So by default we will use "SQLServer:", but we will query sys.dm_os_performance_counters to get the real value
  $counter_prefix = "SQLServer";   #---- Default
  if ($vershort > 80)
  {
    &connectDB if ! $dbh; 
    &msg("Selecting from dm_os_performance_counters to obtain counter_prefix"); 
    $sql = "select top 1 OBJECT_NAME from sys.dm_os_performance_counters";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare1954");
    $sth->execute                || &dbError("Execute_Select1955");
    while (@Data = $sth->fetchrow_array)
    {
      $counter_string = $Data[0];
    }
    $sth->finish || &dbErrorOK("Finish1960");
    $counter_prefix_raw = (split(":",$counter_string)) [0];
    $counter_prefix = $counter_prefix_raw if $counter_prefix_raw;
    &msg("Resulting counter_string=$counter_string counter_prefix_raw=$counter_prefix_raw"); 
  }
  &msg("Using counter_prefix=$counter_prefix"); 

  #---- Now collect the data from the windoze performance counters

  #---- NEW - Collect from parms in CFG file
  &msg("From CFG file: \%cfg_perfcounter"); 
  foreach (sort keys %cfg_perfcounter)
  {
    $counter     = $_; 
    $dbamon_verb = $cfg_perfcounter{$_};

    if ($counter =~ /SQLSERVERPREFIX/) { $counter =~ s/SQLSERVERPREFIX/$counter_prefix/; } 
    
    &msg("  Found: counter=$counter dbamon_verb=$dbamon_verb - Invoking SysPerfSample");
    &SysPerfSample($counter, $dbamon_verb); 
  }

  #---- We have now collected all of the data

  if (1 == 0)
  {
    if (! $WWW) 
    {
      &msg("Resulting hash sysperf:"); 
      foreach $this_key (sort keys %sysperf)
      {
	&msg("  Key=$this_key Value=$sysperf{$this_key}");
      }
    }
  }
 
  if ($sysperf{"MemAvailMBytes"} > 0) 
  {
    $mem_avail = $sysperf{"MemAvailMBytes"} + 0;  
    &msg("Set mem_avail from sysperf hash - mem_avail=$mem_avail"); 
  } 
  
  $sp_elapsed = time - $sp_start; 
  &msg("SysPerf - Done - Elapsed: $sp_elapsed second(s)");
}

#------------------------------------------------------------------------------
sub SysPerfBulk
#------------------------------------------------------------------------------
{
  &msg("SysPerfBulk - Starting - typeperf_sample_dur=$typeperf_sample_dur");
  $spb_stime = time; 

  #---- Each DB seems to have a different way of specifying the first part of the verb 
  #---- So by default we will use "SQLServer:", but we will query sys.dm_os_performance_counters to get the real value
  $counter_prefix = "SQLServer";   #---- Default
  undef %sysperf_bulk;
  undef %perf_counters;
  my $perf_probeout; 
  $debug_perfbulk = 0; 

  if ($vershort > 80)
  {
    &connectDB if ! $dbh; 
    &msg("Selecting from dm_os_performance_counters to obtain counter_prefix"); 
    $sql = "select top 1 OBJECT_NAME from sys.dm_os_performance_counters";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare1954");
    $sth->execute                || &dbError("Execute_Select1955");
    while (@Data = $sth->fetchrow_array)
    {
      $counter_string = $Data[0];
    }
    $sth->finish || &dbErrorOK("Finish1960");
    $counter_prefix_raw = (split(":",$counter_string)) [0];
    $counter_prefix = $counter_prefix_raw if $counter_prefix_raw;
    &msg("Resulting counter_string=$counter_string counter_prefix_raw=$counter_prefix_raw"); 
  }
  &msg("Using counter_prefix=$counter_prefix"); 

  #---- Now collect the data from the windoze performance counters

  #---- NEW - Collect from parms in CFG file - Write all out to $sps_file
  $sps_file_in  = "dbamon_typeperf_in.txt"; 
  open(SPSFILE,">$sps_file_in") || &error("Cannot open output $sps_file_in - $!"); 

  &msg("Writing Perf Counters from CFG file to $sps_file_in"); 
  foreach (sort keys %cfg_perfcounter)
  {
    $counter     = $_; 
    $dbamon_verb = $cfg_perfcounter{$_};

    if ($counter =~ /SQLSERVERPREFIX/) { $counter =~ s/SQLSERVERPREFIX/$counter_prefix/; } 
    
    &msg("  Found: counter=$counter dbamon_verb=$dbamon_verb - Writing to $sps_file_in") if $debug_perfbulk;
    print SPSFILE "$counter\n"; 
    $counter =~ s/^\\//; 
    $perf_counters{$counter} = $dbamon_verb;
  }
  close(SPSFILE); 

  #---- Decide which command to use - typeperf or dbamon_mssql_tpr 
  $typeperf_cmd = "typeperf.exe"; 
  &msg("Verifying that typeperf exists"); 
  open(SPSCMD,"$typeperf_cmd 2>&1 |"); 
  while(<SPSCMD>)
  {
    if (/is not recognized as an internal or external command/i || -e "Override_TPE.txt")
    {
      $typeperf_cmd = "dbamon_mssql_tpe.exe";
      &msg("  typeperf NG - Will use typeperf_cmd=$typeperf_cmd");
      last;
    } 
  }
  close(SPSCMD); 
  &msg("We will be using typeperf_cmd=$typeperf_cmd"); 

  #---- Run typeperf and collect the results
  $sps_first_line = 0; 

  #---- Old
  ##$sps_cmd = "$typeperf_cmd -cf $sps_file_in -sc 1 -si $typeperf_sample_dur"; 
  #---- New
  $sps_cmd = "$typeperf_cmd -cf $sps_file_in -sc 1"; 

  ##&msg("Running $typeperf_sample_dur second sample of performance counters - sps_cmd=$sps_cmd"); 
  &msg("Running sample of performance counters - sps_cmd=$sps_cmd"); 

  open(SPSCMD,"$sps_cmd 2>&1 |"); 
  while(<SPSCMD>)
  {
    next if /^\s$/; 
    next if /^Warning:/; 
    print;
    
    @sps_words = split (/\,/,$_) ; 
    if (! $sps_first_line && /CSV /) 
    {
      $icnt = 0; 
      foreach $this_word (@sps_words)
      {
        $this_word =~ s/\n//g; 
        $this_counter = $this_word; 
        $this_counter =~ s/\\\\$host_uc\\//; 
        $this_counter =~ s/\"//g; 
        $icnt++; 
        $typeperf_keys{$icnt} = $this_counter; 
        &msg("  DEBUG - COUNTER - icnt=$icnt this_word=$this_word this_counter=$this_counter") if $debug_perfbulk; 
      }
      $sps_first_line = 1; 
      $field_cnt_line_1 = $icnt;
      next; 
    }
    else   #---- There should just be 2 non-null lines
    {
      $icnt = 0; 
      foreach $this_word (@sps_words)
      {
        next if $this_word =~ /CSV /; 

        $this_word =~ s/\n//g; 
        $this_word =~ s/\"//g; 
        #------------------------------------------------------------------------
        # 2.27 - 2012/04/07 BB: Strange problem found by City of COS. They had
        #   some servers where missing perf counters (not found on that server)
        #   had OK FIELD NAMES but every missing counter showed a -1 in the value
        #   line. So, this line of code will skip over all values that are -1 in 
        #   such a way that we don't increment $icnt, which should make the number
        #   of values equal to the number of column names in the previous line. 
        #   Strange!!!
        # 
        next if $this_word == -1;     #--- Skip bad values and get back in sync
        #------------------------------------------------------------------------
        $icnt++; 
        $this_key         = $typeperf_keys{$icnt}; 
        $this_dbamon_verb = $perf_counters{$this_key}; 
        &msg("  DEBUG - VAL - icnt=$icnt this_word=$this_word this_key=$this_key this_dbamon_verb=$this_dbamon_verb") if $debug_perfbulk; 
        next if ! $this_dbamon_verb; 

        #---- Processing for counters with many decimal places
        if ($this_dbamon_verb =~ /MULT1000$/)
        {
          $this_dbamon_verb =~ s/MULT1000//; 
          $this_word = $this_word * 1000; 
        }
     
        $perf_probeout .= "$P SYSPERF: $this_dbamon_verb $this_word\n"; 
        $sysperf_bulk{$this_dbamon_verb} = $this_word; 
        $sysperf_bulk{$this_dbamon_verb} = sprintf("%.2f", $sysperf_bulk{$this_dbamon_verb}); 
      }
      $field_cnt_line_2 = $icnt;
      last; 
    }
  }
  close(SPSCMD);

  #---- We have now collected all of the data - Compare field counts
  $field_cnt_line_1 += 0;
  $field_cnt_line_2 += 0;
  &msg("field_cnt_line_1=$field_cnt_line_1"); 
  &msg("field_cnt_line_2=$field_cnt_line_2"); 

  if ($field_cnt_line_1 == $field_cnt_line_2) 
  {
    &msg("Field counts are equal - Good!"); 
  }
  else
  {
    ##&msg("PHONEHOME: SysPerfBulk_Unequal_Field_Counts_LINE1=${field_cnt_line_1}_LINE2=${field_cnt_line_2}"); 
    &dataReturn("SYSPERF: BadCounterValues 1"); 
    return; 
  }

  my $sp_count_nonzero = 0; 

  if (! $WWW) 
  {
    &msg("Resulting hash sysperf_bulk:"); 
    foreach $this_key (sort keys %sysperf_bulk)
    {
      &msg("  Key=$this_key Value=$sysperf_bulk{$this_key}");
      $sp_count_nonzero++ if $sysperf_bulk{$this_key} > 0;   
    }
  }

  &msg("SysPerfBulk - Count of non-zero values: $sp_count_nonzero"); 
  &msg("PHONEHOME: SysPerfBulk - Count_of_non-zero_values=${sp_count_nonzero}_(too_few)") if $sp_count_nonzero < 1 && $osname ne "Win2000"; 

  #---- Write out the counters that we collected
  if ($perf_probeout) 
  { 
    &msg("PERF Probeout:\n$perf_probeout") unless $WWW; 
  }
 
  if ($sysperf_bulk{"MemAvailMBytes"} > 0) 
  {
    $mem_avail = $sysperf_bulk{"MemAvailMBytes"} + 0;  
    &msg("Set mem_avail from sysperf_bulk hash - mem_avail=$mem_avail"); 
  } 
  
  $spb_elapsed = time - $spb_stime; 
  &msg("SysPerfBulk - Done - Elapsed: $spb_elapsed second(s)");
}

#------------------------------------------------------------------------------
sub SysPerfSpecial
#------------------------------------------------------------------------------
{
  &msg("SysPerfSpecial - Starting");

  #---- #1 - Blocked processes GROSS
  $sql = "select count(*) from master..sysprocesses (nolock) where blocked != 0"; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L2556");
  $sth->execute || &dbErrorOK("Execute_L2557");
  while (@Data = $sth->fetchrow_array)
  {
    &dataReturn("SYSPERF: SQL_BlockedProcsGross $Data[0]"); 
  }
  
  #---- #2 - Blocked processes BLOCKED BY SOMEONE ELSE
  $sql = "select count(*) from master..sysprocesses (nolock) where blocked != 0 and blocked != spid"; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L2565");
  $sth->execute || &dbErrorOK("Execute_L2566");
  while (@Data = $sth->fetchrow_array)
  {
    &dataReturn("SYSPERF: SQL_BlockedProcsOtherProc $Data[0]"); 
  }

  #---- #3 - Check for Lock Pages In Memory WORKING (2008 and higher only) 
  if ($vershort >= 100)
  {
    $sql = "select locked_page_allocations_kb from master.sys.dm_os_process_memory"; 
    $sth = $dbh->prepare($sql) || &dbError("Prepare_L2613");
    $sth->execute || &dbErrorOK("Execute_L2614");
    while (@Data = $sth->fetchrow_array)
    {
      &dataReturn("SYSPERF: SQL_LPIM_Locked_KB $Data[0]"); 
    }
  }

  #---- #4 - RUNNABLE Requests
  if ($vershort >= 90)
  {
    $sql = "select count(*) from master.sys.dm_exec_requests where status = 'runnable'"; 
    $sth = $dbh->prepare($sql) || &dbError("Prepare_L2624");
    $sth->execute || &dbErrorOK("Execute_L2624");
    while (@Data = $sth->fetchrow_array)
    {
      &dataReturn("SYSPERF: SQL_Runnable_Reqs $Data[0]"); 
    }
  }

  #---- #4A - RUNNABLE Tasks (different)
  if ($vershort >= 90)
  {
    $sql = "SELECT SUM(runnable_tasks_count) AS sum_runnable_tasks FROM sys.dm_os_schedulers WHERE scheduler_id < 255"; 
    $sth = $dbh->prepare($sql) || &dbError("Prepare_L2624");
    $sth->execute || &dbErrorOK("Execute_L2624");
    while (@Data = $sth->fetchrow_array)
    {
      &dataReturn("SYSPERF: SQL_Runnable_Tasks $Data[0]"); 
    }
  }
  #---- #5A - TOP WAITs for SQL 2005+
  if ($vershort >= 90)
  {
    $sql = "
      WITH    Waits
          AS ( SELECT TOP 5
                        wait_type ,
                        wait_time_ms / 1000. AS wait_time_s ,
                        100. * wait_time_ms / SUM(wait_time_ms) OVER ( ) AS pct ,
                        ROW_NUMBER() OVER ( ORDER BY wait_time_ms DESC ) AS rn
               FROM     sys.dm_os_wait_stats WITH (NOLOCK)
               WHERE    wait_type NOT IN 
               $idle_waits
               AND wait_type NOT LIKE 'BACKUP%'
             )
    SELECT  W1.wait_type ,
            CAST(W1.wait_time_s AS DECIMAL(12, 2)) AS wait_time_s ,
            CAST(W1.pct AS DECIMAL(12, 2)) AS pct ,
            CAST(SUM(W2.pct) AS DECIMAL(12, 2)) AS running_pct
    FROM    Waits AS W1
            INNER JOIN Waits AS W2 ON W2.rn <= W1.rn
    GROUP BY W1.rn ,
            W1.wait_type ,
            W1.wait_time_s ,
            W1.pct
    "; 
    $sth = $dbh->prepare($sql) || &dbError("Prepare_L2808");
    $sth->execute || &dbErrorOK("Execute_L2809");
    $perf_rank = 0; 
    while (@Data = $sth->fetchrow_array)
    {
      $perf_rank++; 
      &dataReturn("SYSPERF: SQL_Top_Waits_Rank$perf_rank $Data[0] $perf_rank $Data[2]"); 
    }
  }

  #---- #5B - TOP WAITs for SQL 2000
  ## Testing -- if ($vershort > 90)
  if ($vershort < 90)
  {
    &SysPerf2000Waits;
  }

  #---- #6 - Week Old SQL Session
  if ($vershort >= 90)
  {
    $sql = "
SELECT  COUNT(*) AS WeekOldSesCount
FROM    master..sysprocesses
WHERE   spid > 50
        AND DB_NAME(dbid) != 'msdb'
        AND loginame NOT LIKE '%ntservice%'
        AND program_name NOT LIKE '%jobstep%'
		AND DATEDIFF(dd, login_time, GETDATE()) >= 7
    "; 
    $sth = $dbh->prepare($sql) || &dbError("Prepare_L2967");
    $sth->execute || &dbErrorOK("Execute_L2968");
    while (@Data = $sth->fetchrow_array)
    {
      &dataReturn("SYSPERF: SQL_Sessions_Week_Old $Data[0]"); 
    }
  }

  #---- #7 - Login=SA Connections
  if ($vershort >= 90)
  {
    $sql = "
SELECT  COUNT(*) AS SAConnections 
FROM    master..sysprocesses
WHERE   spid > 50
        AND loginame = 'SA' 
    "; 
    $sth = $dbh->prepare($sql) || &dbError("Prepare_L2967");
    $sth->execute || &dbErrorOK("Execute_L2968");
    $zcnt = 0;   #---- 3.19
    while (@Data = $sth->fetchrow_array)
    {
      $zcnt = $Data[0]; 
    }
    &dataReturn("SYSPERF: SQL_Sessions_SA $zcnt");   #---- 3.19
  }

  #---- Return
  &msg("SysPerfSpecial - Done");
}

#------------------------------------------------------------------------------
sub SysPerf2000Waits
#------------------------------------------------------------------------------
{
  &msg("SysPerf2000Waits - Starting");

  # /*
  # From: http://www.sql-server-pro.com/get-wait-stats.html
  # */
  #  
  # set nocount on;
  # create table #wt (types varchar(30))
  #  
  # -- Add any wait types you want to ignore here. 'Total' MUST be ignored.
  # insert into #wt values('Total')
  # insert into #wt values('LAZYWRITER_SLEEP')
  # insert into #wt values('SLEEP')
  # insert into #wt values('OLEDB')
  # insert into #wt values('RESOURCE_QUEUE')
  # insert into #wt values('WAITFOR')
  #  
  # create table #ws (wait_type varchar(255),
  #	      requests decimal(20, 0),
  #	      wait_time_ms decimal(20, 0),
  #	      signal_wait_time decimal(20, 0))
  #    
  #   insert #ws exec ('dbcc sqlperf(waitstats) with no_infomsgs')
  #      
  #   select top 5 wait_type,
  #   cast(wait_time_ms / 1000. as decimal(12, 2)) wait_time_s,
  #   cast(100. * wait_time_ms /
  #	   (select sum(wait_time_ms)
  #	    from #ws
  #	    where wait_type not in
  #		    (select types from #wt)) as decimal(12, 2)) pct,
  #   case when requests > 0
  #	then cast((wait_time_ms - signal_wait_time) / requests as int)
  #	else 0 end avg_wait_ms
  #   from #ws
  #   where wait_type not in (select types from #wt)
  #               by 3 desc
  #    
  #   drop table #ws
  #   drop table #wt

  my $not_in_list = "'Total', 'LAZYWRITER_SLEEP', 'SLEEP', 'OLEDB', 'RESOURCE_QUEUE', 'WAITFOR'"; 

  $dbh->do("create table #dbamon_ws (
    wait_type        varchar(255),
    requests         decimal(20, 0),
    wait_time_ms     decimal(20, 0),
    signal_wait_time decimal(20, 0)
    )") || &dbError("CT_2870");

  ## $dbh->do("insert #dbamon_ws exec ('dbcc sqlperf(waitstats) with no_infomsgs'") || &dbError("INS_2874"); 
  ## $sql = "exec ('DBCC SQLPERF (LOGSPACE)')";

  $dbh->do("use master") || &dbError("USE_2876"); 
  $dbh->do("INSERT #dbamon_ws EXEC ('DBCC SQLPERF (WAITSTATS)')") || &dbError("INS_2874"); 

  $sql = "select top 5 
    wait_type,
    cast(wait_time_ms / 1000. as decimal(12, 2)) wait_time_s,
    cast(100. * wait_time_ms /
      (select sum(wait_time_ms)
         from #dbamon_ws
         where wait_type not in ($not_in_list) 
      ) as decimal(12, 2)) pct,
    case 
      when requests > 0 then cast((wait_time_ms - signal_wait_time) / requests as int)
      else 0 
    end avg_wait_ms
  from #dbamon_ws
  where 
    wait_type not in ($not_in_list)
  order by 
    3 desc
  ";
  $sth = $dbh->prepare("$sql") || &dbError("PRE_2894");
  $sth->execute || &dbError("EXE_2895");

  my $perf_rank = 0; 

  while (@Data = $sth->fetchrow_array)
  {
    $perf_rank++; 
    &dataReturn("SYSPERF: SQL_Top_Waits_Rank$perf_rank $Data[0] $perf_rank $Data[2]"); 
  }

  $dbh->do("drop table #dbamon_ws") || &dbError("DRP_2876"); 

  &msg("SysPerf2000Waits - Done");
}

#------------------------------------------------------------------------------
sub SysPerfCompare
#------------------------------------------------------------------------------
{
  &msg("SysPerfCompare - Starting");
  my $zstring = ""; 
  my $zatleastone = 0; 

  &msg("Resulting hash sysperf:"); 
  foreach $this_key (sort keys %sysperf)
  {
    $zstring = sprintf("%-40s %12.2f", $this_key, $sysperf{$this_key});  
    &msg("  $zstring");
  }

  &msg("Resulting hash sysperf_bulk:"); 
  foreach $this_key (sort keys %sysperf_bulk)
  {
    $zstring = sprintf("%-40s %12.2f", $this_key, $sysperf_bulk{$this_key});  
    &msg("  $zstring");
    $zatleastone = 1 if $sysperf_bulk{$this_key} > 0;  
  }

  &msg("Timing:"); 
  &msg("  Elapsed BULK:  $spb_elapsed"); 
  &msg("  Elapsed Other: $sp_elapsed"); 

  &msg("Key Count:"); 
  my $count = keys %sysperf_bulk;
  my $countb = keys %sysperf;
  &msg("  KeyCount BULK:  $countb"); 
  &msg("  KeyCount Other: $count"); 

  if ($count == $countb && $zatleastone)
  {
    &msg("Everything looks GOOD - Equal key counts and at least 1 Bulk value - Copying sysperf_bulk to sysperf");   
    $sysperf = $sysperf_bulk; 
  }  
  elsif  ($count >= 3 && $countb >= 3)
  {
    &msg("Everything looks GOOD - Bulk and Other each have >= 3 keys - Copying sysperf_bulk to sysperf");   
    $sysperf = $sysperf_bulk; 
  }  
  elsif ($count == 0 && $countb == 0)
  {
    &msg("Everything looks GOOD - ?? both Bulk and Other each have 0 keys (I guess this is OK?)  - Copying sysperf_bulk to sysperf");   
    $sysperf = $sysperf_bulk; 
  }  
  else
  {
    &msg("PHONEHOME: Something_wrong-Sysperf_element_count_!=_SysperfBULK"); 
  }

  &msg("SysPerfCompare - Done");
}

#------------------------------------------------------------------------------
sub SQLPerf
#------------------------------------------------------------------------------
{
  $perf_before_time = time; 
  $perf_interval = 5; 

  &msg("SQLPerf - Starting - perf_before_time=$perf_before_time");

  #---- Call perfSample BEFORE
  &perfSample("Before"); 
 
  #---- Sleep before taking 2nd snapshot
  &msg("  Sleeping perf_interval=$perf_interval"); 
  sleep $perf_interval; 

  #---- Call perfSample AFTER
  $perf_after_time = time; 
  &perfSample("After"); 

  #---- Calculations
  $perf_el_time = $perf_after_time - $perf_before_time;
  &msg("  SQLPerf - Calculating Deltas - perf_before_time=$perf_before_time perf_after_time=$perf_after_time perf_el_time=$perf_el_time");

  foreach $p_metric (sort keys %perf_after_all)
  {
    $p_before_val = $perf_before_all{$p_metric};
    $p_after_val  = $perf_after_all{$p_metric};
    $p_delta_val  = $p_after_val - $p_before_val; 
    $p_per_second = -1;  #---- In case of zero divide - Unlikely
    $p_per_second = sprintf("%.2f", ($p_delta_val / $perf_el_time)) if $perf_el_time > 0;

    if ($p_metric =~ /rate/i) 
    {
      &msg("  Metric=$p_metric p_before_val=$p_before_val p_after_val=$p_after_val p_delta_val=$p_delta_val p_per_second=$p_per_second");  
      &dataReturn("PERF: $p_metric $p_per_second"); 
    }
    else
    {
      &msg("  Metric=$p_metric p_before_val=$p_before_val p_after_val=$p_after_val");  
      if ($p_before_val > $p_after_val) { $p_final_val = $p_before_val; } 
      else                              { $p_final_val = $p_after_val; } 
      &dataReturn("PERF: $p_metric $p_final_val"); 
    }
  }

  #$perf_total_trans = $perf_after_transcount - $perf_before_transcount; 
  #$perf_total_transrate = sprintf("%.2f", ($perf_total_trans / $perf_el_time)) if $perf_el_time > 0;

  #&msg("SQLPerf - BEFORE - perf_before_time=$perf_before_time - perf_before_transcount=$perf_before_transcount");
  #&msg("SQLPerf - AFTER  - perf_el_time=$perf_el_time - perf_after_transcount=$perf_after_transcount");

  &msg("SQLPerf - Done");
}

# ----------------------------------------------------------------------
sub bkrun
# ----------------------------------------------------------------------
{
  $db     = $arg1;
  $method = $arg2;
  $cmd    = $arg3;

  &msg("bkrun - Running backup for DB=$db Method=$method");
  &msg("bkrun: Command before {DB}, {SQLPATH}, {PERLPATH} and backslash substitution: $cmd");

  # 24Jan04 - Now PERLPATH contains the path to the executable
  #  If they specified perl.exe in the CMD, that is wrong. 
  if ($cmd =~ /perl.exe/ && $cmd =~ /PERLPATH/)
  {
    &msg("NOTE: PERLPATH is wrong - It specifies perl.exe - modifying"); 
    $cmd =~ s/\/perl.exe//g;
    &msg("Modified Command after substitution: $cmd");
    $modified = 1;
  }

  $cmd =~ s/\{DB\}/\"$db\"/g;
  $cmd =~ s'\[BLANK\]' 'g;
  $cmd =~ s'\[HYPHEN\]'-'g;

  $cmd =~ s/\{SQLPATH\}/$SQLPATH/g;
  $cmd =~ s/\{PERLPATH\}/$PERLPATH/g;

  $cmd =~ s/\//\\/g;
  &msg("bkrun: Command after substitution: $cmd");

  #DEBUG START
  system("$PERLPATH C:\\dbatools\\socketmail.pl dbaadmin\@dba.it.thecompany.com dbaadmin\@dba.it.thecompany.com \"dbamon_mssql.pl Modified_CMD   PERLPATH=$PERLPATH host=$host modified=$modified cmd=$cmd [AUTO]\" $dbname/$backup_type") if $modified;

  system("$PERLPATH C:\\dbatools\\socketmail.pl dbaadmin\@dba.it.thecompany.com dbaadmin\@dba.it.thecompany.com \"dbamon_mssql.pl PERLPATH_Not_E PERLPATH=$PERLPATH host=$host modified=$modified cmd=$cmd [AUTO]\" $dbname/$backup_type") if ! -e $PERLPATH;
  #DEBUG END 

  if ($method eq "B") { $syscmd = "start/b \"MSSQL $db Backup\" $cmd"; }
  else                { $syscmd = "$cmd"; }

  &msg("$bkrun: About to issue: $syscmd");
  $s_time = time;
  $rc = system($syscmd);
  $e_time = time;
  $el_time = $e_time - $s_time;
  &msg("bkrun: Back from issuing: $syscmd - rc=$rc el_time=$el_time");

  $rc /= 256 if $rc != 0;
  if ($rc != 0)
  {
    &msg("ERROR: Invoked Backup_Command: ended with non-zero rc=$rc");
  }
}

# ----------------------------------------------------------------------
sub bkhi
# ----------------------------------------------------------------------
{
  $dbname = $arg1; 

  $dbname =~ s/\[HYPHEN\]/\-/g;
  $dbname =~ s/\[BLANK\]/\ /g;
  
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify MSSQL availability.
  &connectDB;
  
  $dbh->do("use msdb")         || &dbError("Use_MSDB");

  if (!$dberror)
  {
    # Create a report of all backups for this DB
    ##if ($ver =~ "6.5")
    if ($vershort < 70)
    { 
      # Check backup age for this db
      $sql = "
       select
	  substring(database_name,1,16) as db,
	  backup_type,
	  backup_finish,
	  datediff(hour,backup_finish, getdate()) as hours_since
       from
	  sysbackuphistory 
       where
	  backup_type = 1 
	  and database_name = '$dbname'
	  and datediff(day, backup_finish, getdate()) <= 50
       order by
	  3 desc";
    }
    else
    {
      # Check backup age for this db
      $sql = "
	 select
	    substring(database_name,1,16) as db,
	    type,
	    backup_finish_date,
	    datediff(hour, backup_finish_date, getdate()) as hours_since
	 from
	    backupset
	 where
	    database_name = '$dbname'
	    --and datediff(day, backup_finish_date, getdate()) <= 50
	 order by
	    3 desc";
    }

    &msg("Running query of MSDB for Backup History Report for database $dbname");
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");

    print "\n<table border=1 bgcolor=skyblue class=c1>
    <tr bgcolor=slate> 
      <th><font size=2>Backup<br>Type
      <th><font size=2>Timestamp
      <th><font size=2>Age<br>(Hours)
    \n";
    $count = 0;
    while (@Data = $sth->fetchrow_array)
    {
      ++$count;
      $db      = $Data[0];
      $bcktype = $Data[1];
      if ($bcktype eq "1") { $bcktype = "D" }; 
      $bckts   = $Data[2];
      $bckage  = $Data[3];

      if    ($bcktype eq "D") { $bt_out = "Database"; }
      elsif ($bcktype eq "I") { $bt_out = "Database Differential"; }
      elsif ($bcktype eq "L") { $bt_out = "Log"; }
      elsif ($bcktype eq "F") { $bt_out = "File"; }
      else                        { $bt_out = "?"; }

      $bt = "($bcktype)$bt_out";

      printf "<tr>
        <td><font size=2>%-4s </font>
        <td><font size=2>%-24s </font>
        <td align=right><font size=2>%-6s</font>
      \n",
      $bt,
      $bckts,
      $bckage
      ;
      $backup_count++;
    }
    print "</table>\n";
    print "\n<b>Total Backups: $backup_count</b>\n\n"; 
  }
}

# ----------------------------------------------------------------------
sub bkup
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("bkup - Starting"); 
  # use strict;
  use DBI;

  #---- If this is an AO cluster, only take backups readings under certain conditions
  if ($ao_readings{'HADR_Backup_Pref'} eq "secondary" && $ao_readings{'HADR_Role'} ne "SECONDARY") 
  {
    &msg("Since this IS and AO Cluster with Backup_Pref=secondary -and- This is NOT the secondary node, skipping backup checking"); 
    return;
  }

  #---- 3.26 - 2016/03/20 - If this is an AO cluster and this node is ASYNC COMMIT, then we won't care about backup age checking 
  if ($ao_readings{'HADR_Availability_Mode'} =~ /^ASYNC/i) 
  {
    &msg("Since this is an AO Cluster and this node is in ASYNC* commit mode, skipping backup checking"); 
    return;
  }

  #---- Default backup method
  $backup_method = "UN";    #---- Default type of unknown

  if ($company eq "thecompany") 
  {
    if (-e "\\temp\\ALL.txt")
    {
      $all_log = "\\temp\\ALL.txt";
    }
    else
    {
      $all_log = "$SQLPATH\\dba_bkup_log\\ALL.txt";
    }

    &msg("Trying to determine backup method from $all_log"); 

    if (-e $all_log && ! -r $all_log)
    {
      system("$PERLPATH C:\\dbatools\\socketmail.pl dbaadmin\@dba.it.thecompany.com dbaadmin\@dba.it.thecompanthecompany.com \"dbamon_mssql.pl ALL Log Not Readable - all_log=$all_log [AUTO]\" $dbname/$backup_type") if $modified;
    }

    open(ALL_LOG, "$all_log") || print "$P | Cannot open $all_log - $!\n";
    $lines_read = 0;
    while (<ALL_LOG>)
    {
      $lines_read++;
      if (/Backup_Method:/)
      {
	@words  = split(' ',$_); 
	$backup_method = $words[$#words];
      }
    }
    close(ALL_LOG);
    &msg("Read $lines_read lines from $all_log - backup_method=$backup_method"); 
  }
  
  &msg("Attempting to determine backup type"); 
  #---- Check for CommVault (CV) backup method and SYMANTEC backup method
  #---    If file exists and has been updated within the last 4 days, then this DB is using CV
  $cv_log_file = "c:\\program files\\commvault\\simpana\\log files\\sqlida.log";
  $c2_log_file = "D:\\program files\\commvault\\simpana\\log files\\sqlida.log";
  $sy_log_dir  = "C:\\Program Files\\Symantec\\Backup Exec\\RAWS\\Data";
  $s2_log_file = "C:\\Program Files\\Symantec\\Backup Exec\\Logs\\dbrecover.log";
  &msg("Looking for these files:"); 
  &msg("  $cv_log_file"); 
  &msg("  $c2_log_file"); 
  &msg("  $sy_log_dir"); 
  &msg("  $s2_log_file"); 

  if ($wmi_services{"SQLBackupAgent"} == 1) 
  {
    $backup_method = "RG";
    &msg("Found RedGate SQL Backup Agent running - backup_method=$backup_method");
  }
  elsif (-e "$cv_log_file")
  {
    $cv_file_mtime    = ( stat $cv_log_file )[9];
    $cv_file_age_days = (time - $cv_file_mtime) / 86400;
    if ($cv_file_age_days <= 30) { $backup_method = "CV"; }
    &msg("Found File - cv_file_mtime=$cv_file_mtime cv_file_age_days=$cv_file_age_days backup_method=$backup_method");
  }
  elsif (-e "$c2_log_file")
  {
    $c2_file_mtime    = ( stat $c2_log_file )[9];
    $c2_file_age_days = (time - $c2_file_mtime) / 86400;
    if ($c2_file_age_days <= 30) { $backup_method = "CV"; }
    &msg("Found File - c2_file_mtime=$c2_file_mtime c2_file_age_days=$c2_file_age_days backup_method=$backup_method");
  }
  elsif (-e "$sy_log_dir")
  {
    $sy_dir_mtime    = ( stat $sy_log_dir )[9];
    $sy_dir_age_days = (time - $sy_dir_mtime) / 86400;
    if ($sy_dir_age_days <= 14) { $backup_method = "SY"; }
    &msg("Found File - sy_dir_mtime=$sy_dir_mtime sy_dir_age_days=$sy_dir_age_days backup_method=$backup_method");
  }
  elsif (-e "$s2_log_file")
  {
    $s2_file_mtime    = ( stat $s2_log_file )[9];
    $s2_file_age_days = (time - $s2_file_mtime) / 86400;
    if ($s2_file_age_days <= 14) { $backup_method = "SY"; }
    &msg("Found File - s2_file_mtime=$s2_file_mtime s2_file_age_days=$s2_file_age_days backup_method=$backup_method");
  }

  &msg("Results - backup_method=$backup_method");

  #---- Attempt to connect to the master database on the server, to verify MSSQL availability.
  &connectDB;

  if (!$dberror)
  {
    &msg("Checking for database master");

    $sth = $dbh->do("use master") || &dbError("Use_Master");

    #---- Read DBNames from master
    &msg("Reading DB name from sysdatabases");
    $sql = "select name from sysdatabases order by 1; ";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");

    undef @dblist; 

    while (@Data = $sth->fetchrow_array)
    {
      $dbname = $Data[0];
      push(@dblist,$dbname);
      ++$numdbs;
    }

    #---- Process DB names
    foreach $dbname (@dblist)
    {
      &msg("Processing dbname=$dbname");
      $dbname_out  = $dbname;
      $dbname_out  =~ s/\s/[BLANK]/g;
      $dbname_out  =~ s/\-/[HYPHEN]/g;

      $dbname_out2 = $dbname_out; 
      $dbname_out2 = substr($dbname_out2,0,40) . "..." if length($dbname_out2) > 40; 

      if ($vershort < 70)
      { 
        $sql = " select
	      substring(database_name,1,16) as db,
	      max(backup_finish) as maxdate,
	      datediff(hour, max(backup_finish), getdate()) as hours_since
	   from
              sysbackuphistory 
	   where
	      backup_type =1
	      and database_name = '$dbname'
	   group by
	      database_name
           order by database_name, 3 desc";
      }
      else
      {
        $sql = " select
	      substring(database_name,1,16) as db,
	      max(backup_finish_date) as maxdate,
	      datediff(hour, max(backup_finish_date), getdate()) as hours_since
	   from
              backupset
	   where
	      type in ('D','I')
	      and database_name = '$dbname'
	   group by
	      database_name 
           order by 1, 3 desc";
      }

      $dbh->do("use msdb")         || &dbError("Use_MSDB2");
      $sth = $dbh->prepare("$sql") || &dbError("Prepare");
      $sth->execute                || &dbError("Execute_Select");
      $bckfound = 0;

      while (@Data = $sth->fetchrow_array)
      {
        $bckfound = 1;
	$db      = $Data[0];
	$bckts   = $Data[1];
	$bckage  = $Data[2];

        #---- Get rid of spaces
        ##$bckts =~ s/\s/_/g;

        print "BckAge: $dbname_out $bckage $bckts $backup_method \n";
      }

      if (!$bckfound)
      {
	$db      = $dbname;
        print "BckAge: $dbname_out -999999\n";
      }

      #---- Create backup report
      $sql = "select
        substring(database_name,1,16) as db,
        type,
        max(backup_finish_date) as maxdate,
        datediff(hour, max(backup_finish_date), getdate()) as hours_since
      from
        backupset
      where
	database_name = '$dbname'
      group by
        database_name,
        type
      order by 
        1, 2";
      $dbh->do("use msdb")         || &dbError("Use_MSDB2");
      $sth = $dbh->prepare("$sql") || &dbError("Prepare");
      $sth->execute                || &dbError("Execute_Select");
      $bckfound = 0;

      print "BckDet: <tr bgcolor=cadetblue><td colspan=9>$fs &nbsp; <b> Database: $dbname_out </b>\n";

      while (@Data = $sth->fetchrow_array)
      {
	$db             = $Data[0];
	$bck_type       = $Data[1];
	$bck_maxts_raw  = $Data[2];
	$bck_agehr      = $Data[3];
    
        #---- 2007-11-15 11:46:23.000
        $bck_maxts = substr($bck_maxts_raw,0,10);
        $bck_maxts =~ s/\-/\//g; 
        $bck_maxts .= "-" . substr($bck_maxts_raw,11,8);
        $bck_agedy = sprintf("%.2f", ($bck_agehr / 24));

        if    ($bck_type eq "D") { $bck_type_out = "(D) Database Full"; }
        elsif ($bck_type eq "I") { $bck_type_out = "(I) Database Differential"; }
        elsif ($bck_type eq "L") 
        { 
          $bck_type_out = "(L) Transaction Log"; 
          print "BckAgeTLOG: $dbname_out $bck_agehr $bck_maxts_raw $backup_method\n"; 
        }
        else                     { $bck_type_out = $bck_type; }

        ##print "BckDetTEST: $dbname_out bck_type=($bck_type) bck_maxts=($bck_maxts) bck_agehr=($bck_agehr)\n";
        print "BckDet: <tr bgcolor=cornsilk><td>$fs <b> $dbname_out2 </b> <td>$fs $bck_type_out<td>$fs $bck_maxts<td align=right>$fs $bck_agehr<td align=right>$fs $bck_agedy\n";
      }
    }
  }

  #---- If BKTYPE is still UN, then try to figure out what's goin' on! 
  ##if ($backup_method eq "UN") 
  ##{
  ##}
  #---- Get backup type from backup data dictionary view
  &backupType;

  &msg("bkup - Done"); 
}

# ----------------------------------------------------------------------
sub backupType
# ----------------------------------------------------------------------
{
  &msg("backupType - Starting - ALTERNATE Backup Type logic"); 

  #---- If    BACKUP_DEVICE is C: format, then SQL native backups
  #---- ElsIf BACKUP_DEVICE is \\ format, then SQL native backups
  #---- ElsIf NAME is NULL and UC user_name like '%TSERV%' then SYMANTEC backup 
  #---- OLD: if ($vershort <= 80) 

  my $extra_column = ""; 
  my $alt_backup_method = "";  

  if ($vershort >= 90)  { $extra_column = ", is_snapshot"; }

  $sql = "SELECT
    ba.backup_start_date,
    ba.database_name,
    ba.type,
    bm.physical_device_name AS backup_device,
    ba.name,
    ba.user_name,
    ba.description,
    ba.backup_size $extra_column
  FROM [msdb].[dbo].[backupset] ba,
       [msdb].[dbo].[backupmediafamily] bm
  where
    ba.media_set_id = bm.media_set_id
    and ba.backup_start_date > dateadd(dd,-10,getdate())
    AND ba.type = 'D'
  order by 
    1
  "; 

  &msg("  baDEBUG - sql=$sql"); 

  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute                || &dbError("Execute_Select");

  $bt_type_sql      = 0;
  $bt_type_symantec = 0; 
  $bt_type_cv       = 0; 
  $bt_type_vss      = 0; 

  while (@Data = $sth->fetchrow_array)
  {
    $bt_timestamp   = shift @Data;
    $bt_dbname      = shift @Data;
    $bt_type        = shift @Data;
    $bt_bck_device  = shift @Data;
    $bt_name        = shift @Data;
    $bt_user        = shift @Data;
    $bt_desc        = shift @Data;
    $bt_size        = shift @Data;
    $bt_snapshot    = shift @Data;

    if    (substr($bt_bck_device,1,1) eq ":")          { $bt_type_sql = 1; } 
    elsif ($bt_bck_device =~ /\/\// )                  { $bt_type_sql = 1; } 
    elsif ($bt_name =~ /commvault/i )                  { $bt_type_cv = 1; } 
    elsif ($bt_snapshot eq "1" )                       { $bt_type_vss = 1; } 
    elsif ($bt_name eq "" && uc($bt_user) =~ /TSERV/)  { $bt_type_symantec = 1; } 
    elsif ($bt_name =~ /backup exec/i)                 { $bt_type_symantec = 1; } 
    else  { } 
  }

  if    ($bt_type_vss)      { $alt_backup_method = "VSS"; }
  elsif ($bt_type_cv)       { $alt_backup_method = "CV"; }
  elsif ($bt_type_symantec) { $alt_backup_method = "SY"; }
  elsif ($bt_type_sql)      { $alt_backup_method = "SQL"; }
  else  { } 

  #---- Old
  #print "$P Backup_Method: $alt_backup_method\n" if $alt_backup_method; 
  #---- New - If the method is RG, then don't bother with alt_backup_method
  if ($backup_method eq "RG") 
  {
    print "$P Backup_Method: $backup_method\n"; 
  }
  else
  {
    print "$P Backup_Method: $alt_backup_method\n" if $alt_backup_method; 
  }

  &msg("backupType - Done"); 
}

# ----------------------------------------------------------------------
sub backupJobs
# ----------------------------------------------------------------------
{
  &msg("Querying backup jobs ");
 
  if (! defined $dbh)
  {
    ##$dbh = DBI->connect("DBI:ODBC:$driver",'guest','' ) || &dbError("Connect_To_DB");
    &connectDB;
  }

  if ($sth)
  {
    $sth->finish();
  }

  $sth = $dbh->do("use msdb") || &dbError("Use_Master");

  $sql = "select 
      j.name, 
      s.command,
      j.enabled
    from  
      sysjobs j,
      sysjobsteps s
    where 
      j.job_id = s.job_id 
     
    ;";

  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute                || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
    $jobname    = $Data[0];
    $jobcmd     = $Data[1];
    $jobenabled = $Data[2];

    ##&msg("DEBUG jobname=$jobname jobenabled=$jobenabled");

    $jobcmd  =~ s/'/QUOTE/g;
    
    $jobcmd  = substr($jobcmd,0,200) if length($jobcmd) > 200;
    $jobname = substr($jobname,0,75) if length($jobname) > 75;

    if    ($jobcmd  =~ /call_backup/)         { $jobtype = "BackupVeritas"; }
    elsif ($jobcmd  =~ /call_disk_backup.pl/) { $jobtype = "BackupDisk"; }
    elsif ($jobcmd  =~ /OBII_backup/)         { $jobtype = "BackupOB"; }
    elsif ($jobname =~ /^billtest/)           { $jobtype = "BBTEST"; }
    else                                      { $jobtype = "Other"; }

    &dataReturn("BACKUPJOB: \$jobname='$jobname'\; \$jobcmd='$jobcmd'\; \$jobtype='$jobtype'\; ");

    $rundisable = $arg1;  # Set by Run_Surgery: DBC parameter

    if ($rundisable)
    {
      if ($jobtype =~ /^Backup/ && $jobenabled)
      {
        push(@sqltorun,"exec sp_update_job \@job_name='$jobname',\@enabled=0");
      }
    }
  }

  $jobsupdated = 0;
  
  &msg("Looking for jobs to update");

  if ($sqltorun[0])
  {
    foreach $sql (@sqltorun)
    { 
      &msg("Running sp_update_job - sql=$sql");
      $dbh->do("use msdb")          || &dbError("Use_MSDB");
      ##$sth2->finish()             || &dbError("Finish");
      $sth2 = $dbh->prepare("$sql") || &dbError("Prepare");
      $sth2->execute                || &dbError("Execute_Disable");
    }
  }

  &msg("Done processing jobs");
}

# ----------------------------------------------------------------------
sub oldPerl
# ----------------------------------------------------------------------
{
  &msg("oldPerl - Starting - Looking for residual Perl processes"); 

  $pslist_loc = "C:\\dbatools\\pslist.exe";
  $oldperl_t  = 24;    #---- 1.27
  $oldperl_cnt = 0;
 
  if (! -e $pslist_loc)
  {
    &msg("pslist is not found at $pslist_loc - Skipping");
    return;
  }

  &msg("Looking for old Perl procesess that have been running for at least $oldperl_t hours under userid=$userid - pslist_loc=$pslist_loc");

  $cmd = "$pslist_loc > NUL 2>&1";
  &msg("Testing $pslist_loc to make sure that it works on this server - cmd=$cmd");
  if (system("$cmd") != 0)
  {
    &msg("pslist Error encountered - Skipping");
    return;
  }

  open(CMD, "$pslist_loc |") || &error("Cannot invoke $pslist_loc - $!");
  while (<CMD>)
  {
    @words  = split;
    $pname  = $words[0];
    $pid    = $words[1];
    $utime  = $words[6];
    $ktime  = $words[7];
    $etime  = $words[8];

    $hours = (split(":",$etime)) [0];

    next if $pname !~ /Perl/;
    next if $hours < $oldperl_t;

    # Get username
    open(CMD2, "pulist  |") || print "$P | Cannot invoke $pslist_loc - $!\n";;
    while (<CMD2>)
    {
      @words  = split;
      $pgm2   = $words[0];
      $pid2   = $words[1];
      $usr2   = $words[2];

      ##print "pgm2=$pgm2 pid2=$pid2 usr2=$usr2\n"; 
 
      next if $pid2 ne $pid;

      $user   = $words[2];
    }
    close(CMD2);

    next if index($user,$userid) == -1;

    print "$P OLDPERL: pid=$pid pname=$pname etime=$etime hours=$hours user=$user utime=$utime ktime=$ktime\n";
    $oldperl_cnt++;
  }
  close(CMD);

  &msg("oldPerl - Done - Found $oldperl_cnt old perl processes"); 
}

# ----------------------------------------------------------------------
sub checkDoubleTake
# ----------------------------------------------------------------------
{
  &msg("checkDoubleTake - Starting - Checking DoubleTake (registry)"); 

  #---- See if it is installed
  %values="";
  $Register = "Software\\NSI Software\\Double-Take\\CurrentVersion";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey); 
  ##&msg("  hkey=$hkey"); 
  if ($hkey eq "")
  {
    &msg("  DoubleTake is NOT installed"); 
    return;
  }
  $hkey->GetValues(\%values) || &msg("  Cannot find DoubleTake in registry");
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $doubletake_version = $RegValue if $RegKey eq "VersionInfo";
  }
  $hkey->Close();
  if ($doubletake_version eq "")
  {
    &msg("  DoubleTake is NOT installed"); 
    return;
  }
  &msg("  DoubleTake version $doubletake_version is installed"); 

  #---- Get MSSQL base dir
  %values="";
  $Register = "Software\\Microsoft\\MSSQLServer\\MSSQLServer\\Parameters";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey); 
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType       = $values{$value}->[1];
    $RegValue      = $values{$value}->[2];
    $RegKey        = $values{$value}->[0];
    $mssql_basedir = substr($RegValue,2) if $RegKey eq "SQLArg0";
  }
  $hkey->Close();

  $zraw = $mssql_basedir;
  $zlookfor = "\\"; 
  $zidx = rindex($zraw,$zlookfor); 
  $doubletake_dir = substr($zraw,0,$zidx);

  &msg("  mssql_basedir=$mssql_basedir doubletake_dir=$doubletake_dir"); 

  $doubletake_fileage_mins = 999999; 
  $doubletake_file = "$doubletake_dir\\DBAmon_Timestamp.txt"; 
  if (-e $doubletake_file) 
  {
    open(TS, "$doubletake_file") || print "$P | Cannot open input $doubletake_file - $!\n";;
    while (<TS>)
    {
      @words = split;
      $tsnum = $words[0];
    }
    $doubletake_fileage_mins = int((time - $tsnum) / 60); 
  }

  #---- See if doubletake is running
  $doubletake_status = "?";
  open(NET, 'net start|') || print "Error: Running net start";
  while(<NET>)
  {
    ##print;
    if (/Double-Take/)            { $doubletake_status="[Running]"; }
  }
  close(NET);

  &dataReturn("DoubleTakeStatus:      $doubletake_status");
  &dataReturn("DoubleTakeDir:         $doubletake_dir");
  &dataReturn("DoubleTakeFile:        $doubletake_file");
  &dataReturn("DoubleTakeFileAgeMins: $doubletake_fileage_mins");

  &msg("checkDoubleTake - Done"); 
}

# ----------------------------------------------------------------------
sub connectDBOld
# ----------------------------------------------------------------------
{
  &msg("connectDB() Connecting to ODBC driver=$driver as 'guest'"); 
  $dbh = DBI->connect("DBI:ODBC:$driver",'guest','' ) || &dbError("Connect_To_DB");

  #if ($host eq "wbbndba1")
  #{
  #  &msg("  Setting isolation level: SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED"); 
  #  $dbh->do("SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED") || &dbError("SET ISO LEVEL");
  #}
  &msg("  Setting isolation level: SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED"); 
  $dbh->do("SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED") || &dbError("SET ISO LEVEL");
}

# ----------------------------------------------------------------------
sub connectDB
# ----------------------------------------------------------------------
{
  &msg("connectDB() Connecting to ODBC without driver (dynamic)"); 

  if ($default_instance) 
  {
    if (-e "dbamon_mssql_Parm_ConnectToHostname.txt")
    {
      $DSN = "driver={SQL Server};Server=$host;uid=;pwd=;"; 
    }
    else
    {
      $DSN = "driver={SQL Server};Server=localhost;uid=;pwd=;"; 
    }
  }
  else
  {
    #---- OLD: if ($vershort <= 80) 
    ## if ($vershort <= 80 || -e "dbamon_mssql_Parm_ConnectToHostname.txt")
    #---- Some servers don't have a localhost DNS entry - this touch file is for that
    if (-e "dbamon_mssql_Parm_ConnectToHostname.txt")
    {
      $DSN = "driver={SQL Server};Server=$host\\$in_instance;uid=;pwd=;"; 
    }
    else
    {
      $DSN = "driver={SQL Server};Server=localhost\\$in_instance;uid=;pwd=;"; 
    }
  }

  if ($dbh ne "") 
  {
    &msg("Already connected to DB - dbh is not null"); 
    return;
  }

  &msg("  connecting DSN=$DSN") ;
  $dbh = DBI->connect("dbi:ODBC:$DSN", 
  { PrintError => 1,
    RaiseError => 0 } ) || &error("DBConnect");

  #---- Set long read len
  $dbh->{LongReadLen} = 16000;
  $dbh->{LongTruncOk} = 1;

  $iso_level = "SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED"; 
  &msg("  Setting isolation level: $iso_level"); 
  $dbh->do($iso_level) || &error("SET ISO LEVEL");
  &msg("connectDB() Done"); 

  $dbh->do("use tempdb") || &error("SET ISO LEVEL");
  ##$sql = " IF OBJECT_ID (N'tempdb.dbo.dateconvert_19', N'FN') IS NOT NULL DROP FUNCTION dbo.dateconvert_19; ";
  $sql = " IF OBJECT_ID (N'dbo.dateconvert_19', N'FN') IS NOT NULL DROP FUNCTION dbo.dateconvert_19; ";
  ##&msg("Running SQL=$sql");
  $sth = $dbh->do($sql) || &error("DROP_F1");

  $dbh->do("use tempdb") || &error("SET ISO LEVEL");
  #  -- 2005+ only?: WITH EXECUTE AS CALLER
  ##$sql = "CREATE FUNCTION dbo.dateconvert_19 (\@DATE datetime2)
  $sql = "CREATE FUNCTION dbo.dateconvert_19 (\@DATE datetime)
    RETURNS varchar(19)
    AS
    BEGIN
	 DECLARE \@RESULT varchar(19);
	 SET \@RESULT = CONVERT(varchar(10), \@DATE, 111) +
		  '-' + CONVERT(varchar(8),  \@DATE, 108);
	 RETURN(\@RESULT);
    END
  ";
  ##&msg("Running SQL=$sql");
  $sth = $dbh->do($sql) || &error("Create_F1");

  $connected_to_db = 1; 

  &connectVars;

  &msg("connectDB - Done"); 
}

# ----------------------------------------------------------------------
sub newVars
# ----------------------------------------------------------------------
{
  &msg("newVars - Starting"); 

  #---- Copy newly coded vars to the OLD NAME
  $ver      = $sql_version; 
  $vershort = $sql_vershort; 
  $PERLPATH = $new_PERLPATH; 
  $SQLPATH  = $sql_sqlpath; 
  $osver    = $sql_osver; 

  #---- 2013/06/08 New way using TieRegistry 
  if (! $osver   && $owmi_osver) { $osver   = $owmi_osver; }
  if (! $sqlpath && $rr_sqlpath) { $SQLPATH = $rr_sqlpath; }

  #---- Return values
  &dataReturn("OSVer:    $osver $osname");
  &dataReturn("PERLPATH: $PERLPATH");

  &msg("newVars - Done - \nver=$ver \nvershort=$vershort \nPERLPATH=$PERLPATH \nSQLPATH=$SQLPATH \nosver=$osver") unless $WWW; 
}

# ----------------------------------------------------------------------
sub checkVars
# ----------------------------------------------------------------------
{
  &msg("checkVars - Starting"); 

  my $var_errors = ""; 

  if ($SQLPATH eq "")  { $var_errors .= "SQLPATH is NULL,";  }
  if ($PERLPATH eq "") { $var_errors .= "PERLPATH is NULL,";  }
  if ($ver eq "")      { $var_errors .= "ver is NULL,";  }
  if ($vershort eq "") { $var_errors .= "vershort is NULL,";  }
  #if ($osver eq "")    { $var_errors .= "osver is NULL,";  }

  if ($var_errors) 
  {
    chop $var_errors; 
    &error("Null Required Variables: $var_errors"); 
  }

  &msg("checkVars - Done"); 
}

# ----------------------------------------------------------------------
sub connectVars
# ----------------------------------------------------------------------
{
  &msg("connectVars - Starting"); 

  $cv_debug = 0; 

  #---- Query SQL EDITION now, since it will be needed for other checks
  &msg("  Querying SQL for patchlevel and edition") if $cv_debug; 
  $dbh->do("use master")                || &dbError("Use_Master");
  $sth = $dbh->prepare("
    SELECT SERVERPROPERTY('productversion'), 
    SERVERPROPERTY ('productlevel'), 
    SERVERPROPERTY ('edition')
  ") || &dbError("Prepare_SQLVER_L3034");
  $sth->execute                         || &dbError("Execute_Select");
  $sql_version = $sql_patchlevel = $sql_edition = "?"; 
  while (@Data = $sth->fetchrow_array)
  {
    $sql_version      = $Data[0]; 
    $sql_patchlevel   = $Data[1]; 
    $sql_edition      = $Data[2]; 
  }
  $sth->finish() || &dbError("Could not execute FINISH");

  #---- Edit VERSHORT
  $sql_vershort = (split(/\./,$sql_version)) [0] . '.' .
                  (split(/\./,$sql_version)) [1]; 
  $sql_vershort =~ s/\.//;

  #---- VERSHORT could be in the format 800, 900 or 1000, etc.. edit that to be 80, 90, 100, 105
  if    ($sql_version =~ /^8.0/)      { $sql_vershort = 80; }
  elsif ($sql_version =~ /^9.0/)      { $sql_vershort = 90; }
  elsif ($sql_version =~ /^10.0/)     { $sql_vershort = 100; }
  elsif ($sql_version =~ /^10.5/)     { $sql_vershort = 105; }
  elsif ($sql_version =~ /^11.0/)     { $sql_vershort = 110; }
  elsif ($sql_version =~ /^12.0/)     { $sql_vershort = 120; }
  elsif ($sql_version =~ /^13.0/)     { $sql_vershort = 130; }    #---- MSSQL 2016
  else    { &error("DBAmon does not have support for sql_version=$sql_version"); } 

  #---- REGREAD Call
  ##if ($use_mssqlregread && $owmi_version eq "") 
  if (! $use_wmiosver)
  {
    #---- OSVER
    &msg("MSSQL_REGREAD - osver"); 
    $sth = $dbh->prepare("
    exec master.dbo.xp_instance_regread
	N'HKEY_LOCAL_MACHINE',
	N'Software\\Microsoft\\Windows NT\\CurrentVersion',
	N'CurrentVersion'
    ") || &dbError("Prepare_SQLVER_L3691");
    $sth->execute || &dbError("Execute_Select");
    $sql_osver = "?"; 
    while (@Data = $sth->fetchrow_array)
    {
      $sql_osver    = $Data[1]; 
    }

    #---- sql_ospatch
    &msg("MSSQL_REGREAD - ospatch"); 
    $sth = $dbh->prepare("
    exec master.dbo.xp_instance_regread
	N'HKEY_LOCAL_MACHINE',
	N'Software\\Microsoft\\Windows NT\\CurrentVersion',
	N'CSDVersion'
    ") || &dbError("Prepare_SQLVER_L3691");
    $sth->execute || &dbError("Execute_Select");
    $sql_ospatch = "?"; 
    while (@Data = $sth->fetchrow_array)
    {
      $sql_ospatch    = $Data[1]; 
    }
    $sql_ospatch =~ s/Service Pack /SP/g;

    #---- Edit OSVER
    $sql_osver .= ",$sql_ospatch" if $sql_ospatch ne "?" and $sql_ospatch ne ""; 
  }

  if ($use_mssqlregread && $rr_sqlpath eq "") 
  {
    #---- SQLPATH
    &msg("MSSQL_REGREAD - sqlpath"); 
    $sth = $dbh->prepare("
    exec master.dbo.xp_instance_regread
	N'HKEY_LOCAL_MACHINE',
	N'Software\\Microsoft\\MSSQLServer\\Setup',
	N'SQLPath'
    ") || &dbError("Prepare_SQLVER_L3706");
    $sth->execute || &dbError("Execute_Select");
    $sql_sqlpath = "?"; 
    while (@Data = $sth->fetchrow_array)
    {
      $sql_sqlpath    = $Data[1]; 
    }
  }

  #---- SWKEY -- MAY NOT EXIST! -- We don't call this any more 2013/06
  #  $query_swkey = 0; 
  #  if ($query_swkey == 1) 
  #  {
  #    $sth = $dbh->prepare("
  #  exec master.dbo.xp_instance_regread
  #	N'HKEY_LOCAL_MACHINE',
  #	N'Software\\Microsoft\\Microsoft SQL Server\\$sql_vershort\\Registration',
  #	N'CD_KEY'
  #    ") || &dbError("Prepare_SQLVER_L3743");
  #    $sth->execute || &dbError("Execute_Select_L3811");
  #    $sql_swkey = "?"; 
  #    while (@Data = $sth->fetchrow_array)
  #    {
  #      $sql_swkey    = $Data[1]; 
  #    }
  #    print "MSSQLSWKEY: $mssql_regkey\n" if $sql_swkey && $sql_swkey ne "?";
  #  }

  if ($use_mssqlregread && $rr_svcacct eq "") 
  {
    #---- Service Account
    &msg("MSSQL_REGREAD - svcacct"); 
    $sth = $dbh->prepare("exec master.dbo.xp_instance_regread
	N'HKEY_LOCAL_MACHINE',
	N'SYSTEM\\CurrentControlSet\\Services\\MSSQLSERVER',
	N'ObjectName'
    ") || &dbError("Prepare_SAN_L3965");
    $sth->execute || &dbError("EXE_3966");
    $sql_service_account = "?"; 
    while (@Data = $sth->fetchrow_array)
    {
      $sql_service_account    = uc $Data[1]; 
    }
    &dataReturn("MSSQLServiceAccount:  $sql_service_account"); 
  }

  &msg("  Results - \nsql_version=($sql_version)\nsql_vershort=($sql_vershort)\nsql_patchlevel=($sql_patchlevel)\nsql_edition=($sql_edition)\nsql_osver=($sql_osver)\nsql_ospatch=($sql_ospatch)\nsql_sqlpath=($sql_sqlpath)\nsql_swkey=($sql_swkey)") if ! $WWW; 

  &msg("connectVars - Done"); 
}

# ----------------------------------------------------------------------
sub test
# ----------------------------------------------------------------------
{
  &msg("test()"); 

  &msg("Setting isolation level: SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED"); 
  $dbh->do("SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED") || &dbError("Use_Master_1");


  $dbname = "master";

	&msg("Running exec sp_spaceused for dbname='$dbname'"); 
	$sth = $dbh->prepare("exec sp_spaceused") || &dbError("Prepare");
	$dberror = 0;
	$sth->execute || &dbErrorOK("Connecting to db=$dbname");
	if ($dberror)
	{
	  ++$numdbsoffline;
	  print "DB:     $dbname_out CONNECTERROR \n";
	  next;
	}
	while (@Data = $sth->fetchrow_array)
	{
	  ##print "Data0=$Data[0]\n";   # Test
	  ##@words = split ' ', $Data[0];
	  ##$verb = $words[0];
	  ##if ($verb eq $dbname)
	  if (uc $Data[0] eq uc $dbname)
	  {
	    $db_spacealloc = $Data[1];
	    chop $db_spacealloc ; chop $db_spacealloc ;chop $db_spacealloc ;
	    $db_spacefree  = $Data[2];
	    chop $db_spacefree ; chop $db_spacefree ;chop $db_spacefree ;
	    $db_spaceused  = $db_spacealloc - $db_spacefree;
	  }
	}

  &msg("db_spaceused=$db_spaceused"); 
}

# ----------------------------------------------------------------------
sub reqFileRead 
# ----------------------------------------------------------------------
{
  #---- REQ Path, etc.
  $reqfile_path = "dbamon_mssql_req.pl";
  $reqfile_debug = 1; 

  &msg("reqFileRead - Starting - Reading reqfile_path=$reqfile_path dcf_debug=$dcf_debug"); 

  if (-e "$reqfile_path") 
  {
    &msg("Locating PERL and Syntax checking $reqfile_path"); 
    if (system("perl -v") == 0 && system("perl -wc $reqfile_path 2>&1") != 0)
    {
      &msg("PHONEHOME: Require file $reqfile_path Perl compile error - Not requiring"); 
    }
    elsif (-z $dcf_path)
    {
      &msg("PHONEHOME: Require file $reqfile_path Is zero bytes - Not requiring"); 
    }
    else
    {
      require "$reqfile_path"; 
    }
  }
  else
  {
    &msg("PHONEHOME: ReqFile $reqfile_path missing - REQFILEMISSING"); 
  }
  &msg("reqFileRead - Done"); 
}

# ----------------------------------------------------------------------
sub DCFRead 
# ----------------------------------------------------------------------
{
  #---- DCF (DBAmon control file) path
  $dcf_path = "dbamon_mssql_dcf_${in_instance}.txt";
  $dcf_debug = 1; 

  &msg("DCFRead - Starting - Reading dcf_path=$dcf_path dcf_debug=$dcf_debug"); 

  if (-e "$dcf_path") 
  {
    #---- Only require the file if it passes a perl syntax check
    ## if (system("perl -wc $dcf_path 2>&1") != 0)
    #---- 2012/07/30 BB - We only want to run this compile check IF we have the path to get to PERL (not always true - UKS2) 
    &msg("Locating PERL and Syntax checking $dcf_path"); 
    if (system("perl -v") == 0 && system("perl -wc $dcf_path 2>&1") != 0)
    {
      &msg("Require file $dcf_path Perl compile error - Not requiring"); 
      # system("echp ' ' | mailx -s 'DBAmon | $host/$os $dcf_path Compile Error' dbaadmin\@dba.it.mycompany.com") if $company eq "mycompany";
    }
    elsif (-z $dcf_path)
    {
      &msg("Require file $dcf_path Is zero bytes - Not requiring"); 
    }
    else
    {
      require "$dcf_path"; 
    }
  }
  else
  {
    &msg("Controlfile file $dcf_path missing - DCFFILEMISSING"); 
    # system("echo ' ' | mailx -s 'DBAmon | $host/$os - DCF $dcf_path Missing' dbaadmin\@dba.it.mycompany.com") if $company eq "mycompany";
  }

  #---- TEMP DEBUG: show variable values
  if ($dcf_debug) 
  {
    &msg("DEBUG - DCF Values read:"); 
    foreach $dcf_key (sort keys %dcf_data)
    {
      &msg("  dcf_data{$dcf_key}=$dcf_data{$dcf_key}"); 
    }
  }

  if ($dcf_data{"LastCycleFinishNum"} > 0)
  {
    $zmins_since = sprintf("%.2f", (time - $dcf_data{"LastCycleFinishNum"}) / 60);
    &msg("DCFRead - Done - Minutes since completion of last iteration: $zmins_since"); 
  }
}

#------------------------------------------------------------------------------
sub timeToText
#------------------------------------------------------------------------------
{
  my $zz_ts = $_[0];
  my ($sec,$min,$hour,$mday,$mon,$year) = localtime($zz_ts);
  $year += 1900;
  $mon += 1;

  # Pad with 0's
  my $yy = sprintf("%04d",$year);
  my $mm = sprintf("%02d",$mon);
  my $dd = sprintf("%02d",$mday);
  my $hh = sprintf("%02d",$hour);
  my $mi = sprintf("%02d",$min);
  my $ss = sprintf("%02d",$sec);

  my $date = "$yy/$mm/$dd-$hh:$mi:$ss";
  return $date;
}

# ----------------------------------------------------------------------
sub DCFWrite 
# ----------------------------------------------------------------------
{
  &msg("DCFWrite - Starting - Writing dcf_path=$dcf_path"); 
  $dcf_debug = 1; 

  #---- Cycle finish variable
  my $z = time; 
  $dcf_data{"LastCycleFinishNum"}  = $z; 
  $dcf_data{"LastCycleFinishChar"} = &timeToText($z); 

  #---- Write out values
  foreach $dcf_key (sort keys %dcf_data)
  {
    $dcf_out .= "\$dcf_data{$dcf_key} = '$dcf_data{$dcf_key}';\n";
    $dcf_count++; 
  }
  ##&msg("DEBUG - dcf_count=$dcf_count dcf_out=$dcf_out"); 

  open(DCF, ">$dcf_path") || &msg("Cannot open output $dcf_path - $!");
  print DCF $dcf_out; 
  close(DCF);

  system("type $dcf_path") if $dcf_debug;

  &msg("DCFWrite - Done - Wrote $dcf_count controlfile entries"); 
}

# ----------------------------------------------------------------------
sub init
# ----------------------------------------------------------------------
{
  &msg("init - Starting"); 

  $stime = time;

  $verb = $ARGV[0];
  $arg1 = $ARGV[1];
  $arg2 = $ARGV[2];
  $arg3 = $ARGV[3];
  $arg4 = $ARGV[4];

  $WWW = 1 if $arg1 eq "WWW";

  #---- Misc vars.
  $connected_to_db = 0; 

  ($pshort = $P) =~ s/.pl$//; 
  $plog =  "${pshort}_PgmLog.txt"; 
  open(PLOG,">$plog") || &error("Cannot open output plog=$plog - $!"); 
  &msg("  Starting PLOG"); 

  $userid = Win32::LoginName();
  $osname = Win32::GetOSName();
  $domain = Win32::DomainName();

  chop($host=`hostname`); 
  $host_uc = uc $host; 
  $fs = "<font size=2>"; 

  #---- Process specified MSSQL instance name 
  $in_instance = $ENV{"MSSQL_INSTANCE"}; 
  $in_instance =~ s/ //g;
  if (! $in_instance)
  {
    &msg("Instance not specified - Using default MSSQLSERVER instance name"); 
    $in_instance = "MSSQLSERVER"; 
    $default_instance = 1;
  }
  else
  {
    $default_instance = 0;
  }

  #---- Old
  #if (system("srvinfo -ns >NUL 2>NUL") == 0) { $srvinfo_cmd = "srvinfo -ns"; }
  #elsif ($ENV{'NTRESKIT'}) { $srvinfo_cmd = "$ENV{'NTRESKIT'}\\srvinfo -ns"; }
  #elsif (-e "dbamon_mssql_di.exe") { $srvinfo_cmd = "dbamon_mssql_di.exe -ns"; }
  #else
  #{
  #  &msg("Hmmmm... Could not find srvinfo in default path and NTRESKIT not in env");
  #}
  ##---- We will just hard code this now Sep. 2013
  $srvinfo_cmd = "dbamon_mssql_di.exe -ns"; 

  $system_root = $ENV{"SYSTEMROOT"};
  $root_fs = substr($system_root,0,2);

  $driver = "DBAmonMSSQL";

  #---- Read dbamon_mssql.cfg file
  &readCfg;

  #---- Read MSSQL11.MSSQL2 REG KEY for this instance 
  &regInit;

  #---- Old PERHPATH logic
  ##if    (-e "c:\\strawberry\\perl\\bin\\perl.exe")  { $new_PERLPATH = "c:\\strawberry\\perl\\bin\\perl.exe"; } 
  ##elsif (-e "c:\\perl\\bin\\perl.exe")              { $new_PERLPATH = "c:\\perl\\bin\\perl.exe"; } 
  ##elsif (-e "c:\\perl64\\bin\\perl.exe")            { $new_PERLPATH = "c:\\perl64\\bin\\perl.exe"; } 
  ##else                                              { $new_PERLPATH = "?"; } 
  #---- New PERHPATH logic
  $new_PERLPATH = $^X; 

  #---- Determine SHIFT
  $z1 = &get_date("Y/M/D-H:M:S");
  $now_hhmm = substr($z1,11,5); 
  ($zsec, $zmin, $zhr, $zday, $zmonth, $zyear, $now_weekday, $zdayofyr, $zjunk_yuk) = localtime(time);

  
  if ($now_hhmm ge "08:00" && $now_hhmm le "17:00" && $now_weekday != 0 && $now_weekday != 6)  
  { 
    $target_shift = "P";    #---- Prime shift
  } 
  elsif ($now_weekday == 0 || $now_weekday == 6)  
  { 
    $target_shift = "W";    #---- Weekend shift
  } 
  else                                               
  {
    $target_shift = "N";    #---- Night Weekday shift
  } 
  &msg("Shift calculations - now_hhmm=$now_hhmm now_weekday=$now_weekday target_shift=$target_shift"); 
  &dataReturn("TargetShift: $target_shift"); 
  
  #---- Display results
  &msg("  host=$host osname=$osname userid=$userid instance=($in_instance) domain=$domain pshort=$pshort");
  &msg("  Results - \nhost=($host)\nverb=($verb)\narg1=($arg1)\narg2=($arg2)\narg3=($arg3)\narg4=($arg4)\ndriver=($driver)\nnew_PERLPATH={$new_PERLPATH)\nrr_regkey=$rr_regkey\nrr_regpre=$rr_regpre") if ! $WWW;
  &dataReturn("WindowsDomain: $domain"); 

  #---- 3.27 - I want just one list of idle_waits
  #---- 3.27 - Updated the idle waits from SQLSkills: http://www.sqlskills.com/blogs/paul/wait-statistics-or-please-tell-me-where-it-hurts/
  $idle_waits = "(
        N'BROKER_EVENTHANDLER',             N'BROKER_RECEIVE_WAITFOR',
        N'BROKER_TASK_STOP',                N'BROKER_TO_FLUSH',
        N'BROKER_TRANSMITTER',              N'CHECKPOINT_QUEUE',
        N'CHKPT',                           N'CLR_AUTO_EVENT',
        N'CLR_MANUAL_EVENT',                N'CLR_SEMAPHORE',
        N'DBMIRROR_DBM_EVENT',              N'DBMIRROR_EVENTS_QUEUE',
        N'DBMIRROR_WORKER_QUEUE',           N'DBMIRRORING_CMD',
        N'DIRTY_PAGE_POLL',                 N'DISPATCHER_QUEUE_SEMAPHORE',
        N'EXECSYNC',                        N'FSAGENT',
        N'FT_IFTS_SCHEDULER_IDLE_WAIT',     N'FT_IFTSHC_MUTEX',
        N'HADR_CLUSAPI_CALL',               N'HADR_FILESTREAM_IOMGR_IOCOMPLETION',
        N'HADR_LOGCAPTURE_WAIT',            N'HADR_NOTIFICATION_DEQUEUE',
        N'HADR_TIMER_TASK',                 N'HADR_WORK_QUEUE',
        N'KSOURCE_WAKEUP',                  N'LAZYWRITER_SLEEP',
        N'LOGMGR_QUEUE',                    N'ONDEMAND_TASK_QUEUE',
        N'PWAIT_ALL_COMPONENTS_INITIALIZED',
        N'QDS_PERSIST_TASK_MAIN_LOOP_SLEEP',
        N'QDS_SHUTDOWN_QUEUE',
        N'QDS_CLEANUP_STALE_QUERIES_TASK_MAIN_LOOP_SLEEP',
        N'REQUEST_FOR_DEADLOCK_SEARCH',     N'RESOURCE_QUEUE',
        N'SERVER_IDLE_CHECK',               N'SLEEP_BPOOL_FLUSH',
        N'SLEEP_DBSTARTUP',                 N'SLEEP_DCOMSTARTUP',
        N'SLEEP_MASTERDBREADY',             N'SLEEP_MASTERMDREADY',
        N'SLEEP_MASTERUPGRADED',            N'SLEEP_MSDBSTARTUP',
        N'SLEEP_SYSTEMTASK',                N'SLEEP_TASK',
        N'SLEEP_TEMPDBSTARTUP',             N'SNI_HTTP_ACCEPT',
        N'SP_SERVER_DIAGNOSTICS_SLEEP',     N'SQLTRACE_BUFFER_FLUSH',
        N'SQLTRACE_INCREMENTAL_FLUSH_SLEEP',
        N'SQLTRACE_WAIT_ENTRIES',           N'WAIT_FOR_RESULTS',
        N'WAITFOR',                         N'WAITFOR_TASKSHUTDOWN',
        N'WAIT_XTP_HOST_WAIT',              N'WAIT_XTP_OFFLINE_CKPT_NEW_LOG',
        N'WAIT_XTP_CKPT_CLOSE',             N'XE_DISPATCHER_JOIN',
        N'XE_DISPATCHER_WAIT',              N'XE_TIMER_EVENT')
  "; 

  &msg("init - Done"); 
}

# --------------------------------------------------------------------
sub regInit
# --------------------------------------------------------------------
#  Find the MSSQL11.MSSQL2 REG KEY for this instance. This will be used
#  later.
# --------------------------------------------------------------------
{
  &msg("regInit - Starting"); 

  #---- This will be used later
  $rr_regkey = &regRead("HKEY_LOCAL_MACHINE/SOFTWARE/Microsoft/Microsoft SQL Server/Instance Names/SQL", "/$in_instance");
  $rr_regpre = "HKEY_LOCAL_MACHINE/SOFTWARE/Microsoft/Microsoft SQL Server" if $rr_regkey;

  if ($rr_regkey eq "")   #---- Try Wow6432 MODE - New Way
  {
    &msg("rr_regkey is Null - Trying Wow6432 tree"); 
    $rr_regkey = &regRead("HKEY_LOCAL_MACHINE/SOFTWARE/Microsoft/Microsoft SQL Server/Instance Names/SQL", "/$in_instance", "wow6432");
    if ($rr_regkey)
    {
      $rr_regpre = "HKEY_LOCAL_MACHINE/SOFTWARE/Microsoft/Microsoft SQL Server" if $rr_regkey;
      $use_rr_wow6432   = 1; 
      &msg("Reading REG in WOW6432 mode worked"); 
    }
  }

  #if ($rr_regkey eq "")   #---- Try Wow6432 - OLD
  #{
  #  &msg("rr_regkey is Null - Trying Wow6432 tree"); 
  #  $rr_regkey = &regRead("HKEY_LOCAL_MACHINE/SOFTWARE/Wow6432Node/Microsoft/Microsoft SQL Server/Instance Names/SQL", "/$in_instance");
  #  $rr_regpre = "HKEY_LOCAL_MACHINE/SOFTWARE/Wow6432Node/Microsoft/Microsoft SQL Server" if $rr_regkey;
  #}

  if ($rr_regkey eq "")   #---- Try SQL2000
  {
    &msg("rr_regkey is Null - Trying SQL2000 Format tree"); 
    $rr_regtest = &regRead("HKEY_LOCAL_MACHINE/SOFTWARE/Microsoft/Microsoft SQL Server/$in_instance/Setup", "/SQLPath");
    if ($rr_regtest ne "") 
    {
      $rr_regpre = "HKEY_LOCAL_MACHINE/SOFTWARE/Microsoft/Microsoft SQL Server";
      $rr_regkey = "$in_instance"; 
      &msg("Reading REG in SQL2000 mode worked"); 
    }
  }

  if ($rr_regkey eq "")   #---- Did we find it at all? 
  {
    &msg("Could not read rr_regkey"); 
    ##print "PHONEHOME:Could not find RR_REGKEY\n"; 
  }

  #----
  #---- Read some commonly used values that will be used later
  #----

  if ($rr_regpre) 
  {
    #---- Get SQLPATH
    $rr_sqlpath = &regRead("$rr_regpre/$rr_regkey/Setup", "/SQLPATH");

    #---- Get SQL Agent Errorlog Path
    $rr_sql_agent_log = &regRead("$rr_regpre/$rr_regkey/SQLServerAgent", "/ErrorLogFile");
  }

  #---- Get SQL Service Acct
  if ($default_instance) 
  {
    $rr_svcacct = &regRead("HKEY_LOCAL_MACHINE/System/CurrentControlSet/services/MSSQLSERVER", "/ObjectName");
  }
  else
  {
    $rr_svcacct = &regRead("HKEY_LOCAL_MACHINE/System/CurrentControlSet/services/MSSQL\$$in_instance", "/ObjectName");
  }

  #---- Some edits
  $rr_sqlpath =~ tr/\x00//d;

  #---- Do some data returns
  &dataReturn("MSSQLServiceAccount:  $rr_svcacct") if $rr_svcacct; 

  &msg("regInit - Done - \nrr_regpre=$rr_regpre\nrr_regkey=$rr_regkey\nrr_sqlpath=$rr_sqlpath\nrr_svcacct=$rr_svcacct\nrr_sql_agent_log=$rr_sql_agent_log") if ! $WWW; 
}

# --------------------------------------------------------------------
sub regRead
# --------------------------------------------------------------------
{
  my ($rr_folder, $rr_key, $rr_parm) = @_;

  my $rr_debug = 0;
  my $rr_return = "";

  &msg("regRead - Starting - rr_folder=$rr_folder rr_key=$rr_key") if $rr_debug;

  use Win32::TieRegistry( Delimiter=>"#", ArrayValues=>0 );
  my $pound              = $Registry->Delimiter("/");

  #---- From example at: http://stackoverflow.com/questions/1621053/perls-tieregistry-and-windows-server-2008-r2
  #---- $regKey = $Registry->Open("HKEY_LOCAL_MACHINE/SOFTWARE/Microsoft/MSSQLServer/Setup", {Access=> 0x20019|0x0100});
  #---- This syntax passes the HEX flag to access the 64 bit registry
  #----  $regKey = $Registry->Open($rr_folder, {Access=> 0x20019|0x0100});

  if ($rr_parm =~ /wow6432/i || $use_rr_wow6432)
  {
    $regKey = $Registry->Open($rr_folder, {Access=> 0x20019|0x0200});
  }
  elsif ($osname eq "Win2000")
  {
    $regKey = $Registry->Open($rr_folder, {Access=> 0x20019});
  }
  else
  {
    $regKey = $Registry->Open($rr_folder, {Access=> 0x20019|0x0100});
  }

  $rr_return = $regKey->{$rr_key};

  if ($rr_debug)
  {
    foreach $key (keys %$regKey) { print"DEBUG - $rr_folder / $key: " . $regKey->{"$key"} . "\n"; }
  }

  &msg("regRead - Done - returning (rr_return)=($rr_return)") if $rr_debug;
  return $rr_return;
}

# ----------------------------------------------------------------------
sub readCfg
# ----------------------------------------------------------------------
{
  &msg("readCfg - Starting"); 

  $file_cfg_local = "dbamon_mssql_local.cfg"; 
  $file_cfg = "dbamon_mssql.cfg"; 

  &msg("Checking existence of LOCAL CFG file $file_cfg_local"); 
  if (-e "$file_cfg_local" && -r "$file_cfg_local")
  {
    $file_cfg = $file_cfg_local; 
    &msg("LOCAL CFG File DOES exist - It will be used ($file_cfg)"); 
  }
  else
  {
    &msg("LOCAL CFG File does NOT exist - Default file will be used ($file_cfg)"); 
  }

  &msg("Reading - file_cfg=$file_cfg"); 

  $cnt_cfg = 0;
  $cfg_debug = 1; 

  if (-e "$file_cfg" && -r "$file_cfg")
  {
    open(CFG, "$file_cfg") || &error("Error: Count not open input file_cfg=$file_cfg - $!");
    while(<CFG>)
    {
      ##print;
      next if /^#/ || /^$/;
      $cnt_cfg++; 
      @words = split;
      if ($words[0] eq "CHKALERT" && $words[1] eq "E")
      {
        push (@cfg_chkalert_e, $words[2]); 
      }
      elsif ($words[0] eq "PERFCOUNTER" )
      {
	$zp1 = (split(/\|/,$_))[1];
	$zp2 = (split(/\|/,$_))[2];

        $cfg_perfcounter{$zp1} = $zp2; 
      }
      else
      {
        &msg("ERROR: Verb=$words[0] Noun1=$words[1] Is undefined"); 
      }
    }
    close(CFG); 
  }
  else
  {
    &msg("Config file $file_cfg does not exist or is not readable"); 
  }

  if ($cfg_debug)
  {
    if (! $WWW)
    {
      &msg("Resulting \@cfg_chkalert_e"); 
      foreach (@cfg_chkalert_e)
      {
	&msg("  $_");
      }

      &msg("Resulting \%cfg_perfcounter"); 
      foreach (sort keys %cfg_perfcounter)
      {
        $zp1 = $_; 
        $zp2 = $cfg_perfcounter{$_};
        print "key=($zp1),val=($zp2)\n";
      }
    }
  }

  #---- Test
  if (! $WWW)
  {
    &msg("From CFG file, these SQL Log errors will be excluded:"); 
    foreach (@cfg_chkalert_e)
    {
      &msg("  $_");
    }
  }

  &msg("readCfg - Done - Non-comment lines read: $cnt_cfg"); 
}

# ----------------------------------------------------------------------
sub getRegInfo
# ----------------------------------------------------------------------
{
  &msg("getRegInfo - Starting"); 

  #---- Old
  ##use Win32::Registry;
  #---- New
  eval "use Win32::Registry"; 
  &error("Could not USE Win32::Registry") if ($@);

  $debug_reg1 = 0;

  #---- Find $hostname
  %values="";
  $Register = "System\\CurrentControlset\\Services\\tcpip\\Parameters";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| &msg("Cannot open registry 1 $Register - $!");
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $host = $RegValue if $RegKey eq "Hostname";
  }
  $hkey->Close();
  &msg("DEBUG_REG1 - host=$host") if $debug_reg1;

  &msg("Reading registry for NETWORK DOMAIN"); 
  %values="";
  $Register = "System\\CurrentControlset\\Services\\tcpip\\Parameters";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| &msg("Cannot open registry 2 $Register - $!");
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $domain = $RegValue if $RegKey eq "Domain";
    $compwork=$domain;
  }
  $hkey->Close();

  #---- Save Company name
  @words = split(/\./,$compwork);
  $nexttolast = $#words - 1;
  $company = lc $words[$nexttolast];
  &msg("DEBUG_REG1 - company=$company") if $debug_reg1;

  #---- Get registry entries for Perl 
  &msg("Reading registry for PERL VERSION"); 
  %values="";
  $Register = "Software\\Perl";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| &msg("Cannot open registry 3 $Register - $!");
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $PERLPATH = $RegValue if $RegKey eq "";
  }
  $hkey->Close();
  &msg("DEBUG_REG1 - PERLPATH=$PERLPATH") if $debug_reg1;

  $path_length = length($PERLPATH);
  if (substr($PERLPATH,$path_length - 1,1) eq "\\")
  {
    chop($PERLPATH)
  }
  $PERLPATH = "$PERLPATH\\bin";
  if ($PERLPATH !~ /exe$/)
  {
    $PERLPATH .= "\\perl.exe";
  }

  #---- 
  #---- Find SQL values: SQLPATH, ver, vershort, mssql64bit
  #----
  $SQLPATH_2000 = ""; 
  $SQLPATH_2005 = ""; 
  $SQLPATH_WOW  = ""; 

  #---- Find SQL values (old way - 2000)

  &msg("Reading registry for SQL SQLPATH - Base"); 
  %values="";
  $Register = "Software\\Microsoft\\mssqlserver\\setup";
  $openkey = 1;
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey) || ($openkey = 0);
  if ($openkey)
  {
    $hkey->GetValues(\%values);
    foreach $value (keys(%values))
    {
      $RegType      = $values{$value}->[1];
      $RegValue     = $values{$value}->[2];
      $RegKey       = $values{$value}->[0];
      ##print "$RegKey $RegValue \n";
      $SQLPATH = $RegValue if $RegKey eq "SQLPath";
    }
    $hkey->Close();
  }
  else 
  { 
    &msg("Could not find registry entries - Old style MSSQL entries (this is OK) - Register=$Register"); 
  }

  #---- Get MS SQL version OLD STYLE
  &msg("Reading registry for SQL SQLPATH - OLD STYLE"); 
  %values="";
  $Register = "Software\\Microsoft\\MSSQLServer\\MSSQLServer\\CurrentVersion";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| &msg("Cannot open registry $Register - $!");
  if ($hkey)
  {
    $hkey->GetValues(\%values);
    foreach $value (keys(%values))
    {
      $RegType      = $values{$value}->[1];
      $RegValue     = $values{$value}->[2];
      $RegKey       = $values{$value}->[0];
      $VER_2000 = $RegValue if lc($RegKey) eq "csdversion";
      $VER_2000 = $RegValue if lc($RegKey) eq "currentversion" && $VER_2000 eq "";
    }
    $hkey->Close();
  }

  #---- 2011/09/29 BB: We have a SQL 2000 NAMED INSTANCE which does not use either of the above formats. Let's try this:
  if ($SQLPATH eq "")
  {
    &msg("Reading registry for SQL SQLPATH - OLD STYLE #2"); 
    %values="";
    $Register = "Software\\Microsoft\\Microsoft SQL Server\\$in_instance\\Setup";
    $openkey = 1;
    $HKEY_LOCAL_MACHINE->Open($Register,$hkey) || ($openkey = 0);
    if ($openkey)
    {
      $hkey->GetValues(\%values);
      foreach $value (keys(%values))
      {
	$RegKey    = $values{$value}->[0];
	$RegType   = $values{$value}->[1];
	$RegValue  = $values{$value}->[2];
	$SQLPATH   = $RegValue if $RegKey eq "SQLPath";
      }
      $hkey->Close();
    }
    &msg("Resulting SQLPATH=($SQLPATH)"); 

    #---- Get MS SQL version OLD STYLE
    &msg("Reading registry for SQL SQLPATH - OLD STYLE #3"); 
    %values="";
    $Register = "Software\\Microsoft\\Microsoft SQL Server\\$in_instance\\MSSQLServer\\CurrentVersion";
    $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| &msg("Cannot open registry $Register - $!");
    if ($hkey)
    {
      $hkey->GetValues(\%values);
      foreach $value (keys(%values))
      {
	$RegType      = $values{$value}->[1];
	$RegValue     = $values{$value}->[2];
	$RegKey       = $values{$value}->[0];
	$VER_2000 = $RegValue if lc($RegKey) eq "currentversion" && $VER_2000 eq "";
	$VER_2000 = $RegValue if lc($RegKey) eq "csdversion";
      }
      $hkey->Close();
    }
  }

  #---- Save this for later
  $SQLPATH_2000 = $SQLPATH; 
  $SQLPATH = ""; 

  #---- 2.01 - It may be that a server has both old and new format registry entries. We need to ALSO check for a named instance with this NAME.
  #----          if we don't find that, it's OK -- just use what we found above. 

  #---- 
  #---- Try NEW method (SQL2005, 2008, higher)
  #---- 

  #---- Find SQL instances 
  &msg("Reading registry for SQL SQLPATH - NEW STYLE #1"); 
  %values="";
  $Register = "Software\\Microsoft\\Microsoft SQL Server\\Instance Names\\SQL";
  $openkey = 1;
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey) || ($openkey = 0);
  if ($openkey)
  {
    $hkey->GetValues(\%values);
    foreach $value (keys(%values))
    {
      $RegKey       = $values{$value}->[0];
      $RegType      = $values{$value}->[1];
      $RegValue     = $values{$value}->[2];
      ##print "key=$RegKey value=$RegValue \n";
      $sql_instances{$RegKey} = $RegValue if $RegKey;
    }
    $hkey->Close();
    &msg("MSSQL Instances Found:"); 
    foreach $this_instance (sort keys %sql_instances)
    {
      &msg("  SQL_Instance: $this_instance  SQL_Info: $sql_instances{$this_instance}");
    }

    #---- Now ensure that the $in_instance for this execution WAS found in the list of instances
    if (! $sql_instances{$in_instance} ) 
    { 
      &msg("The Instance that you specified ($in_instance) Does NOT EXIST on this server - It could be that this instance is OLD"); 
    }
    else
    {
      #---- If we are here, then this server DOES have a list of instances and this in_instance DOES exist
      $in_instance_key = $sql_instances{$in_instance}; 
      &msg("Using in_instance_key=$in_instance_key to find SQL version"); 

      #---- Get MS SQL version
      %values="";
      $Register = "Software\\Microsoft\\Microsoft SQL Server\\$in_instance_key\\MSSQLServer\\CurrentVersion";
      $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
      $hkey->GetValues(\%values);
      foreach $value (keys(%values))
      {
	$RegType      = $values{$value}->[1];
	$RegValue     = $values{$value}->[2];
	$RegKey       = $values{$value}->[0];
	$VER_2005 = $RegValue if lc($RegKey) eq "csdversion";
	$VER_2005 = $RegValue if lc($RegKey) eq "currentversion" && $VER_2005 eq "";
      }
      $hkey->Close();

      #---- Get SQLPATH
      $SQLPATH = "";
      %values = "";
      $Register = "Software\\Microsoft\\Microsoft SQL Server\\$in_instance_key\\Setup";
      $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
      $hkey->GetValues(\%values);
      foreach $value (keys(%values))
      {
	$RegType      = $values{$value}->[1];
	$RegValue     = $values{$value}->[2];
	$RegKey       = $values{$value}->[0];
	$SQLPATH = $RegValue if lc($RegKey) eq "sqlpath";
      }
      $hkey->Close();
    }
  }
  else 
  { 
    &msg("Could not read registry to get List of MSSQL instances - This could be an OLD server - Register=$Register"); 
  }
  #---- Save this for later
  $SQLPATH_2005 = $SQLPATH; 

  #----
  #---- Find SQL instances - WOW6432NODE method (rare)
  #----
  &msg("Reading registry for SQL SQLPATH - WOW6432NODE STYLE"); 
  %values="";
  $Register = "Software\\wow6432node\\Microsoft\\Microsoft SQL Server\\Instance Names\\SQL";
  $openkey = 1;
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey) || ($openkey = 0);
  if ($openkey)
  {
    $hkey->GetValues(\%values);
    foreach $value (keys(%values))
    {
      $RegKey       = $values{$value}->[0];
      $RegType      = $values{$value}->[1];
      $RegValue     = $values{$value}->[2];
      ##print "key=$RegKey value=$RegValue \n";
      $sql_instances{$RegKey} = $RegValue if $RegKey;
    }
    $hkey->Close();
    &msg("MSSQL Instances Found (if any):"); 
    foreach $this_instance (sort keys %sql_instances)
    {
      &msg("  SQL_Instance: $this_instance  SQL_Info: $sql_instances{$this_instance}");
    }

    #---- Now ensure that the $in_instance for this execution WAS found in the list of instances
    if (! $sql_instances{$in_instance} ) 
    { 
      &msg("The Instance that you specified ($in_instance) Does NOT EXIST on this server in this registry mode (No problem)"); 
    }
    else
    {
      #---- If we are here, then this server DOES have a list of instances and this in_instance DOES exist
      $in_instance_key = $sql_instances{$in_instance}; 
      &msg("Using in_instance_key=$in_instance_key to find SQL version"); 

      #---- Get MS SQL version
      %values="";
      $Register = "Software\\wow6432node\\Microsoft\\Microsoft SQL Server\\$in_instance_key\\MSSQLServer\\CurrentVersion";
      $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
      $hkey->GetValues(\%values);
      foreach $value (keys(%values))
      {
	$RegType      = $values{$value}->[1];
	$RegValue     = $values{$value}->[2];
	$RegKey       = $values{$value}->[0];
	$VER_WOW = $RegValue if lc($RegKey) eq "csdversion";
	$VER_WOW = $RegValue if lc($RegKey) eq "currentversion" && $VER_WOW eq "";
      }
      $hkey->Close();

      #---- Get SQLPATH_WOW
      $SQLPATH_WOW = "";
      %values = "";
      $Register = "Software\\wow6432node\\Microsoft\\Microsoft SQL Server\\$in_instance_key\\Setup";
      $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry (wow6432node Mode) - Register=$Register - $!";
      $hkey->GetValues(\%values);
      foreach $value (keys(%values))
      {
	$RegType      = $values{$value}->[1];
	$RegValue     = $values{$value}->[2];
	$RegKey       = $values{$value}->[0];
	$SQLPATH_WOW  = $RegValue if lc($RegKey) eq "sqlpath";
      }
      $hkey->Close();
    }
  }
  else 
  { 
    &msg("Could not read registry to get List of MSSQL instances in this mode - Register=$Register - (No problem)"); 
  }

  #---- Decide which value to use for SQLPATH
  &msg("After REG samples - SQLPATH_2000=$SQLPATH_2000 SQLPATH_2005=$SQLPATH_2005 SQLPATH_WOW=$SQLPATH_WOW - Deciding which one to use..."); 
  if    ($SQLPATH_2005) 
  { 
    $SQLPATH = $SQLPATH_2005; 
    $ver     = $VER_2005; 
    &msg("Using SQLPATH_2005 SQLPATH value"); 
  }
  elsif ($SQLPATH_2000) 
  { 
    $SQLPATH = $SQLPATH_2000; 
    $ver     = $VER_2000; 
    &msg("Using SQLPATH_2000 SQLPATH value"); 
  }
  elsif ($SQLPATH_WOW) 
  { 
    $SQLPATH = $SQLPATH_WOW; 
    $ver     = $VER_WOW; 
    &msg("Using SQLPATH_WOW SQLPATH value"); 
  }
  else  { &error("Could NOT FIND SQLPATH from registry - Maybe you installed Perl 32-bit in a 64-bit OS?"); }

  #---- See if we can see if this is 64bit mode
  #---- I will try to make this work from the MASTER DB (that would be better)
  #$key = "HKEY_LOCAL_MACHINE\\software\\wow6432node\\microsoft\\microsoft sql server\\100\\tools\\setup";
  #foreach (`reg query \"$key\" `)
  #{
  #  #print;
  #  @words = split;
  #  if (/64-bit/) { $mssql64bit = 1; }
  #}
  #&msg( "DEBUG mssql64bit=$mssql64bit"); 
     
  if (length((split(/\./,$ver)) [2]) == 3)
  {
    $ver = (split(/\./,$ver)) [0] . '.' .
	   (split(/\./,$ver)) [1] . '.' .
	   "0" . (split(/\./,$ver)) [2];
    &msg("DEBUG = Padding right node of version with 0 - ver=$ver"); 
  }

  #---- If after this we don't have SQLPATH, look for the values in this file
  $sqlpathfile = "c:\\SQLPATH.txt";
  if ($SQLPATH eq "" && -e "$sqlpathfile")
  {
    &msg("SQLPATH Being set from file $sqlpathfile"); 
    chop($SQLPATH = `type $sqlpathfile`); 
    &msg("New SQLPATH=$SQLPATH"); 
  }

  $vershort = (split(/\./,$ver)) [0] . '.' .
	      (split(/\./,$ver)) [1]; 
  $vershort =~ s/\.//;

  &msg("DEBUG - vershort before: $vershort"); 
  #---- VERSHORT could be in the format 800, 900 or 1000, etc.. edit that to be 80, 90, 100, 105
  if    ($vershort == 800)  { $vershort = 80; }
  elsif ($vershort == 900)  { $vershort = 90; }
  elsif ($vershort == 1000) { $vershort = 100; }
  elsif ($vershort == 1050) { $vershort = 105; }
  elsif ($vershort == 1100) { $vershort = 110; }
  &msg("DEBUG - vershort after: $vershort"); 

  #---- Format VERSION
  #if    ($ver =~ /^8.0/)      { $ver_major = "2000"; }
  #elsif ($ver =~ /^9.0/)      { $ver_major = "2005"; }
  #elsif ($ver =~ /^10.0/)     { $ver_major = "2008"; }
  #elsif ($ver =~ /^10.5/)     { $ver_major = "2008R2"; }
  #else                        { $ver_major = ""; } 
  ##
  #if    ($ver eq "8.00.0384") { $ver_sp = "SP1"; }
  #elsif ($ver eq "8.00.0534") { $ver_sp = "SP2";  }
  #elsif ($ver =~ /9.00.2047/) { $ver_sp = "SP1";  }
  #elsif ($ver =~ /9.00.2047/) { $ver_sp = "SP1";  }
  #elsif ($ver =~ /10.0.2531/) { $ver_sp = "SP1";  }
  #else                        { $ver_sp = ""; } 
  ##
  #$ver = "$ver($ver_major($ver_sp))"; 

  &error("Could not find SQLPATH") if ! $SQLPATH;

  $SQLPATH =~ s/\x0//g if $SQLPATH;    #---- Remove any NULLS !!!
  &msg("SQLPATH=($SQLPATH) PERLPATH=$PERLPATH ver=$ver WWW=$WWW userid=$userid vershort=$vershort mssql64bit=$mssql64bit");
  &msg("getRegInfo - Done - company=$company"); 
}

#----------------------------------------------------------------------------------
sub WMIProcessor
#----------------------------------------------------------------------------------
{
  return if $WWW; 
  &msg("WMIProcessor - starting");

  use Win32::OLE('in');
 
  #use constant wbemFlagReturnImmediately => 0x10;
  #use constant wbemFlagForwardOnly => 0x20;
 
  my $computer = "localhost";
 
  my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2"); 

  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Returning");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    return;
  }

  #my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_Processor", "WQL",
  #my $colItems = $objWMIService->ExecQuery("SELECT AddressWidth,Description, Name, MaxClockSpeed FROM Win32_Processor", "WQL",
  #my $colItems = $objWMIService->ExecQuery("SELECT AddressWidth,Description, Name, MaxClockSpeed, NumberOfCores, NumberOfLogicalProcessors FROM Win32_Processor", "WQL",
  my $colItems = $objWMIService->ExecQuery("SELECT AddressWidth,Description, Name, MaxClockSpeed FROM Win32_Processor", "WQL",
    wbemFlagReturnImmediately | wbemFlagForwardOnly);
 
  foreach my $objItem (in $colItems)
  {
    $pwmi_awidth      = $objItem->{AddressWidth};
    $pwmi_desc        = $objItem->{Description};
    $pwmi_maxclockmhz = $objItem->{MaxClockSpeed};
    $pwmi_name        = $objItem->{Name};
  }
 
  $pwmi_cpu_model = (split(/\s/,$pwmi_desc))[0];

  $pwmi_name =~ s/\s/_/g;
  $pwmi_desc =~ s/\s/_/g;

  &dataReturn("CPUModel:         $pwmi_cpu_model $pwmi_desc") if ! $usewin32registry; 
  &dataReturn("CPUClockSpeedMHz: $pwmi_maxclockmhz"); 
  &dataReturn("CPUArch:          $pwmi_awidth"); 

  if ($pwmi_awidth == 64) 
  {
    $os64bit = 1;
  }
  else
  {
    $os64bit = 0;
  }

  &msg("  Results - \npwmi_cpu_model=$pwmi_cpu_model \npwmi_awidth=$pwmi_awidth \npwmi_maxclockmhz=$pwmi_maxclockmhz \npwmi_desc=$pwmi_desc \npwmi_name=$pwmi_name
pwmi_num_cores=$pwmi_num_cores\npwmi_num_proc=$pwmi_num_proc");
  &msg("WMIProcessor - Done");
}

#----------------------------------------------------------------------------------
sub WMIComputerSystem
#----------------------------------------------------------------------------------
{
  return if $WWW; 
  &msg("WMIComputerSystem - starting");

  use Win32::OLE('in');
 
  #use constant wbemFlagReturnImmediately => 0x10;
  #use constant wbemFlagForwardOnly => 0x20;
 
  my $computer = "localhost";
 
  my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2"); 

  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Returning");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    return;
  }

  if ($owmi_osver_short < 6) 
  {
    $colname = "NumberOfProcessors"; 
  }
  else
  {
    $colname = "NumberOfLogicalProcessors"; 
  }

  my $colItems = $objWMIService->ExecQuery("SELECT $colname FROM Win32_ComputerSystem", "WQL",
    wbemFlagReturnImmediately | wbemFlagForwardOnly);

  $pwmi_num_proc = -1; 
 
  foreach my $objItem (in $colItems)
  {
    $pwmi_num_proc    = $objItem->{NumberOfProcessors}        if $objItem->{NumberOfProcessors} ne "";
    $pwmi_num_proc    = $objItem->{NumberOfLogicalProcessors} if $objItem->{NumberOfLogicalProcessors} ne "";
  }
 
  if ($pwmi_num_proc > 0) 
  {
    $numcpus = $pwmi_num_proc; 
    &dataReturn("NumCPUs: $numcpus");
    &dataReturn("SYSPERF: CPUCount $numcpus"); 
  }

  &msg("WMIComputerSystem - Done - numcpus=$numcpus pwmi_num_proc=$pwmi_num_proc");
}

#----------------------------------------------------------------------------------
sub WMIProduct
#----------------------------------------------------------------------------------
{
  &msg("WMIProduct - Starting");

  use Win32::OLE('in');
 
  #use constant wbemFlagReturnImmediately => 0x10;
  #use constant wbemFlagForwardOnly => 0x20;
 
  my $computer = "localhost";
 
  my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2"); 

  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Returning");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    return;
  }

  my $colItems = $objWMIService->ExecQuery("SELECT Name FROM Win32_Product where Name like 'SQL%'", "WQL", wbemFlagReturnImmediately | wbemFlagForwardOnly);

  $pwmi_product_cnt = 0; 
  foreach my $objItem (in $colItems)
  {
    $pwmi_product_name    = $objItem->{Name}; 
    $pwmi_product_cnt++; 
    &msg("Found $pwmi_product_name"); 
  }
 
  #if ($pwmi_num_proc > 0) 
  #{
  #  $numcpus = $pwmi_num_proc; 
  #  &dataReturn("NumCPUs: $numcpus");
  #}

  &msg("WMIProduct - Done - pwmi_product_cnt=$pwmi_product_cnt");
}

#----------------------------------------------------------------------------------
sub WMIOperatingSystem
#----------------------------------------------------------------------------------
{
  return if $WWW; 
  &msg("WMIOperatingSystem - Starting");

  #---- See: http://msdn.microsoft.com/en-us/library/windows/desktop/aa394239(v=vs.85).aspx 

  use Win32::OLE('in');
 
  my $computer = "localhost";
  my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2"); 
  my $owmi_lastreboot = ""; 

  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Returning");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    return;
  }

  my $colItems = $objWMIService->ExecQuery("SELECT lastbootuptime, systemdirectory FROM Win32_OperatingSystem", "WQL",
    wbemFlagReturnImmediately | wbemFlagForwardOnly);
 
  foreach my $objItem (in $colItems)
  {
    $owmi_lastreboot_raw = $objItem->{LastBootupTime};
    $owmi_systemdir      = $objItem->{SystemDirectory};
  }

  &msg("DEBUG - owmi_lastreboot_raw=$owmi_lastreboot_raw owmi_systemdir=$owmi_systemdir");  

  #---- Calc days since last reboot
  #----   Raw: 20120706150137.375199-360
  if ($owmi_lastreboot_raw =~ /^20/) 
  {
    $owmi_lastreboot = 
      substr($owmi_lastreboot_raw,0,4) . "/" . 
      substr($owmi_lastreboot_raw,4,2) . "/" .
      substr($owmi_lastreboot_raw,6,2) . "-" .
      substr($owmi_lastreboot_raw,8,2) . ":" .
      substr($owmi_lastreboot_raw,10,2) . ":" .
      substr($owmi_lastreboot_raw,12,2); 
    
    $owmi_lr_num = &timeToNum($owmi_lastreboot); 
    $owmi_lr_age_days = sprintf("%.2f", ((time() - $owmi_lr_num) / 86400)); 
  }
  else
  {
    $owmi_systemdir   = "?"; 
    $owmi_lastreboot  = "?"; 
    $owmi_lr_age_days = -1; 
  }

  &msg("DEBUG - owmi_lastreboot=$owmi_lastreboot owmi_lr_num=$owmi_lr_num owmi_lr_age_days=$owmi_lr_age_days");  
 
  print "$P OS_LastReboot:           $owmi_lastreboot\n"; 
  print "$P OS_LastRebootDaysSince:  $owmi_lr_age_days\n"; 
  print "$P OS_SystemDir:            $owmi_systemdir\n"; 

  &msg("WMIOperatingSystem - Done - owmi_lastreboot=$owmi_lastreboot owmi_systemdir=$owmi_systemdir");
}

#----------------------------------------------------------------------------------
sub WMIOSVer
#----------------------------------------------------------------------------------
{
  return if $WWW; 
  &msg("WMIOSVer - Starting");

  #---- See: http://msdn.microsoft.com/en-us/library/windows/desktop/aa394239(v=vs.85).aspx 

  use Win32::OLE('in');
 
  my $computer = "localhost";
  my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2"); 

  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Returning");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    return;
  }

  my $colItems = $objWMIService->ExecQuery("SELECT version, csdversion FROM Win32_OperatingSystem", "WQL",
    wbemFlagReturnImmediately | wbemFlagForwardOnly);
 
  foreach my $objItem (in $colItems)
  {
    $owmi_version    = $objItem->{Version};
    $owmi_csdversion = $objItem->{CSDVersion};
  }

  &msg("DEBUG - owmi_version=$owmi_version owmi_csdversion=$owmi_csdversion");  
 
  if ($owmi_csdversion ne "") { $owmi_csdversion =~ s/Service Pack /SP/g; } 

  #---- Form vars for use by other sprocs
  $owmi_osver = "$owmi_version,$owmi_csdversion"; 
  $owmi_osver_short = substr($owmi_osver,0,1); 

  #---- Return data to probe caller
  &dataReturn("OSVer:    $owmi_osver $osname");

  &msg("WMIOSVer - Done - owmi_osver_short=$owmi_osver_short");
}

#----------------------------------------------------------------------------------
sub WMISCSI
#----------------------------------------------------------------------------------
{
  return if $WWW; 
  &msg("WMISCSI - Starting");

  #---- See: http://msdn.microsoft.com/en-us/library/windows/desktop/aa394239(v=vs.85).aspx 

  use Win32::OLE('in');
 
  my $computer = "localhost";
  my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2"); 

  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Returning");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    return;
  }

  my $colItems = $objWMIService->ExecQuery("SELECT caption FROM Win32_scsicontroller", "WQL",
    wbemFlagReturnImmediately | wbemFlagForwardOnly);

  $owmi_scsi_cnt    = 0; 
  $owmi_scsi_pvscsi = 0; 
 
  foreach my $objItem (in $colItems)
  {
    $owmi_caption    = $objItem->{Caption};
    &msg("Found SCSI Controller: $owmi_caption"); 

    $owmi_scsi_cnt++;
    $owmi_scsi_pvscsi++ if $owmi_caption =~ /PVSCSI/; 
  }

  #---- Return data to probe caller
  &dataReturn("SYSPERF: SCSI_Cont_Tot     $owmi_scsi_cnt"); 
  &dataReturn("SYSPERF: SCSI_Cont_PVSCSI  $owmi_scsi_pvscsi"); 

  &msg("WMISCSI - Done - owmi_scsi_cnt=$owmi_scsi_cnt owmi_scsi_pvscsi=$owmi_scsi_pvscsi");
}

#----------------------------------------------------------------------------------
sub WMIService
#----------------------------------------------------------------------------------
{
  &msg("WMIService - Starting");

  #---- See: http://msdn.microsoft.com/en-us/library/windows/desktop/aa394239(v=vs.85).aspx 

  use Win32::OLE('in');
 
  my $computer = "localhost";
  my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2"); 

  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Returning");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    return;
  }

  my $colItems = $objWMIService->ExecQuery("SELECT name, started, startmode, caption FROM Win32_Service", "WQL",
    wbemFlagReturnImmediately | wbemFlagForwardOnly);

  my $svc_running = 0; 
  my $svc_notrunning = 0; 
  $svc_notrunning_autostart = 0; 
  $svc_notrunning_autostart_list = ""; 

  $services_running{"OSWin"}++; 
 
  foreach my $objItem (in $colItems)
  {
    $owmi_svc_name      = $objItem->{Name};
    $owmi_svc_started   = $objItem->{Started};
    $owmi_svc_startmode = $objItem->{StartMode};
    $owmi_svc_caption   = $objItem->{Caption};

    ##&msg("DEBUG - owmi_svc_name=$owmi_svc_name owmi_svc_started=$owmi_svc_started owmi_svc_startmode=$owmi_svc_startmode");
    
    $wmi_services{$owmi_svc_name} = $owmi_svc_started; 

    $svc_running++    if $owmi_svc_started == 1; 
    $svc_notrunning++ if $owmi_svc_started == 0; 

    #---- Only look for SQL services
    if ($owmi_svc_name =~ /sql/i && $owmi_svc_started == 0 && $owmi_svc_startmode eq "Auto") 
    {
      $svc_notrunning_autostart++; 
      $svc_notrunning_autostart_list .= "$owmi_svc_name "; 
    }
    
    if ($owmi_svc_caption =~ /^SQL Server \(/ && $owmi_svc_started == 1)          {  $services_running{"MSSQL"}++; }
    if ($owmi_svc_caption =~ /^SQL Server Agent/ && $owmi_svc_started == 1)       {  $services_running{"MSSQL-Agent"}++; }
    if ($owmi_svc_caption =~ /^SQL Server Integration/ && $owmi_svc_started == 1) {  $services_running{"SSIS"}++; }
    if ($owmi_svc_caption =~ /^SQL Server Reporting/ && $owmi_svc_started == 1)   {  $services_running{"SSRS"}++;  }
    if ($owmi_svc_caption =~ /^SQL Server Anal/ && $owmi_svc_started == 1)        {  $services_running{"SSAS"}++; }
    if ($owmi_svc_caption =~ /^SQL Server Browser/ && $owmi_svc_started == 1)     {  $services_running{"MSSQL-Brws"}++; }
  }

  if ($svc_notrunning_autostart > 0)  
  {
    &dataReturn("SvcsNotRunningAS: $svc_notrunning_autostart $svc_notrunning_autostart_list");
  }

  #---- Create services running list
  $services_running_out = ""; 
  foreach $this_svc (sort keys %services_running) 
  {
    $services_running_out .= "$this_svc "; 
  }
  &dataReturn("SvcsString: $services_running_out"); 

  &msg("WMIService - Done - svc_running=$svc_running svc_notrunning=$svc_notrunning svc_notrunning_autostart=$svc_notrunning_autostart");
}

#----------------------------------------------------------------------------------
sub WMITopProcessesCPU
#----------------------------------------------------------------------------------
{
  return if $WWW; 

  &msg("WMITopProcessesCPU - Starting");

  #---- See: http://msdn.microsoft.com/en-us/library/windows/desktop/aa394239(v=vs.85).aspx 

  use Win32::OLE('in');
 
  my $computer = "localhost";
  my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2"); 

  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Returning");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    return;
  }

  #---- wmic path Win32_PerfFormattedData_PerfProc_Process get Name,PercentProcessorTime, workingset, privatebytes, workingsetpeak, pagefilebytes, elapsedtime
  my $colItems = $objWMIService->ExecQuery("SELECT Name, PercentProcessorTime, WorkingSet, PrivateBytes, ElapsedTime, Description, IDProcess FROM Win32_PerfFormattedData_PerfProc_Process", "WQL",
    wbemFlagReturnImmediately | wbemFlagForwardOnly);

  my $tot_cpu = 0; 
  my $process_cnt = 0; 
 
  my $t_pct = 10; 
  my %pids = (); 

  $tot_processes_all  = 0; 
  $tot_processes_perl = 0; 
  $tot_processes_age_oldest_sec = 0; 

  foreach my $objItem (in $colItems)
  {
    $owmi_process_name    = $objItem->{Name};
    $owmi_cpu_pct         = $objItem->{PercentProcessorTime};
    $owmi_pid             = $objItem->{IDProcess};
    $owmi_elapsed_sec     = $objItem->{ElapsedTime}; 

    $owmi_working_set     = $objItem->{WorkingSet}; 
    $owmi_working_set_mb  = int($owmi_working_set / (1024*1024)); 
    $memhash{$owmi_working_set_mb} = "$owmi_process_name/$owmi_pid" unless $owmi_process_name eq "_Total"; 

    next if $owmi_process_name eq "Idle" || $owmi_process_name eq "_Total"; 

    $tot_processes_all++; 
    $tot_processes_age_oldest_sec = $owmi_elapsed_sec if $owmi_elapsed_sec > $tot_processes_age_oldest_sec;

    if ($owmi_process_name =~ /perl/i)
    {
      &msg("  Perl Process - owmi_process_name=$owmi_process_name owmi_cpu_pct=$owmi_cpu_pct owmi_elapsed_sec=$owmi_elapsed_sec"); 
      $tot_processes_perl++ if $owmi_process_name =~ /perl/i; 
    }

    next if $owmi_cpu_pct < $t_pct; 

    $process_cnt++; 

    &msg("  DEBUG - owmi_process_name=$owmi_process_name owmi_cpu_pct=$owmi_cpu_pct"); 

    $snap_cpdata = 
        "sn_process_name='$objItem->{Name}'<|>" . 
        "sn_cpu_pct='$objItem->{PercentProcessorTime}'<|>" . 
        "sn_private_bytes='$objItem->{PrivateBytes}'<|>" . 
        "sn_working_set='$objItem->{WorkingSet}'<|>" . 
        "sn_elapsed_seconds='$objItem->{ElapsedTime}'<|>" . 
        "sn_process_desc='$objItem->{Description}'<|>" .
        "sn_id_process='$objItem->{IDProcess}'<|>\n" ; 
    $pids{$owmi_pid} = $snap_cpdata;

    $tot_cpu += $owmi_cpu_pct; 
  }

  foreach $this_pid (sort keys %pids)
  {
    print "DDP:<|>$P<|>SNAP_CPU_PROCESS:<|>$pids{$this_pid}\n";
  }

  &dataReturn("SYSPERF: Processes_Count  $tot_processes_all"); 
  &dataReturn("SYSPERF: Processes_Perl   $tot_processes_perl"); 

  $server_upfor_days = sprintf("%.2f", $tot_processes_age_oldest_sec / 86400 ); 
  &dataReturn("SYSPERF: Server_Upfor_Days  $server_upfor_days"); 

  #---- Process Top 4 Mem Consumers
  $c = 0;
  foreach (sort { $b <=> $a } keys(%memhash) )   #---- Numeric sort
  {
    last if ++$c > 5;
    ##&msg("DEBUG Results #$c - $_ - $memhash{$_}");
    $raw = $memhash{$_}; 
    $zf1 = (split(/\//,$raw))[0];
    $zf2 = (split(/\//,$raw))[1];
    print "DDP:<|>$P<|>SNAP_MEM_TOP:<|>sn_process_name=$zf1<|>sn_process_spid=$zf2<|>sn_working_set_size_mb=$_<|>\n";
  }

  #---- Go away
  &msg("WMITopProcessesCPU - Done - tot_cpu=$tot_cpu process_cnt=$process_cnt tot_processes_all=$tot_processes_all tot_processes_perl=$tot_processes_perl tot_processes_age_oldest_sec=$tot_processes_age_oldest_sec");
}

#----------------------------------------------------------------------------------
sub WMINetPerf
#----------------------------------------------------------------------------------
{
  return if $WWW; 

  &msg("WMINetPerf - Starting");

  #---- On some servers this takes around 2 minutes, so ... 
  if ($now_hhmm ge "00:00" && $now_hhmm le "02:00")  
  { 
    &msg("It is now $now_hhmm - So it is OK to run"); 
  } 
  else
  { 
    &msg("It is now $now_hhmm - So it is NOT OK to run - Returning"); 
    return;
  } 

  #---- See: http://msdn.microsoft.com/en-us/library/windows/desktop/aa394239(v=vs.85).aspx 

  use Win32::OLE('in');
 
  my $computer = "localhost";
  my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2"); 

  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Returning");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    return;
  }

  my $colItems = $objWMIService->ExecQuery("SELECT name, currentbandwidth, bytesreceivedpersec, bytessentpersec, packetsreceivederrors, packetsoutbounderrors, OutputQueueLength FROM Win32_PerfFormattedData_Tcpip_NetworkInterface", "WQL", wbemFlagReturnImmediately | wbemFlagForwardOnly);
 
  $wminet_rows = 0; 

  foreach $objItem (in $colItems)
  {  
    $wminet_rows++; 

    $wminp_name = $objItem->{name};
    &msg("  NetPerf Row - wminp_name=$wminp_name"); 

    #BytesReceivedPersec  BytesSentPersec  CurrentBandwidth   OutputQueueLength  PacketsOutboundErrors  PacketsReceivedErrors
    $wminp_ctrs{BytesReceivedPersec}   += $objItem->{BytesReceivedPersec};
    $wminp_ctrs{BytesSentPersec}       += $objItem->{BytesSentPersec};
    $wminp_ctrs{CurrentBandwidth}      += $objItem->{CurrentBandwidth};
    $wminp_ctrs{OutputQueueLength}     += $objItem->{OutputQueueLength};
    $wminp_ctrs{PacketsOutboundErrors} += $objItem->{PacketsOutboundErrors};
    $wminp_ctrs{PacketsReceivedErrors} += $objItem->{PacketsReceivedErrors};

    $wminp_ctrs{BytesTotalPersec}      =  $wminp_ctrs{BytesReceivedPersec} + $wminp_ctrs{BytesSentPersec}; 
  }

  &msg("Totals:"); 

  foreach $this_ctr (sort keys %wminp_ctrs)
  {
    $this_val = $wminp_ctrs{"$this_ctr"}; 
    &msg("  this_ctr=$this_ctr this_val=$this_val"); 
    &dataReturn("SYSPERF: NET_$this_ctr $this_val"); 
  }

  &msg("WMINetPerf - Done - wminet_rows=$wminet_rows");
}

# ----------------------------------------------------------------------
sub driveCheck
# ----------------------------------------------------------------------
{
  &msg("driveCheckWMI - Loading DRIVE data into hash"); 

  use Win32::OLE('in'); 

  #use constant wbemFlagReturnImmediately => 0x10; 
  #use constant wbemFlagForwardOnly => 0x20; 

  $computer = ".";
  $objWMIService = Win32::OLE->GetObject
      ("winmgmts:\\\\$computer\\root\\CIMV2");  #--- or die "WMI connection failed.\n";
 
  if (! $objWMIService)
  {
    &msg("objWMIService is NULL - Error=($!) - Running driveCheckCMD instead");
    &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting
    &driveCheckCMD;
    return;
  }

  $colItems = $objWMIService->ExecQuery 
      ("SELECT deviceid, size, freespace, status, statusinfo FROM Win32_LogicalDisk where drivetype = 3","WQL",wbemFlagReturnImmediately | wbemFlagForwardOnly); 
   
  $drive_count = 0;
  $tot_mb_size = 0;
  $tot_mb_free = 0;
  undef %disks;

  &setlocale_C;  #---- Reset locale in case OLE changed it to the local setting

  foreach my $objItem (in $colItems) 
  { 
    #print "Device ID: $objItem->{DeviceID}\n"; 
    #print "Free Space: $objItem->{FreeSpace}\n"; 
    #print "Size: $objItem->{Size}\n"; 

    $drive = $objItem->{DeviceID}; 
    $drive =~ s/\://;
    $disks{"$drive"} = 1;

    $disk_size_mb{"$drive"} = sprintf("%.2f", ($objItem->{Size}      / (1024*1024))  ); 
    $disk_free_mb{"$drive"} = sprintf("%.2f", ($objItem->{FreeSpace} / (1024*1024))  ); 
    $disk_used_mb{"$drive"} = sprintf("%.2f", ($disk_size_mb{"$drive"} - $disk_free_mb{"$drive"}));

    $disk_size_gb{"$drive"} = sprintf("%.2f", ($objItem->{Size}      / (1024*1024*1024))  ); 
    $disk_free_gb{"$drive"} = sprintf("%.2f", ($objItem->{FreeSpace} / (1024*1024*1024))  ); 
    $disk_used_gb{"$drive"} = sprintf("%.2f", ($disk_size_gb{"$drive"} - $disk_free_gb{"$drive"}));

    $disk_pct_full{"$drive"} = sprintf("%.2f", 100 * ($disk_used_gb{"$drive"} / $disk_size_gb{"$drive"})) if  $disk_size_gb{"$drive"} > 0;
    $drive_count++; 

    #---- 3.21
    if ($disk_size_gb{$drive} > 0)  
    {
      &dataReturn("Disk_Drive_Space_Data: $drive SizeGB  $disk_size_gb{$drive}");  
      &dataReturn("Disk_Drive_Space_Data: $drive FreeGB  $disk_free_gb{$drive}");  
      &dataReturn("Disk_Drive_Space_Data: $drive UsedGB  $disk_used_gb{$drive}");  
      &dataReturn("Disk_Drive_Space_Data: $drive PctFull $disk_pct_full{$drive}");  
    }

    $tot_mb_size += $disk_size_mb{"$drive"}; 
    $tot_mb_free += $disk_free_mb{"$drive"}; 
  } 

  #---- See if we have ANY results? 
  if ($tot_mb_size == 0) 
  {
    &msg("Even after running WMI, tot_mb_size=$tot_mb_size - We will try driveCheckCMD instead");
    &driveCheckCMD;
    return;
  }

  $tot_gb_list = ""; 
  &msg("  Resulting Disk info:");
  foreach $zdrive (sort keys %disks)
  {
    &msg("    Disk: $zdrive - Size=$disk_size_gb{$zdrive} Free=$disk_free_gb{$zdrive} Used=$disk_used_gb{$zdrive}  PctF=$disk_pct_full{$zdrive}"); 
    $tot_gb_list .= $zdrive; 
  }

  #---- Return Total disk size
  my $tot_gb_size = int($tot_mb_size / 1024); 
  my $tot_gb_used = $tot_gb_size - ($tot_mb_free / 1024); 
  my $tot_gb_pct  = sprintf "%.2f", ($tot_gb_used / $tot_gb_size) * 100;
  &dataReturn("DISK_Tot_Size_GB: $tot_gb_size");  
  &dataReturn("DISK_Tot_Pct:     $tot_gb_pct");  
  &dataReturn("DISK_Tot_List:    $tot_gb_list");  

  #---- 3.25 - Added this two
  &dataReturn("SYSPERF: DiskSpaceTotal_GB       $tot_gb_size"); 
  &dataReturn("SYSPERF: DiskSpaceTotal_PctFull  $tot_gb_pct"); 

  &msg("driveCheckWMI - Done - tot_gb_size=$tot_gb_size tot_mb_size=$tot_mb_size tot_mb_free=$tot_mb_free"); 
}

# ----------------------------------------------------------------------
sub countCPUs
# ----------------------------------------------------------------------
{
  &msg("countCPUs - Starting - srvinfo_cmd=$srvinfo_cmd"); 

  if ($ENV{"NUMBER_OF_PROCESSORS"})
  {
    &msg("  Setting numcpus from ENV"); 
    $numcpus = $ENV{"NUMBER_OF_PROCESSORS"};
    #print "PHONEHOME:_NUMCPUs_from_ENV\n"; 
  }
  else
  {
    &msg("  Setting numcpus from $srvinfo_cmd"); 
    open(SRVINFO, "$srvinfo_cmd 2>&1 |") || &error("Error: Running $srvinfo_cmd");
    while(<SRVINFO>)
    {
      ##print;
      next unless /^CPU/;
      $numcpus++; 
    }
    &msg("  Resulting numcpus=$numcpus"); 
    #print "PHONEHOME:_NUMCPUs_from_SRVINFO\n"; 
  }

  print "PHONEHOME:_NUMCPUs_is_NULL\n" if ! $numcpus;

  &dataReturn("NumCPUs: $numcpus");

  #---- 3.25
  &dataReturn("SYSPERF: CPUCount $numcpus"); 

  &msg("countCPUs - Done - numcpus=$numcpus"); 
}

# ----------------------------------------------------------------------
sub driveCheckCMD
# ----------------------------------------------------------------------
{
  &msg("driveCheckCMD - Loading DRIVE data into hash - running srvinfo_cmd=$srvinfo_cmd"); 

  #print "PHONEHOME:driveCheckCMD\n"; 

  open(SRVINFO, "$srvinfo_cmd 2>&1 |") || &error("Error: Running $srvinfo_cmd");
  $drive_count = 0;
  $tot_mb_size = 0;
  $tot_mb_free = 0;
  undef %disks;
  while(<SRVINFO>)
  {
    ##print;
    @words = split;

    if (length($words[0]) == 2 && ($words[1] eq "FAT" || $words[1] eq "NTFS"))
    {
      $drive = substr($words[0],0,1);
      $disks{"$drive"} = $_;
      $disk_size_gb{"$drive"} = sprintf("%.2f",$words[2] / 1024);
      $disk_free_gb{"$drive"} = sprintf("%.2f",$words[3] / 1024);
      $disk_used_gb{"$drive"} = sprintf("%.2f", ($disk_size_gb{"$drive"} - $disk_free_gb{"$drive"}));
      $disk_size_mb{"$drive"} = sprintf("%.2f",$words[2] );
      $disk_free_mb{"$drive"} = sprintf("%.2f",$words[3] );
      $disk_used_mb{"$drive"} = sprintf("%.2f", ($disk_size_mb{"$drive"} - $disk_free_mb{"$drive"}));
      $disk_pct_full{"$drive"} = sprintf("%.2f", 100 * ($disk_used_gb{"$drive"} / $disk_size_gb{"$drive"})) if  $disk_size_gb{"$drive"} > 0;
      $drive_count++; 
      $tot_mb_size += $disk_size_mb{"$drive"}; 
      $tot_mb_free += $disk_free_mb{"$drive"}; 
    }
  }

  &msg("  Resulting Disk info:");
  foreach $zdrive (sort keys %disks)
  {
    &msg("    Disk: $zdrive - Size=$disk_size_gb{$zdrive} Free=$disk_free_gb{$zdrive} Used=$disk_used_gb{$zdrive}  PctF=$disk_pct_full{$zdrive}"); 
  }

  &msg("driveCheckCMD - Done - tot_mb_size=$tot_mb_size tot_mb_free=$tot_mb_free"); 
}

# ----------------------------------------------------------------------
sub checkReplication
# ----------------------------------------------------------------------
{
  &msg("checkReplication - Starting");

  my $debug_cr = 0; 

  if ($#dblist < 0) 
  {
    &msg("List of DBs (dblist) is null - Returning"); 
    return;
  }

  &msg("  Looking for Distribution* DB"); 
  foreach $dbname (@dblist)
  {
    &msg("  DEBUG - Found dbname=$dbname") if $debug_cr; 
    if ($dbname =~ /^distribution/i) 
    {
      &msg("    Found a good distribution* DB - Looking for MSREPL_COMMANDS Table") if $debug_cr; 

      #---- Look for MSREPL_COMMANDS table
      $sql = "select OBJECT_ID('$dbname.dbo.msrepl_commands')"; 
      $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
      $sth3->execute() || &error("Could not execute sql=$sql");
      while (@Data = $sth3->fetchrow_array)
      {
	$table_objid = $Data[0]; 
      }
      &msg("    Resulting table_objid=$table_objid"); 

      if ($table_objid > 0) 
      {
        &msg("    Found MSREPL_COMMANDS table"); 
        &dataReturn("REPL_DIST: Y"); 
        $repl_dist = 1; 

        #---- Run SQL to see replication "last replicated" date by subscriber
        $sql = "SELECT  
          ag.NAME AS Agent_Name ,
          agent_id AS Agent_ID ,
          MAX(time) AS Max_Repl_Timestamp ,
          DATEDIFF(mi, MAX(time), GETDATE()) AS Mins_Since_Last_Update
        FROM    
          [distribution].[dbo].[MSdistribution_history] hi with ( NOLOCK ) ,
          [distribution].[dbo].[MSdistribution_agents] ag with ( NOLOCK )
        WHERE   
          hi.agent_id = ag.id
          AND hi.runstatus IN ( 2, 3, 4 )
        GROUP BY 
          agent_id ,
          ag.name
        ORDER BY 
          1"; 
	$sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
	$sth3->execute() || &error("Could not execute sql=$sql");
	while (@Data = $sth3->fetchrow_array)
	{
	  $re_agent_name = $Data[0]; 
	  $re_agent_num  = $Data[1]; 
	  $re_last_ts    = $Data[2]; 
	  $re_mins_since = $Data[3]; 

	  $re_hrs_since  = sprintf("%.2f",$re_mins_since / 60);
          #---- New in 3.25 - We found an agent name with a SPACE, which goofed up the metric
          $re_agent_name =~ s/\s/[SPACE]/g;

          &dataReturn("REPL_Stat:  $re_agent_name  $re_agent_num  $re_last_ts  $re_hrs_since"); 
	}
      }
    }
  }

  if ($repl_dist)  
  {
    #---- Look for agents that are not using the DEFAULT agent profile
    $sql = "SELECT 
        replace(jo.name , ' ', '_'),
        replace(pr.profile_name , ' ', '_')
        --jo.enabled , --[publication] , --[publisher_db] , --[subscriber_db]
FROM    [distribution].[dbo].[MSdistribution_agents] ag WITH ( NOLOCK ) ,
        msdb..msagent_profiles pr WITH ( NOLOCK ) ,
        msdb..sysjobs jo WITH (NOLOCK)
WHERE   ag.profile_id = pr.profile_id
        AND ag.job_id = jo.job_id
        AND jo.enabled = 1
	--AND pr.profile_name != 'default agent profile'
	AND pr.profile_name not like 'default%'
ORDER BY 1
      "; 
    $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
    $sth3->execute() || &error("Could not execute sql=$sql");
    while (@Data = $sth3->fetchrow_array)
    {
      $re_agent_name    = $Data[0]; 
      $re_agent_profile = $Data[1]; 

      $re_agent_name =~ s/\s/[SPACE]/g;

      &dataReturn("REPL_Agent_Non_Default_Profile: $re_agent_name $re_agent_profile"); 
    }
  }
  
  &msg("checkReplication - Done");
}

# ----------------------------------------------------------------------
sub checkRJSF
# ----------------------------------------------------------------------
{
  &msg("checkRJSF - Starting");

  #---- JUST A TEST!!
  ###print "dbamon_mssql.pl RJSF_LastOKLoad_Age_Hrs: RJ_SF_CIProd 34 1.51\n"; 
  
  my $debug_rj = 1; 

  if ($#dblist < 0) 
  {
    &msg("List of DBs (dblist) is null - Returning"); 
    return;
  }

  &msg("  Looking for DB which contains tables RJ_HISTORY and RJ4SF_ERROR"); 
  foreach $dbname (@dblist)
  {
    &msg("Found dbname=$dbname");

    #---- We only care about DBs that begin with upper-case RJ
    next unless $dbname =~ /^RJ/;
    &msg("DEBUG - This is an RJ* DB") if $debug_rj;

    #---- Look for a few tables
    $sql = "
      select t1.*, t2.*, t3.*
      from
      (select count(*) as c1 from $dbname.INFORMATION_SCHEMA.tables where table_name = 'rj_history') t1,
      (select count(*) as c2 from $dbname.INFORMATION_SCHEMA.tables where table_name = 'rj4sf_error') t2,
      (select count(*) as c3 from $dbname.INFORMATION_SCHEMA.tables where table_name = 'sf_loginhistory') t3
    "; 
 
    $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
    $sth3->execute() || &error("Could not execute sql=$sql");

    $zd0 = $zd1 = $zd2 = -1;   #---- Clear vars
    $rjsf_alldbs_maxlogin_age_hrs = -1;
    $rjsf_alldbs_minlogin_age_hrs = 99999999;

    while (@Data = $sth3->fetchrow_array)
    {
      $zd0 = shift(@Data); 
      $zd1 = shift(@Data); 
      $zd2 = shift(@Data); 
    }
    &msg("    Resulting zd0=$zd0 zd1=$zd1 zd2=$zd2") if $debug_rj; 

    if ($zd0 == 1 && $zd1 == 1) 
    {
      &msg("This DB does have the RJSF tables"); 
    }
    else
    {
      &msg("This DB does NOT have all of the required RJSF tables - Skipping"); 
      next;
    }
    
    &dataReturn("RJSF_Found: $dbname Y"); 
    $rjsf_found = 1; 

    #---- Run SQL to see the LAST LOADED TS for 3 key tables
    $sql = "
    SELECT object_name,
      max(run_complete_date),
      datediff(mi, max(run_complete_date), getdate()) Mins_Since_Last_Update
    FROM [$dbname].[dbo].[RJ_HISTORY] 
    where object_name in ('LOGINHISTORY', 'LEAD', 'ACCOUNT')
      and run_status = 'completed'
    group by object_name
    order by 3 
    "; 
    $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
    $sth3->execute() || &error("Could not execute sql=$sql");
    while (@Data = $sth3->fetchrow_array)
    {
      $rjsf_obj_name     = $Data[0]; 
      $rjsf_last_load_ts = $Data[1]; 
      $rjsf_mins_since   = $Data[2]; 

      $rjsf_hrs_since  = sprintf("%.2f",$rjsf_mins_since / 60);

      &dataReturn("RJSF_Obj_Stats: $dbname  $rjsf_obj_name  $rjsf_last_load_ts  $rjsf_mins_since  $rjsf_hrs_since"); 
    }
    &dataReturn("SYSPERF: SQL_RJ_${dbname}_Max_Hrs_Since_Load $rjsf_hrs_since"); 

    #---- Run SQL to see the MAX TS from SG_LOGINHISTORY
    if ($zd2 == 1)  #---- Does this table even exist?
    {
      $sql = "
      IF (select count(*) from $dbname.INFORMATION_SCHEMA.TABLES where table_name = 'SF_LOGINHISTORY') > 0
      BEGIN
	  SELECT datediff(mi, max(logintime), sysutcdatetime()) from $dbname..sf_loginhistory
      END
      "; 
      $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
      $sth3->execute() || &error("Could not execute sql=$sql");
      while (@Data = $sth3->fetchrow_array)
      {
	$rjsf_maxlogin_age_min  = $Data[0]; 
	$rjsf_maxlogin_age_hrs  = sprintf("%.2f",$rjsf_maxlogin_age_min / 60);
	&dataReturn("RJSF_MaxLogin_Age: $dbname $rjsf_maxlogin_age_min  $rjsf_maxlogin_age_hrs"); 
	&dataReturn("SYSPERF: SQL_RJ_${dbname}_Max_Login_Age_Hrs $rjsf_maxlogin_age_hrs"); 

	$rjsf_alldbs_maxlogin_age_hrs = $rjsf_maxlogin_age_hrs if $rjsf_maxlogin_age_hrs > $rjsf_alldbs_maxlogin_age_hrs;
	$rjsf_alldbs_minlogin_age_hrs = $rjsf_maxlogin_age_hrs if $rjsf_maxlogin_age_hrs < $rjsf_alldbs_minlogin_age_hrs;
      }
    }

    #---- Run SQL to see the MAX TS from CICENTRAL..RJ_LOG
    if ($cice_rj_log == 1)  #---- Does this table even exist?
    {
      $sql = "
	select min(DATEDIFF(mi, rl_ts, getdate()) ) as 'Mins_Since_Last_OK_Run_for_this_DB'
	from cicentral..RJ_Log 
	where rl_rj_dbname = '$dbname' and RL_Status = 'OK'
      "; 
      $sth3 = $dbh->prepare($sql) || &error("L6195 Could not prepare sql=$sql");
      $sth3->execute() || &error("L6196 Could not execute sql=$sql");
      while (@Data = $sth3->fetchrow_array)
      {
	$rjsf_lastokload_mins_since  = $Data[0]; 
	$rjsf_lastokload_hrs_since   = sprintf("%.2f",$rjsf_lastokload_mins_since / 60);
	&dataReturn("RJSF_LastOKLoad_Age_Hrs: $dbname $rjsf_lastokload_mins_since $rjsf_lastokload_hrs_since"); 
	&dataReturn("SYSPERF: SQL_RJ_LastOKLoad_${dbname}_Age_Hrs $rjsf_lastokload_hrs_since"); 
      }
    }

    #---- Rates
    $sql = "
      select 
      sum(records_added_etl + records_updated_etl) as rows_changed,
      sum(api_count) sum_api_count,
      count(distinct object_name) as tables,
      sum(errors) sum_errors
      from $dbname..rj_history
      where run_status = 'completed'
      and RUN_COMPLETE_DATE > dateadd(mi, -60, getdate())
    "; 

    $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
    $sth3->execute() || &error("Could not execute sql=$sql");
    while (@Data = $sth3->fetchrow_array)
    {
      $rjsf_lasthr_rows_changed = shift @Data;
      $rjsf_lasthr_api_calls    = shift @Data;
      $rjsf_lasthr_table_cnt    = shift @Data;
      $rjsf_lasthr_errors       = shift @Data;

      &dataReturn("SYSPERF: SQL_RJ_${dbname}_LastHr_Rows_Changed  $rjsf_lasthr_rows_changed"); 
      &dataReturn("SYSPERF: SQL_RJ_${dbname}_LastHr_API_Calls     $rjsf_lasthr_api_calls"); 
      &dataReturn("SYSPERF: SQL_RJ_${dbname}_LastHr_Table_Cnt     $rjsf_lasthr_table_cnt"); 
      &dataReturn("SYSPERF: SQL_RJ_${dbname}_LastHr_Errors        $rjsf_lasthr_errors"); 
    }
  }   #---- End of foreach DB

  #---- Data for all RJ DBs
  &dataReturn("SYSPERF: SQL_RJ_AllDBs_Max_Login_Age_Hrs $rjsf_alldbs_maxlogin_age_hrs"); 
  &dataReturn("SYSPERF: SQL_RJ_AllDBs_Min_Login_Age_Hrs $rjsf_alldbs_minlogin_age_hrs"); 

  &msg("checkRJSF - Done");
}

# ----------------------------------------------------------------------
sub checkCDNS
# ----------------------------------------------------------------------
{
  &msg("checkCDNS - Starting");

  my $debug_cdns = 1; 

  if ($#dblist < 0) 
  {
    &msg("List of DBs (dblist) is null - Returning"); 
    return;
  }

  &msg("  Looking for DB which contains tables typical CDNS tables..."); 
  foreach $dbname (@dblist)
  {
    &msg("Found dbname=$dbname");

    #---- We only care about DBs that begin with upper-case CD_NS 
    next unless $dbname =~ /^CD\_NS\_/;
    &msg("DEBUG - This is a CD_NS* DB") if $debug_rj;

    #---- Look for a few tables
    $sql = "
      select t1.*, t2.*, t3.*
      from
      (select count(*) as c1 from $dbname.INFORMATION_SCHEMA.tables where table_name = 'ns_account') t1,
      (select count(*) as c2 from $dbname.INFORMATION_SCHEMA.tables where table_name = 'ns_location') t2,
      (select count(*) as c3 from $dbname.INFORMATION_SCHEMA.tables where table_name = 'ns_job') t3
    "; 
 
    $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
    $sth3->execute() || &error("Could not execute sql=$sql");

    $zd0 = $zd1 = $zd2 = -1;   #---- Clear vars
    $cdns_alldbs_maxlogin_age_hrs = -1;
    $cdns_alldbs_minlogin_age_hrs = 99999999;

    while (@Data = $sth3->fetchrow_array)
    {
      $zd0 = shift(@Data); 
      $zd1 = shift(@Data); 
      $zd2 = shift(@Data); 
    }
    &msg("    Resulting zd0=$zd0 zd1=$zd1 zd2=$zd2") if $debug_cdns; 

    if ($zd0 == 1 && $zd1 == 1) 
    {
      &msg("This DB does have the CDNS tables"); 
    }
    else
    {
      &msg("This DB does NOT have all of the required CDNS tables - Skipping"); 
      next;
    }
    
    &dataReturn("CDNS_Found: $dbname Y"); 
    $cdns_found = 1; 

    #---- Run SQL to see the MAX TS from CICENTRAL..NSS_LOG
    if ($cice_nss_log == 1)  #---- Does this table even exist?
    {
      $sql = "
	select min(DATEDIFF(mi, nl_ts, getdate()) ) as 'Mins_Since_Last_OK_Run_for_this_DB'
	from cicentral..NSS_Log 
	where NL_NSS_Dbname = '$dbname' and NL_Status = 'OK'
      "; 
      $sth3 = $dbh->prepare($sql) || &error("L6195 Could not prepare sql=$sql");
      $sth3->execute() || &error("L6196 Could not execute sql=$sql");
      while (@Data = $sth3->fetchrow_array)
      {
	$cdns_lastokload_mins_since  = $Data[0]; 
	$cdns_lastokload_hrs_since   = sprintf("%.2f",$cdns_lastokload_mins_since / 60);
	&dataReturn("CDNS_LastOKLoad_Age_Hrs: $dbname $cdns_lastokload_mins_since $cdns_lastokload_hrs_since"); 
	&dataReturn("SYSPERF: SQL_CDNS_LastOKLoad_${dbname}_Age_Hrs $cdns_lastokload_hrs_since"); 
      }
    }
  }   #---- End of foreach DB

  &msg("checkCDNS - Done");
}

# ----------------------------------------------------------------------
sub checkCDSF
# ----------------------------------------------------------------------
{
  &msg("checkCDSF - Starting");

  my $debug_cdsf = 1; 

  if ($#dblist < 0) 
  {
    &msg("List of DBs (dblist) is null - Returning"); 
    return;
  }

  &msg("  Looking for DB which contains tables typical CDSF tables..."); 
  foreach $dbname (@dblist)
  {
    &msg("Found dbname=$dbname");

    #---- We only care about DBs that begin with upper-case CD_NS 
    next unless $dbname =~ /^CD\_SF\_/;
    &msg("DEBUG - This is a CD_SF* DB") if $debug_rj;

    #---- Look for a few tables
    $sql = "
      select t1.*, t2.*, t3.*
      from
      (select count(*) as c1 from $dbname.INFORMATION_SCHEMA.tables where table_name = 'sf_account') t1,
      (select count(*) as c2 from $dbname.INFORMATION_SCHEMA.tables where table_name = 'sf_lead') t2,
      (select count(*) as c3 from $dbname.INFORMATION_SCHEMA.tables where table_name = 'sf_task') t3
    "; 
 
    $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
    $sth3->execute() || &error("Could not execute sql=$sql");

    $zd0 = $zd1 = $zd2 = -1;   #---- Clear vars
    $cdsf_alldbs_maxlogin_age_hrs = -1;
    $cdsf_alldbs_minlogin_age_hrs = 99999999;

    while (@Data = $sth3->fetchrow_array)
    {
      $zd0 = shift(@Data); 
      $zd1 = shift(@Data); 
      $zd2 = shift(@Data); 
    }
    &msg("    Resulting zd0=$zd0 zd1=$zd1 zd2=$zd2") if $debug_cdsf; 

    if ($zd0 == 1 && $zd1 == 1) 
    {
      &msg("This DB does have the CDSF tables"); 
    }
    else
    {
      &msg("This DB does NOT have all of the required CDSF tables - Skipping"); 
      next;
    }
    
    &dataReturn("CDSF_Found: $dbname Y"); 
    $cdsf_found = 1; 

    #---- Run SQL to see the MAX TS from CICENTRAL..SFS_LOG
    if ($cice_sfs_log == 1)  #---- Does this table even exist?
    {
      $sql = "
	select min(DATEDIFF(mi, sl_ts, getdate()) ) as 'Mins_Since_Last_OK_Run_for_this_DB'
	from cicentral..SFS_Log 
	where SL_SFS_Dbname = '$dbname' and SL_Status = 'OK'
      "; 
      $sth3 = $dbh->prepare($sql) || &error("L6487 Could not prepare sql=$sql");
      $sth3->execute() || &error("L6488 Could not execute sql=$sql");
      while (@Data = $sth3->fetchrow_array)
      {
	$cdsf_lastokload_mins_since  = $Data[0]; 
	$cdsf_lastokload_hrs_since   = sprintf("%.2f",$cdsf_lastokload_mins_since / 60);
	&dataReturn("CDSF_LastOKLoad_Age_Hrs: $dbname $cdsf_lastokload_mins_since $cdsf_lastokload_hrs_since"); 
	&dataReturn("SYSPERF: SQL_CDSF_LastOKLoad_${dbname}_Age_Hrs $cdsf_lastokload_hrs_since"); 
      }
    }
  }   #---- End of foreach DB

  &msg("checkCDSF - Done");
}

# ----------------------------------------------------------------------
sub checkSSRSLog
# ----------------------------------------------------------------------
{
  &msg("checkSSRSLog - Starting");

  my $ssrs_test_flag = 0; 
  my $ssrs_log_table_name = "ReportServer..ExecutionLog2"; 
  $ssrs_log_table_name = "dbamon.dbamon.instances" if $ssrs_test_flag; 
  $ssrs_log_timestamp = ""; 
  my $ssrs_lo_ts = ""; 
  my $ssrs_hi_ts = "";

  #---- Look for MSREPL_COMMANDS table
  &msg("  Looking for OBJECT_ID of table: $ssrs_log_table_name"); 

  $sql = "select OBJECT_ID('$ssrs_log_table_name')"; 
  $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
  $sth3->execute() || &error("Could not execute sql=$sql");
  while (@Data = $sth3->fetchrow_array)
  {
    $table_objid = $Data[0]; 
  }
  &msg("  Resulting table_objid=$table_objid"); 

  if ($table_objid > 0) 
  {
    &msg("  Found $ssrs_log_table_name table - Continuing"); 
  }
  else
  {
    &msg("  Did not find $ssrs_log_table_name table - Returning"); 
    return;
  }

  #---- Create the proper WHERE clause from the timestamp of the last run
  if ($dcf_data{'SSRSLogBookmark'} ne "") { $where2 = "and TimeEnd > '$dcf_data{'SSRSLogBookmark'}'"; } 
  else                                    { $where2 = " "; } 

  #---- Run SQL to see replication "last replicated" date by subscriber
  $sql = "SELECT 
	  TimeStart as AA_TimeStart ,
	  TimeEnd as AB_TimeEnd ,
          Status as AC_Status ,
	  ReportPath as BB_ReportPath,
	  Username as CC_Username ,
	  Parameters as DD_Parameters ,
	  EE_TotalDurationMS = DATEDIFF(ms, TimeStart, TimeEnd) ,
	  FF_DurationDataRetrievalMS = TimedataRetrieval ,
	  GG_DurationProcessingMS = TimeProcessing ,
	  HH_DurationRendering = TimeRendering ,
	  [RowCount] as II_Rowcount,
	  JJ_ReportSizeKB = CAST(ByteCount / 1024.0 AS DECIMAL(18, 2)) ,
	  KK_ProcessingEngine = CAST(AdditionalInfo.query('data(/AdditionalInfo/ProcessingEngine)') AS VARCHAR(200)) ,
	  LL_ScalabilityPagination = CAST(AdditionalInfo.query('data(/AdditionalInfo/ScalabilityTime/Pagination)') AS VARCHAR(200)) ,
	  MM_ScalabilityProcessing = CAST(AdditionalInfo.query('data(/AdditionalInfo/ScalabilityTime/Processing)') AS VARCHAR(200)) ,
	  NN_EstMemPaginationKB = CAST(AdditionalInfo.query('data(/AdditionalInfo/EstimatedMemoryUsageKB/Pagination)') AS VARCHAR(200)) ,
	  OO_EstMemProcessingKB = CAST(AdditionalInfo.query('data(/AdditionalInfo/EstimatedMemoryUsageKB/Processing)') AS VARCHAR(200)) ,
	  PP_DBQueryTimes = CAST(AdditionalInfo.query('data(/AdditionalInfo/DataExtension/SQL)') AS VARCHAR(200))
  FROM    ReportServer..ExecutionLog2 WITH ( NOLOCK )
  WHERE   ReportPath <> 'Unknown' and TimeStart > dateadd(dd, -7, getdate()) $where2
  ORDER BY 1 DESC
  "; 
  $sql = "select * from $ssrs_log_table_name" if $ssrs_test_flag; 
  &msg("Running sql=$sql");  ## if $ssrs_test_flag; 

  $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
  $sth3->execute() || &error("Could not execute sql=$sql");
  
  $ssrs_log_header_flag = 0; 
  $ssrs_log_out = ""; 
  $ssrs_rowcnt = 0; 
  $ssrs_failed_reports = 0; 
  $ssrs_successful_reports = 0; 

  while($href = $sth3->fetchrow_hashref)
  {
    $ssrs_rowcnt++; 

    $ssrs_log_th = "dbamon_mssql.pl SSRS_Log: <tr bgcolor=cadetblue>"; 
    $ssrs_log_td = "dbamon_mssql.pl SSRS_Log: <tr bgcolor=cornsilk>"; 

    undef %thisrow; 

    #---- Process each COLUMN of this ROW
    foreach (sort keys %{$href} )
    {
      $href_colname = $_;   
      $href_value   = $href->{$href_colname};   
      ##$href_line   .= "$href_colname=$href_value ";
      ##print "DEBUG: $href_colname=$href_value\n"; 

      $fix_colname = substr($href_colname,3); 

      $thisrow{$fix_colname} = $href_value; 
     
      #---- Process STATUS column
      if ($fix_colname eq "Status")
      {
        if ($href_value ne "rsSuccess")
	{
	  $ssrs_this_color  = "pink"; 
          $ssrs_failed_reports++; 
	}
	else 
	{
	  $ssrs_this_color  = "lime"; 
          $ssrs_successful_reports++; 
	}
      }
      else 
      {
        $ssrs_this_color  = "cornsilk"; 
      }

      #---- Process STATUS column - this is a little tricky since we're selecting in descending order;
      if ($fix_colname eq "TimeEnd")
      {
        $ssrs_log_timestamp = $href_value if $ssrs_log_timestamp eq ""; 
        $ssrs_hi_ts         = $href_value if $ssrs_hi_ts eq ""; 
        $ssrs_lo_ts         = $href_value; 
        &msg("DEBUG - ssrs_lo_ts=$ssrs_lo_ts ssrs_hi_ts=$ssrs_hi_ts"); 
      }

      $ssrs_log_th .= "  <th $style_normal>$fix_colname "; 
      $ssrs_log_td .= "  <td bgcolor=$ssrs_this_color $style_normal>$href_value "; 
    }

    #---- We are done processing all of the COLUMNS of this ROW
    #---- If this row has a STATUS of FAIL (which would set ssrs_this_color to PINK) then 
    #----   save the details for later - for the FAILED REPORT(s) EVENT.
    
    ##&msg("DEBUG - last ts: $thisrow{'TimeEnd'} last status: $thisrow{'Status'}"); 
    
    if ($thisrow{'Status'} ne 'rsSuccess') 
    {
      &msg("Found failed report - Status=$thisrow{'Status'}"); 
      push(@ssrs_failed_reports, "TimeEnd=($thisrow{'TimeEnd'}) Status=($thisrow{'Status'}) ReportPath=($thisrow{'ReportPath'}) Username=($thisrow{'Username'})")
    }

    if ($ssrs_log_header_flag == 0) 
    {
      $ssrs_log_out .= $ssrs_log_th . "\n"; 
      $ssrs_log_header_flag = 1; 
    }
    
    #---- Always show the columns
    $ssrs_log_out .= $ssrs_log_td . "\n"; 
  }

  if ($ssrs_log_out ne "") 
  {
    &msg("Printing ssrs_log_out"); 
    print $ssrs_log_out; 
  }

  #---- Save the highest ENDTIME for next time
  $dcf_data{'SSRSLogBookmark'} = $ssrs_log_timestamp if $ssrs_log_timestamp =~ /^2/; 

  &dataReturn("SYSPERF: SSRS_Reports_Failed_Cnt_SLI  $ssrs_failed_reports"); 
  &dataReturn("SYSPERF: SSRS_Reports_Success_Cnt_SLI $ssrs_successful_reports"); 

  #---- See if there are any FAILED REPORTS
  if ($#ssrs_failed_reports > -1) 
  {
    &msg("SSRS Failed Reports Found:"); 
    foreach $this_failed_report (@ssrs_failed_reports) 
    {
      &dataReturn("SSRS_Failed_Report: $this_failed_report"); 
    }
  }

  &msg("Timestamp range: ssrs_lo_ts=$ssrs_lo_ts ssrs_hi_ts=$ssrs_hi_ts");
  &msg("checkSSRSLog - Done - ssrs_rowcnt=$ssrs_rowcnt ssrs_successful_reports=$ssrs_successful_reports ssrs_failed_reports=$ssrs_failed_reports ssrs_log_timestamp=$ssrs_log_timestamp");
}

# ----------------------------------------------------------------------
sub checkFilegroups
# ----------------------------------------------------------------------
{
  &msg("checkFilegroups - Starting - Checking filegroups");

  $debug_fg = 0;

  if ($WWW)
  {
    $debug_fg = 0;
  }

  &driveCheck;
  &connectDB if ! $dbh; 

  #---- Get list of ALL DBs
  #--- Old 
  #$dbh->do("use master") || &dbError("Use_Master");
  #$sql = "sp_helpdb";
  #--- New - Exclude SNAPSHOT DBs
  #--- New 2014/02/28 - Only INCLUDE ONLINE DBs 
  if ($vershort < 90)
  {
    $sql = "SELECT name FROM master..sysdatabases order by 1";
  }
  else
  {
    $sql = "SELECT name FROM master.sys.databases WHERE source_database_id IS null and state_desc = 'ONLINE' order by 1 ";
  }
  $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
  $sth3->execute() || &error("Could not execute sql=$sql");
  &msg("Listing DBs...") if $debug_fg; 
  while (@Data = $sth3->fetchrow_array)
  {
    &msg("  Found $Data[0]") if $debug_fg; 
    push(@db_list, $Data[0]);
  }

  #---- Process once for each DB

  &msg("Now processing each DB...") if $debug_fg; 
  foreach $this_db (@db_list)
  {
    $this_db_out = $this_db;
    $this_db_out =~ s/\s/[BLANK]/g;
    $this_db_out =~ s/\-/[HYPHEN]/g;
    &msg("  Processing this_db=$this_db this_db_out=$this_db_out") if $debug_fg; 

    if ($dbattrs_ext{$this_db}{user_access} eq "SINGLE_USER")
    {
      &msg("This DB ($this_db) is in SINGLE_USER Mode - Skipping to next DB"); 
      next; 
    }

    $sql = "sp_helpfilegroup";
    $dbh->do("use \[$this_db\]") || &dbError("Use_${this_db}");
    $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
    $sth3->execute() || &error("Could not execute sql=$sql");

    undef @fg_list;
    $selectcount = 0;
    ##&msg("  Listing filegroups..."); 
    while (@Data = $sth3->fetchrow_array)
    {
      $selectcount++;

      $fg_name    = $Data[0];
      $fg_groupid = $Data[1];
      $fg_filecnt = $Data[2];

      &msg("    Found fg_name=$fg_name fg_groupid=$fg_groupid fg_filecnt=$fg_filecnt") if $debug_fg;
      push(@fg_list, $fg_name);
    }
    $sth3->finish() || &dbError("Could not execute FINISH");
    &msg("    Found $selectcount filegroup(s)") if $debug_fg; 

    &msg("    Processing list of FGs") if $debug_fg; 
    foreach $this_fg (@fg_list)
    {
      &msg("      Processing this_fg=$this_fg") if $debug_fg; 
 
      $tot_pot_mb = $tot_size_mb = $tot_maxsize_mb = 0; 
      $tot_drive_list = "";
      $unl_flag = 0;
      $nogrow_flag = 0;

      $sql = "exec sp_helpfilegroup \@filegroupname='$this_fg'";
      $sth = $dbh->prepare("$sql") || &error("Prepare");
      $sth->execute || &error("Execute_Select");
      while(@Data = $sth->fetchrow_array or $sth->{odbc_more_results})
      {
        next if $#Data != 5;
	$fg_file_in_group = $Data[0];
	$fg_fileid        = $Data[1];
	$fg_filename      = $Data[2];
	$fg_size          = $Data[3];
	$fg_maxsize       = $Data[4];
	$fg_growth        = $Data[5];

        #---- In case we don't set this later
        $fg_maxsize_mb = -2;

        if ($fg_maxsize =~ /unlimited/i && $fg_growth eq "0 KB") 
        { 
          &msg("*** DB=$this_db_out FG=$this_fg - This FG is FIXED SIZE ***");   #---- if $debug_fg; 
          $nogrow_flag = 1;

          #$sth->finish || &dbError("Execute_Finish");
          #last;
        }
        elsif ($fg_maxsize =~ /unlimited/i) 
        { 
          &msg("*** DB=$this_db_out FG=$this_fg - This FG has at least 1 FILE with maxsize UNLIMITED ***") if $debug_fg; 
          $unl_flag = 1;

          #$sth->finish || &dbError("Execute_Finish");
          #last;
        }

        if ($fg_size =~ / KB$/) { $fg_size_mb = $fg_size; $fg_size_mb =~ s/\sKB$//; $fg_size_mb = sprintf("%.2f",($fg_size_mb / 1024)); }
        else { &error("Unknown UNITS 2584"); }

        #---- if ($unl_flag == 0)
        if ($unl_flag == 0 && $nogrow_flag == 0)
        {
	  if ($fg_maxsize =~ / KB$/) { $fg_maxsize_mb = $fg_maxsize; $fg_maxsize_mb =~ s/\sKB$//; $fg_maxsize_mb = sprintf("%.2f",($fg_maxsize_mb / 1024)); }
	  else { &error("Unknown UNITS 2588 - fg_maxsize=$fg_maxsize"); }
        }

        #---- B4 - 3.23
        ##if ($unl_flag) { $fg_potential_growth_mb = -1; }
        ####else         { $fg_potential_growth_mb = $fg_maxsize_mb - $fg_size_mb; }
        ##else           { $fg_potential_growth_mb = $fg_maxsize_mb - $fg_size_mb if $fg_maxsize_mb > $fg_size_mb; }   #---- HEREITIS 2.26
        #---- After - 3.23 - For nogrow files, it was just using the last value of $fg_potential_growth_mb which is WRONG
        if    ($unl_flag)                     { $fg_potential_growth_mb = -1; }
        elsif ($nogrow_flag)                  { $fg_potential_growth_mb = 0; }
        elsif ($fg_maxsize_mb > $fg_size_mb)  { $fg_potential_growth_mb = $fg_maxsize_mb - $fg_size_mb; }
        else                                  { $fg_potential_growth_mb = 0; }

        $fg_drive = uc substr($fg_filename,0,1); 

	&msg("        FG - Found fg_filename=$fg_filename") if $debug_fg; 
	&msg("        FG -   fg_size_mb=$fg_size_mb fg_maxsize_mb=$fg_maxsize_mb fg_potential_growth_mb=$fg_potential_growth_mb fg_drive=$fg_drive") if $debug_fg; 

        $tot_drive_list .= $fg_drive; 
        $tot_pot_mb     += $fg_potential_growth_mb;
        $tot_size_mb    += $fg_size_mb;
        $tot_maxsize_mb += $fg_maxsize_mb unless $unl_flag;

        $drive_pot_growth{$fg_drive} += $fg_potential_growth_mb if $fg_potential_growth_mb > 0; 
      }
      $sth->finish || &dbError("Execute_Finish");

      $tot_pct_full_vs_max = -1; 

      #---- OLD 2012/03/03
      ## $tot_pct_full_vs_max = sprintf("%.2f", (($tot_size_mb / $tot_maxsize_mb) * 100)) if $tot_maxsize_mb > 0; 
      #---- NEW 2012/03/03
      $tot_pct_full_vs_max    = sprintf("%.2f", (($tot_size_mb / $tot_maxsize_mb) * 100)) if $tot_maxsize_mb > 0 and $tot_maxsize_mb >= $tot_size_mb;  #---- HEREITIS2 2.26

      &msg("      END OF FG Processing - this_fg=$this_fg - tot_size_mb=$tot_size_mb tot_maxsize_mb=$tot_maxsize_mb tot_pct_full_vs_max=$tot_pct_full_vs_max") if $debug_fg; 
      push(@fg_display_list, sprintf("%-40s %-16s %16s %16s %14.2f %17s %8s",$this_db_out,$this_fg,$tot_size_mb,$tot_maxsize_mb,$tot_pct_full_vs_max,$tot_pot_mb, $tot_drive_list)); 
    }
  }

  if ($WWW)
  {
    foreach (@fg_display_list)
    {
      @words = split;
      $fg_db          = $words[0]; 
      $fg_fg          = $words[1]; 
      $fg_totsize     = $words[2]; 
      $fg_maxsize     = $words[3]; 
      $fg_pct_vs_max  = $words[4]; 
      $fg_pot_growth  = $words[5]; 
      $fg_drive       = $words[6]; 

      $fg_filecount = length($fg_drive); 

      if ($fg_pct_vs_max == -1) 
      { 
        $fg_pct_vs_max = "(At least 1 DF is MAXSIZE=Unlimited)"; 
        $color = "white"; 
        $fg_pot_growth  = "N/A"; 
      }
      else 
      { 
        if    ($fg_pct_vs_max < 80) { $color = "lime"; }
        elsif ($fg_pct_vs_max < 90) { $color = "yellow"; }
        else  { $color = "pink"; }
        
        $fg_pct_vs_max .= "%"; 
      } 

      if (! $fg_heading)
      {
	print "<br>\n";
	&msg("Filegroup Status (UC):");
	print "<br><table border=1 bgcolor=skyblue class=c1>\n";
	print "<tr bgcolor=slate>
	  <th $style_normal>Database 
	  <th $style_normal>Filegroup 
	  <th $style_normal>File Count 
	  <th $style_normal>Total<br> DB File<br> Size <br>(mB)
	  <th $style_normal>Max.<br> DB File<br> Size <br>(mB)
	  <th $style_normal>Percent Used<br>vs.<br>Max. Size 
	  <th $style_normal>Potential Growth<br>This FG<br>(mB)
	  <th $style_normal>Drive List<br>For This<br>FG 
	\n";
        $fg_heading = 1;
      }

      print "<tr bgcolor=$color>
	    <td $style_normal> <b> $fg_db </b>
	    <td $style_normal> <b> $fg_fg </b>
	    <td $style_normal align=right> $fg_filecount
	    <td $style_normal align=right> $fg_totsize
	    <td $style_normal align=right> $fg_maxsize 
	    <td $style_normal align=right> $fg_pct_vs_max
	    <td $style_normal align=right> $fg_pot_growth
	    <td  $style_normal> $fg_drive
	  \n";
    }
    print "</table><br>\n"; 

    #---- Display drive growth potential
    foreach $this_drive (sort keys %drive_pot_growth)
    {
      if (! $fgdr_heading)
      {
	print "<br>\n";
	&msg("Potential Growth By Drive:");
	print "<br><table border=1 bgcolor=skyblue class=c1>\n";
	print "<tr bgcolor=slate>
	  <th $style_normal>Drive 
	  <th $style_normal>Potential Growth<br>This Drive<br>(mB)
	  <th $style_normal>Free Space <br>This Drive<br>(mB)
	  <th $style_normal>Status
	";
        $fgdr_heading = 1;
      }

      if ($drive_pot_growth{$this_drive} >  $disk_free_mb{$this_drive}) 
      {
        $color = "pink"; 
        $zmsg = "DB Files could grow beyond Free Space for drive $this_drive:"; 
      }
      else
      {
        $color = "lime"; 
        $zmsg = "DB Files could NOT grow beyond Free Space for drive $this_drive:"; 
      }
      print "<tr bgcolor=$color>
	    <td $style_normal> <b> $this_drive
	    <td $style_normal align=right> $drive_pot_growth{$this_drive} 
	    <td $style_normal align=right> $disk_free_mb{$this_drive} 
	    <td $style_normal> <b> $zmsg
	  \n";
    }
    print "</table><br>\n"; 
  }
  else
  {
    &msg("FG Final Results:"); 
    print "#Legend:                 DBName                                   FGName                TotalSizeMB        MaxSizeMB   PctFullvsMax PotentialGrowthMB    Drive\n"; 
    print "#Legend: (MaxSizeMB is -1 if any DFs are MAXUNLIMITED) PctFullvsMax\n"; 
    foreach $this_line (@fg_display_list)
    {
      print "$P FG_ITEM: $this_line\n"; 
    }
    &msg("FG Drive Growth Results:"); 
    print "#Legend:                 Drive     PotGrowthMB     FreeMB\n"; 
    foreach $this_drive (sort keys %drive_pot_growth)
    {
      print "$P FG_DRIVE_GROWTH: $this_drive $drive_pot_growth{$this_drive} $disk_free_mb{$this_drive}\n"; 
    }
  }

  &msg("checkFilegroups - Done");   
}

# ----------------------------------------------------------------------
sub checkDBMail
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("checkDBMail - Checking DBMail Status (SQL2005+ only)");

  if ($vershort < 90)
  {
    &msg("This check only works for DBMAIL (SQL >= 2005) - Returning"); 
    return;
  }

  #---- Check DBMAIL process status
  #&msg("  Checking to see if DBMAIL is ENABLED");
  ##$dbh->do("exec sp_configure 'show advanced options',1")       || &dbError("Do_4350");
  ##$sth = $dbh->prepare("exec sp_configure 'Database Mail XPs'") || &dbError("Prepare_L4350");
  #$sth = $dbh->prepare("exec sp_configure 'show advanced options',1; exec sp_configure 'Database Mail XPs'") || &dbError("Prepare_L4350");
  #$sth->execute || &dbErrorOK("Execute_4351");
  #while($href = $sth->fetchrow_hashref)
  #{
  #  &msg("  Found row"); 
  #  $dbmail_enabled = $href->{run_value}; 
  #}
  #&msg("  Resulting dbmail_enabled=$dbmail_enabled");

  #---- Look at last line of DBMAIL log table
  $sql = "SELECT
      sent_date,
      sent_status
    FROM
      msdb..sysmail_allitems (NOLOCK)
    WHERE
      sent_date = (SELECT MAX(sent_date) FROM msdb..sysmail_allitems)
    ORDER BY
      1
  "; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L3546");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");
  $mail_row_cnt = 0; 
  $sent_status = ""; 
  while($href = $sth->fetchrow_hashref)
  {
    $mail_row_cnt++;
    $sent_date    = $href->{sent_date}; 
    $sent_status  = $href->{sent_status}; 
    &msg("  Found sent_date=$sent_date sent_status=$sent_status");
  }
  $sent_status = "?" if $sent_status eq ""; 

  #---- Check DBMAIL process status
  if ($sent_status ne "?")
  {
    &msg("  Checking DBMAIL status by running sysmail_help_status_sp");
    $sth = $dbh->prepare("EXEC msdb.dbo.sysmail_help_status_sp;") || &dbError("Prepare_L4382");
    $sth->execute || &dbErrorOK("Execute_4383");
    $dbmail_status = "?"; 
    while($href = $sth->fetchrow_hashref)
    {
      $dbmail_status  = $href->{Status}; 
    }
    &msg("  Resulting dbmail_status=$dbmail_status");
  }

  if    ($sent_status eq "?")         { $zstat = "OK - Possibly_Not_Configured"; }
  elsif ($sent_status eq "sent")      { $zstat = "OK - (sent_status=$sent_status)"; }
  elsif ($dbmail_status eq "STOPPED") { $zstat = "NG - DBMAIL_Is_Stopped_(sent_status=$sent_status)"; }
  else                                { $zstat = "NG - (sent_status=$sent_status)"; }

  &msg("  Most recent status: $zstat"); 
  print "$P DBMAIL_STATUS: $zstat\n"; 

  &msg("checkDBMail - Done - Found $mail_row_cnt rows in SYSMAIL_ALLITEMS");
}

# ----------------------------------------------------------------------
sub checkLRBackup
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("checkLRBackup - Looking for LONG RUNNING BACKUPs");

  $sql = "SELECT
    DATEDIFF(hh,login_time,GETDATE()) AS Process_Age_Hours
    ,spid as SPID
  FROM master..sysprocesses
  WHERE
    UPPER(cmd) LIKE '%BACKUP%'
    and spid > 50
  ORDER BY
    1 
  "; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L3546");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

  $backup_rowcnt = 0; 
  $sent_status = ""; 

  while($href = $sth->fetchrow_hashref)
  {
    $backup_rowcnt++;

    $href_line = ""; 
    foreach (sort keys %{$href} )
    {
      $href_colname = $_;   
      $href_value   = $href->{$href_colname};   
      $href_line   .= "$href_colname=$href_value ";
    }
    &msg("  Found BACKUP process - $href_line");

    $last_process_age_hours = $href->{Process_Age_Hours}; 
    &msg("    Age of this BACKUP process (in hours): $last_process_age_hours"); 
  }

  if ($backup_rowcnt == 0)
  {
    $last_process_age_hours = -1; 
    $href_line = "(No backups running)"; 
  }
  
  &msg("Results - SQL process details of oldest backup process: $href_line"); 
  print "$P LRBACKUP_AGE_DET: $href_line\n"; 
  &msg("Results - Age (hours) of oldest backup process: $last_process_age_hours"); 
  print "$P LRBACKUP_AGE_HRS: $last_process_age_hours\n"; 

  &dataReturn("SYSPERF: SQL_Backup_Running_Hrs $last_process_age_hours"); 

  &msg("checkLRBackup - Done - Found $backup_rowcnt total BACKUPs running");
}

# ----------------------------------------------------------------------
sub checkTLOGMultiFile
# ----------------------------------------------------------------------
{
  &msg("checkTLOGMultiFile - Looking for LONG RUNNING BACKUPs");

  if ($vershort < 90) 
  {
    &msg("This only works for SQL 2005+ - Skipping"); 
    return;
  }

  $sql = "SELECT
    DB_NAME(database_id) AS DB_Name,
    COUNT(*) Num_TLog_Files
  FROM    sys.master_files
  WHERE   type_Desc = 'LOG'
  GROUP BY database_id
  HAVING  COUNT(*) > 1
  "; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L3546");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

  $rowcnt = 0; 

  while(@Data = $sth->fetchrow_array)
  {
    $rowcnt++;

    $tm_dbname      = shift(@Data); 
    $tm_tlogfilecnt = shift(@Data); 

    &dataReturn("TLOGMultiFile: $tm_dbname $tm_tlogfilecnt"); 
  }

  &msg("checkTLOGMultiFile - Done - Found $rowcnt DBs with more than 1 TLOG file");
}

# ----------------------------------------------------------------------
sub checkTempDBContention
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("checkTempDBContention - Looking for sessions waiting on PAGELATCH* on TEMPDB");

  if ($vershort < 90) 
  {
    &msg("This only works for SQL 2005+ - Skipping"); 
    return;
  }

  $sql = "SELECT 
    CASE
      WHEN CAST(RIGHT(a.resource_description,
                      LEN(a.resource_description)
                      - CHARINDEX(':', a.resource_description, 3)) AS INT)
           - 1 % 8088 = 0 THEN 'PFS'
      WHEN CAST(RIGHT(a.resource_description,
                      LEN(a.resource_description)
                      - CHARINDEX(':', a.resource_description, 3)) AS INT)
           - 2 % 511232 = 0 THEN 'GAM'
      WHEN CAST(RIGHT(a.resource_description,
                      LEN(a.resource_description)
                      - CHARINDEX(':', a.resource_description, 3)) AS INT)
           - 3 % 511232 = 0 THEN 'SGAM'
      ELSE 'Other'
	  END as resourcetype,
	  a.session_id,
    a.wait_type,
    a.wait_duration_ms,
    a.blocking_session_id,
    a.resource_description
    --c.text AS SQLText
  FROM sys.dm_os_waiting_tasks a with (NOLOCK)
  INNER JOIN sys.sysprocesses b with (NOLOCK)
  ON
    a.session_id = b.spid
  --OUTER APPLY sys.dm_exec_sql_text(b.sql_handle) c
  WHERE a.wait_type LIKE 'PAGE%LATCH_%'
    AND a.resource_description LIKE '2:%';
  "; 

  &msg("DEBUG - sql=$sql"); 

  &msg("DEBUG - Running USE MASTER"); 
  $dbh->do("use master")     || &dbError("Use_Master_1");

  &msg("DEBUG - Preparing SQL"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5948");
  $sth->execute || &dbErrorOK("Execute_L5949");

  my %tempdb_pagetype_cnt = ();
  my $rowcount = 0; 

  while($href = $sth->fetchrow_hashref)
  {
    $rowcount++; 
    $href_line = ""; 

    foreach (sort keys %{$href} )
    {
      $href_colname = $_;   
      $href_value   = $href->{$href_colname};   
      $href_line   .= "$href_colname=$href_value ";
    }

    $tempdb_pagetype = $href->{'resourcetype'};   
    $tempdb_pagetype_cnt{$tempdb_pagetype}++; 

    &msg("  Found TEMPDB Contention - tempdb_pagetype=$tempdb_pagetype - $href_line");
  }

  foreach $this_pagetype (sort keys %tempdb_pagetype_cnt)
  {
    &dataReturn("SYSPERF: SQL_TempDBContention_${this_pagetype} $tempdb_pagetype_cnt{$this_pagetype}"); 
  }
  
  &msg("checkTempDBContention - Done - Found $rowcount total Waiting Sessions");
}

# ----------------------------------------------------------------------
sub checkTempDBIOBalance
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("checkTempDBIOBalance - Looking for sessions waiting on PAGELATCH* on TEMPDB");

  if ($vershort < 90) 
  {
    &msg("This only works for SQL 2005+ - Skipping"); 
    return;
  }

  $sql = "SELECT 
    ( 1.00 * max.max_value / min.min_value ) * 100 AS Max_vs_Min_as_Percent ,
    MAX.max_value AS Max_IO_Count ,
    MIN.min_value AS Min_IO_Count
  FROM    ( SELECT    MAX(num_of_writes) AS max_value
      FROM      sys.dm_io_virtual_file_stats(NULL, NULL) dm ,
		sys.master_files mf
      WHERE     mf.database_id = dm.database_id
		AND mf.FILE_ID = dm.file_id
		AND dm.database_id = 2
		AND mf.type_desc = 'ROWS'
    ) max ,
    ( SELECT    MIN(num_of_writes) AS min_value
      FROM      sys.dm_io_virtual_file_stats(NULL, NULL) dm ,
		sys.master_files mf
      WHERE     mf.database_id = dm.database_id
		AND mf.FILE_ID = dm.file_id
		AND dm.database_id = 2
		AND mf.type_desc = 'ROWS'
    ) min "; 

  &msg("DEBUG - sql=$sql"); 

  $dbh->do("use tempdb") || &dbError("Use_TEMPDB_L6012");
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5948");
  $sth->execute || &dbErrorOK("Execute_L5949");

  my $rowcount = 0; 
  while(@Data = $sth->fetchrow_array)
  {
    $rowcount++; 

    $iobal_pct      = shift(@Data); 
    $iobal_maxcnt   = shift(@Data); 
    $iobal_mincnt   = shift(@Data); 
    
    &msg("  TEMPDB IOBalance - iobal_pct=$iobal_pct iobal_maxcnt=$iobal_maxcnt iobal_mincnt=$iobal_mincnt");
  }

  #---- We only want to report the $iobal_pct if there are at least 50000 writes (busyest file). 
  if ($iobal_maxcnt < 5000) { $iobal_pct = 0; } 

  #---- We are getting some crazy values for *PCT, so let's try to cap this at 250
  if ($iobal_pct > 250) { $iobal_pct = 250; } 

  &dataReturn("SYSPERF: SQL_TempDB_IOBalance_Pct $iobal_pct"); 
  &dataReturn("SYSPERF: SQL_TempDB_IOBalance_Max $iobal_maxcnt"); 
  &dataReturn("SYSPERF: SQL_TempDB_IOBalance_Min $iobal_mincnt"); 
  
  #---- Put this back
  $dbh->do("use master") || &dbError("Use_Master");

  &msg("checkTempDBIOBalance - Done - Found $rowcount rows");
}

# ----------------------------------------------------------------------
sub checkDrivesForPerf
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("checkDrivesForPerf - Looking for the lowest drive letter for TEMPDB DB files");

  if ($vershort < 90) 
  {
    &msg("This only works for SQL 2005+ - Skipping"); 
    return;
  }

  $sql = "select distinct
    substring(physical_name,1,2) from master.sys.master_files
    order by 1"; 

  &msg("DEBUG - sql=$sql"); 

  $dbh->do("use tempdb") || &dbError("Use_TEMPDB_L6012");
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5948");
  $sth->execute || &dbErrorOK("Execute_L5949");

  my $rowcount = 0; 
  while(@Data = $sth->fetchrow_array)
  {
    $rowcount++; 

    $this_drive      = shift(@Data); 
    &msg("  this_drive=$this_drive");

    if (substr($this_drive,1,1) ne ":") 
    {
      &msg("This drive does not have : in the 2nd position - Skipping"); 
      next;
    }
    
    $this_drive_1      = substr($this_drive,0,1);

    $cfg_perfcounter{"\\logicaldisk($this_drive)\\disk bytes/sec"}  = "Disk_${this_drive_1}_Bytes_PerSec"; 
    $cfg_perfcounter{"\\logicaldisk($this_drive)\\disk reads/sec"}  = "Disk_${this_drive_1}_Reads_PerSec"; 
    $cfg_perfcounter{"\\logicaldisk($this_drive)\\disk writes/sec"} = "Disk_${this_drive_1}_Writes_PerSec"; 
    $cfg_perfcounter{"\\logicaldisk($this_drive)\\avg. disk sec/transfer"} = "Disk_${this_drive_1}_Avg_RTMSMULT1000"; 
    $cfg_perfcounter{"\\logicaldisk($this_drive)\\avg. disk queue length"} = "Disk_${this_drive_1}_Avg_Queue_Len"; 
    $cfg_perfcounter{"\\logicaldisk($this_drive)\\split IO/sec"} = "Disk_${this_drive_1}_Split_IO_PerSec"; 
    $cfg_perfcounter{"\\logicaldisk($this_drive)\\% disk time"}            = "Disk_${this_drive_1}_Pct_Busy"; 
    $cfg_perfcounter{"\\logicaldisk($this_drive)\\% disk read time"}       = "Disk_${this_drive_1}_Pct_Busy_Read"; 
    $cfg_perfcounter{"\\logicaldisk($this_drive)\\% disk write time"}      = "Disk_${this_drive_1}_Pct_Busy_Write"; 
  }

  &msg("checkDrivesForPerf - Done - Found $rowcount rows");
}

# ----------------------------------------------------------------------
sub checkPrimeTimeLRC
# ----------------------------------------------------------------------
# Look for CHECKDB or BACKUP-FULL or BACKUP-DIFFERENTIAL running during
#   prime time (0700 - 1700) 
# ----------------------------------------------------------------------
{
  $lrc_min_t = 30; 
  &msg("checkPrimeTimeLRC - Looking for LONG RUNNING commands running during PRIME TIME");

  if ($rq_mssql_prime_time_lrc_check eq "N")
  {
    &msg("rq_mssql_prime_time_lrc_check=$rq_mssql_prime_time_lrc_check, So exiting"); 
    return; 
  }

  #---- Old
  #$z1 = &get_date("Y/M/D-H:M:S");
  #$now_hhmm = substr($z1,11,5); 
  #($zsec, $zmin, $zhr, $zday, $zmonth, $zyear, $now_weekday, $zdayofyr, $zjunk_yuk) = localtime(time);
  #&msg("now_hhmm=$now_hhmm now_weekday=$now_weekday"); 
  #if ($now_hhmm ge "08:00" && $now_hhmm le "17:00" && $now_weekday != 0 && $now_weekday != 6)  
  #{ 
  #  &msg("This is PRIME TIME WEEKDAY - Continuing"); 
  #} 
  #else                                               
  #{
  #  &msg("This is NOT PRIME TIME WEEKDAY - Exiting"); 
  #  return 0;
  #} 
  #---- New
  if ($target_shift ne "P") 
  {
    &msg("This is NOT Prime Shift (PRIME TIME WEEKDAY) - Returning"); 
    return 0;
  } 

  $sql = "SELECT distinct
    upper(cmd) AS Command, 
    login_time AS CMD_Start_Time,
    DATEDIFF(hh,login_time,GETDATE()) AS Process_Age_Hours,
    DATEDIFF(mi,login_time,GETDATE()) AS Process_Age_Mins,
    spid as SPID
  FROM 
    master..sysprocesses
  WHERE
    spid > 50
    and DATEDIFF(mi,login_time,GETDATE()) >= $lrc_min_t 
    and 
    (UPPER(cmd) LIKE '%BACKUP%' or 
     UPPER(cmd) LIKE '%DBCC%CHECK%')
    and UPPER(cmd) not LIKE '%BACKUP%LOG%'
  ORDER BY 1 "; 

  $sth = $dbh->prepare($sql) || &dbError("Prepare_L3546");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

  $pt_rowcnt = 0; 

  while($href = $sth->fetchrow_hashref)
  {
    $pt_rowcnt++;

    $href_line = ""; 
    foreach (sort keys %{$href} )
    {
      $href_colname = $_;   
      $href_value   = $href->{$href_colname};   
      $href_line   .= "$href_colname=$href_value ";
    }

    &msg("  Found Prime Time process - $href_line");
    &dataReturn("Prime_Time_LRC: ThresholdMins=$lrc_min_t $href_line"); 
  }

  &dataReturn("SYSPERF: SQL_Prime_LRC_Count $pt_rowcnt") if $pt_rowcnt > 0; 

  &msg("checkPrimeTimeLRC - Done - Found $pt_rowcnt total Long Running commands running");
}

# ----------------------------------------------------------------------
sub checkSuspectPages
# ----------------------------------------------------------------------
{
  &msg("checkSuspectPages - Looking for rows in MSDB..SUSPECT_PAGES");

  if ($vershort < 90) 
  {
    &msg("This only works for SQL 2005+ - Skipping"); 
    return;
  }
  
  $sql = "select
  database_id FROM msdb..suspect_pages WHERE (event_type = 1 OR event_type = 2 OR event_type = 3);
  "; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L3546");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

  my $suspect_rowcnt = 0; 
  while($href = $sth->fetchrow_hashref)
  {
    $suspect_rowcnt++;
  }

  if ($suspect_rowcnt > 0) 
  {
    &msg("$suspect_rowcnt rows found - VERY BAD - Investigate immediately"); 
    print "$P SUSPECT_ROWCNT: $suspect_rowcnt\n"; 
  }
  else
  {
    &msg("No rows found - GOOD"); 
  }
  
  &msg("checkSuspectPages - Done - Found $suspect_rowcnt total SUSPECT_PAGES rows");
}

# ----------------------------------------------------------------------
sub checkSignalWait
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("checkSignalWait - A performance check");

  if ($vershort < 90) 
  {
    &msg("This only works for SQL 2005+ - Skipping"); 
    return;
  }
  
  #---- 3.27 - Updated the idle waits from SQLSkills: http://www.sqlskills.com/blogs/paul/wait-statistics-or-please-tell-me-where-it-hurts/
  $sql = "SELECT
            signal_wait_time_ms = SUM(signal_wait_time_ms) ,
	    '%signal waits' = CAST(100.0 * SUM(signal_wait_time_ms)
	    / SUM(wait_time_ms) AS NUMERIC(20, 2)) ,
	    resource_wait_time_ms = SUM(wait_time_ms - signal_wait_time_ms) ,
	    '%resource waits' = CAST(100.0 * SUM(wait_time_ms
						 - signal_wait_time_ms)
	    / SUM(wait_time_ms) AS NUMERIC(20, 2))
    FROM    master.sys.dm_os_wait_stats
    WHERE   wait_type NOT IN 
    $idle_waits
  "; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L4522");
  $sth->execute              || &dbErrorOK("Execute_L4523 helpdb db=$dbname");

  $rowcnt = 0; 
  while (@Data = $sth->fetchrow_array)
  {
    $rowcnt++; 
    $signal_wait_time_ms   = shift(@Data); 
    $signal_wait_pct       = shift(@Data); 
    $resource_wait_time_ms = shift(@Data); 
    $resource_wait_pct     = shift(@Data); 
  }
  &msg("  Rows retreived: $rowcnt"); 

  &msg("  Results:"); 
  &msg("    signal_wait_time_ms=  $signal_wait_time_ms"); 
  &msg("    signal_wait_pct=      $signal_wait_pct"); 
  &msg("    resource_wait_time_ms=$resource_wait_time_ms"); 
  &msg("    resource_wait_pct=    $resource_wait_pct"); 

  &msg("PHONEHOME: checkSignalWait_-_Signal+Resource_wait_!=_100") if ($signal_wait_pct + $resource_wait_pct) != 100; 

  #---- I guess this isn't needed
  ##&dataReturn("SYSPERF: SQL_SignalWait_Pct $signal_wait_pct"); 

  if ($resource_wait_pct > 0) 
  {
    print "$P SIGNAL_Wait_Pct: $signal_wait_pct\n"; 
  }
  else
  {
    &msg("No SIGNAL WAIT response"); 
  }
  
  &msg("checkSignalWait - Done");
}

# ----------------------------------------------------------------------
sub checkBackupAgeFull
# ----------------------------------------------------------------------
{
  &msg("checkBackupAgeFull - Starting");

  #---- If this is an AO cluster, only take backups readings under certain conditions
  if ($ao_readings{'HADR_Backup_Pref'} eq "secondary" && $ao_readings{'HADR_Role'} ne "SECONDARY") 
  {
    &msg("Since this IS and AO Cluster with Backup_Pref=secondary -and- This is NOT the secondary node, skipping backup checking"); 
    return;
  }

  #---- Process DB names
  foreach $dbname (@dblist)
  {
    $dbname_out  = $dbname;
    $dbname_out  =~ s/\s/[BLANK]/g;
    $dbname_out  =~ s/\-/[HYPHEN]/g;

    $sql = "select
	      substring(database_name,1,16) as db,
	      max(backup_finish_date) as maxdate,
	      datediff(day, max(backup_finish_date), getdate()) as days_since
	   from
              backupset
	   where
	      type in ('D')
	      and database_name = '$dbname'
	   group by
	      database_name 
           order by 1, 3 desc";

    $dbh->do("use msdb")         || &dbError("Use_MSDB2");
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute                || &dbError("Execute_Select");

    while (@Data = $sth->fetchrow_array)
    {
      $db      = $Data[0];
      $bckts   = $Data[1];
      $bckage  = $Data[2];

      $bckts   =~ s/\-/\//g;
      $bckts   =~ s/\s/\-/g;

      &dataReturn("BckAgeFullDays: $dbname_out $bckage $bckts");
    }
  }

  &msg("checkBackupAgeFull - Done");
}

# ----------------------------------------------------------------------
sub checkReorgAge
# ----------------------------------------------------------------------
{
  &msg("checkReorgAge - Starting");
  $t_reorg_days = 15; 
  $debug_ra = 0; 

  &msg("Looking for the right DB...");
  #---- Process DB names
  $this_dbname = ""; 
  foreach $dbname (@dblist)
  {
    $dbname = uc $dbname;
    if ($dbname =~ /^CICE/) 
    { 
      $this_dbname = $dbname; 
      last; 
    }
  }
  &msg("Resulting this_dbname=$this_dbname");
 
  if ($this_dbname eq "") 
  {
    &msg("Did not find the magic DB name - returning"); 
    return;
  }

  #---- Look for a table that we will need later (for checkRJ)
  &msg("Looking for RJ_Log"); 
  $sql = "select count(*) from $this_dbname.INFORMATION_SCHEMA.TABLES where table_name = 'RJ_Log'"; 
  &msg("DEBUG0a - sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7349");
  $sth->execute || &dbErrorOK("Execute_L7350");

  $cice_rj_log = -1; 
  while (@Data = $sth->fetchrow_array)
  {
    &msg("DEBUG0b data0=$Data[0]") if $debug_ra;
    $cice_rj_log = $Data[0]; 
  }
  &msg("Resulting cice_rj_log=$cice_rj_log");

  #---- Look for a table that we will need later (for checkCDNS)
  &msg("Looking for NSS_Log"); 
  $sql = "select count(*) from $this_dbname.INFORMATION_SCHEMA.TABLES where table_name = 'NSS_Log'"; 
  &msg("DEBUG0a - sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7349");
  $sth->execute || &dbErrorOK("Execute_L7350");

  $cice_nss_log = -1; 
  while (@Data = $sth->fetchrow_array)
  {
    &msg("DEBUG0b data0=$Data[0]") if $debug_ra;
    $cice_nss_log = $Data[0]; 
  }
  &msg("Resulting cice_nss_log=$cice_nss_log");

  #---- Look for a table that we will need later (for checkCDSF)
  &msg("Looking for SFS_Log"); 
  $sql = "select count(*) from $this_dbname.INFORMATION_SCHEMA.TABLES where table_name = 'SFS_Log'"; 
  &msg("DEBUG0a - sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7349");
  $sth->execute || &dbErrorOK("Execute_L7350");

  $cice_sfs_log = -1; 
  while (@Data = $sth->fetchrow_array)
  {
    &msg("DEBUG0b data0=$Data[0]") if $debug_ra;
    $cice_sfs_log = $Data[0]; 
  }
  &msg("Resulting cice_sfs_log=$cice_sfs_log");

  #---- Now see if this DB has the table that I'm looking for
  $sql = " select count(*) from $this_dbname.INFORMATION_SCHEMA.TABLES where table_name = 'RebuildReorgIndexesLog' "; 
  &msg("DEBUG - sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7149");
  $sth->execute || &dbErrorOK("Execute_L7150");

  my $table_count = -1; 
  while (@Data = $sth->fetchrow_array)
  {
    &msg("DEBUG data0=$Data[0]") if $debug_ra;
    $table_count = $Data[0]; 
  }
  &msg("Resulting table_count=$table_count");

  if ($table_count != 1) 
  {
    &msg("Did not find the magic Table name - returning"); 
    return;
  }

  #---- Collect the results from the log table
  $sql = " 
  SELECT db.name
      ,DATEDIFF(hh, last_rebuild_ts, GETDATE()) / 24.0 AS Rebuild_Indexes_Days_Since
  FROM (SELECT DISTINCT
        UPPER(name) AS name
        FROM sys.databases
        WHERE source_database_id IS NULL -- Exclude Snapshot DBs
       ) AS db
  LEFT OUTER JOIN (SELECT UPPER(databasename) AS databasename
                         ,MAX(logtime) AS last_rebuild_ts
                     FROM [CICentral].[odba].[RebuildReorgIndexesLog]
                    GROUP BY UPPER(databasename)
                  ) AS rl
    ON db.name = rl.databasename
  --WHERE db.name NOT IN ( 'MODEL', 'TEMPDB', 'REPORTSERVERTEMPDB' )
  WHERE db.name NOT IN ( 'MODEL', 'TEMPDB')
    AND db.name NOT LIKE 'REPORTSERVER%TEMPDB'
  ORDER BY 1
  "; 
  ##&msg("DEBUG - sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7149");
  $sth->execute || &dbErrorOK("Execute_L7150");

  while (@Data = $sth->fetchrow_array)
  {
    $re_dbname = $Data[0]; 
    $re_age    = $Data[1]; 

    $re_dbname_uc = uc $re_dbname;

    #---- No event if this DB is in read-only mode
    if ($readOnlyDBs{$re_dbname_uc} == 1)
    {
      &msg("Skipping this DB because it is READ_ONLY"); 
      next;
    }

    #---- Edits
    $re_age = -1 if $re_age eq ""; 
    &msg("DEBUG re_dbname=$re_dbname re_age=$re_age") if $debug_ra;

    #---- Check against threshold
    if ($re_age >= $t_reorg_days || $re_age == -1)
    {
      if ($re_age == -1 ) { $zval = "(Never)"; }
      else                { $zval = $re_age; }
     
      &dataReturn("AUTOREORGAGE: Database=$re_dbname  DaysSinceLastAutoReorg=$zval  Threshold=$t_reorg_days (Days)"); 
    }
  }

  &msg("checkReorgAge - Done");
}

# ----------------------------------------------------------------------
sub checkBackupDBFull
# ----------------------------------------------------------------------
{
  &msg("checkBackupDBFull - Looking for DBs NOT in SIMPLE logging and with NO TLOG backups");

  if ($vershort < 90) 
  {
    &msg("This only works for SQL 2005+ - Skipping"); 
    return;
  }
  
  #---- If this is an AO cluster, only take backups readings under certain conditions
  if ($ao_readings{'HADR_Backup_Pref'} eq "secondary" && $ao_readings{'HADR_Role'} ne "SECONDARY") 
  {
    &msg("Since this IS and AO Cluster with Backup_Pref=secondary -and- This is NOT the secondary node, skipping backup checking"); 
    return;
  }

  $sql = "SELECT  name
FROM    master.sys.databases
WHERE   recovery_model_desc != 'SIMPLE'
        AND is_read_only = 0
        and state_desc != 'RESTORING' 
        AND name NOT IN (
        SELECT  DISTINCT
                database_name
        FROM    [msdb].[dbo].[backupset]
        WHERE   type = 'L'
                AND backup_start_date > DATEADD(dd, -30, GETDATE()) )
  "; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L3546");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

  my $db_list  = ""; 
  my $db_count = 0; 
  while (@Data = $sth->fetchrow_array)
  {
    $db_count++;
    $db_list .= "$Data[0],"; 
  }

  if ($db_count > 0) 
  {
    $db_list =~ s/\s//g;
    $db_list =~ s/,$//g;
    &msg("$db_count DBs found - db_list=$db_list"); 
    print "$P DBS_FULL_LOGGING_NO_TLOG_BACKUP: $db_count $db_list\n"; 
  }
  else
  {
    &msg("No rows found - GOOD"); 
  }
  
  &msg("checkBackupDBFull - Done - Found $db_count DBs in exception status");
}

# ----------------------------------------------------------------------
sub checkVLF
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("checkVLF - Counting VLFs for each DB");

  $sql = "if OBJECT_ID('tempdb..#dbamon_vlf_stage') > 0 BEGIN
      drop table #dbamon_vlf_stage
    END"; 
  $dbh->do("$sql") || &dbError("Drop_If_L4697");
  $sql = "if OBJECT_ID('tempdb..#dbamon_vlf_results') > 0 BEGIN
      drop table #dbamon_vlf_results
    END"; 
  $dbh->do("$sql") || &dbError("Drop_If_L4701");
  if ($vershort < 110) 
  {
    $sql = "CREATE TABLE #dbamon_vlf_stage
	(
	  FileID INT ,
	  FileSize BIGINT ,
	  StartOffset BIGINT ,
	  FSeqNo BIGINT ,
	  [Status] BIGINT ,
	  Parity BIGINT ,
	  CreateLSN NUMERIC(38)
	) ;"; 
  }
  else
  {
    $sql = "CREATE TABLE #dbamon_vlf_stage
	(
	  RecoveryUnitID BIGINT ,
	  FileID INT ,
	  FileSize BIGINT ,
	  StartOffset BIGINT ,
	  FSeqNo BIGINT ,
	  [Status] BIGINT ,
	  Parity BIGINT ,
	  CreateLSN NUMERIC(38)
	) ;"; 
  }
  $dbh->do("$sql") || &dbError("Create_4712");

  #---- 2012/02/08 BB - 2.25: Changed SYSNAME data type to lower case (sysname)
  $sql = "CREATE TABLE #dbamon_vlf_results
	(
	  Database_Name sysname ,
	  VLF_count int
	) ;"; 
  $dbh->do("$sql") || &dbError("Create_4718");
  #---- 2012/07/21 BB: Added master.. to the next line
  #---- 2012/07/27 BB 2.37: Choose this based on version number. :@( 
  
  my $foreach_cmd = ""; 
  if ($vershort < 90)  { $foreach_cmd = "master..sp_msforeachdb"; } 
  else                 { $foreach_cmd = "master.sys.sp_MSforeachdb"; } 

  ## $sql = "EXEC master..sp_msforeachdb N'Use [?];
  $sql = "EXEC $foreach_cmd N'Use [?];
		Insert Into #dbamon_vlf_stage
		Exec master..sp_executeSQL N''DBCC LogInfo([?]) with no_infomsgs'';
     
		Insert Into #dbamon_vlf_results
		Select DB_Name(), Count(*)
		From #dbamon_vlf_stage;
     
		Truncate Table #dbamon_vlf_stage;'"; 
  &msg("  VLFsql=$sql"); 
  $dbh->do("$sql") || &dbError("Msforeachdb_4728");

  $sql = "
    SELECT  database_name, vlf_count
    FROM    #dbamon_vlf_results
    ORDER BY VLF_count DESC ;"; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L4734");
  $sth->execute || &dbErrorOK("Select_4735");

  my $vlf_total = 0; 
  my $vlf_dbname = ""; 
  my $vlf_count = 0; 

  while (@Data = $sth->fetchrow_array)
  {
    $vlf_dbname = $Data[0]; 
    $vlf_count  = $Data[1]; 

    $vlf_total += $vlf_count; 
    $vlf_dbname =~ s/\s/[BLANK]/g;
    $vlf_dbname =~ s/\-/[HYPHEN]/g;

    &dataReturn("VLF_COUNT: $vlf_dbname $vlf_count"); 
  }

  $sql = " DROP TABLE #dbamon_vlf_stage ;";  
  $dbh->do("$sql") || &dbError("Drop_If_L1697");
  $sql = " DROP TABLE #dbamon_vlf_results ;"; 
  $dbh->do("$sql") || &dbError("Drop_If_L1697");

  &msg("checkVLF - Done - Found $vlf_total Total VLFs");
}

# ----------------------------------------------------------------------
sub checkJobs
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("checkJobs - Listing all MSDB jobs");

  $sth = $dbh->prepare("exec msdb..sp_help_job") || &dbError("Prepare_L3193");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

  $job_cnt = 0; 
  $job_cnt_disabled = 0; 
  $job_cnt_enabled = 0; 

  #while($href = $sth->fetchrow_hashref)
  #{
  #  $job_name     = $href->{name}; 
  #  $job_enabled  = $href->{enabled}; 
  #  $job_category = $href->{category}; 
  #  $job_created  = $href->{date_created}; 
  #  $job_modified = $href->{date_modified}; 
  #  $job_status   = $href->{current_execution_status}; 
  #  $job_lr_date    = $href->{last_run_date}; 
  #  $job_lr_time    = $href->{last_run_time}; 
  #  $job_lr_outcome = $href->{last_run_outcome}; 
  #  ##&msg("DEBUG - job_name=$job_name"); 
  #  msg "DDP:<|>$P<|>JOBS:<|>$job_name<|>$job_status<|>$job_enabled<|>$job_category<|>$job_created<|>$job_modified<|>$job_lr_date<|>$job_lr_time<|>$job_lr_outcome<|>\n";
  #  $job_cnt++; 
  #}

  while($href = $sth->fetchrow_hashref)
  {
    $job_cudata = ""; 
    foreach (sort keys %{$href} )
    {
      $job_colname = $_;   
      $job_value   = $href->{$job_colname};   
      $job_value   =~ s/\n/ /g;
      $job_cudata .= "$job_colname='$job_value'<|>"
    }
    print "DDP:<|>$P<|>JOBS:<|>$job_cudata\n";
    $job_cnt++; 

    #---- Count enabled / disabled jobs
    $job_enabled  = $href->{enabled}; 
    #&msg("DEBUG - job_enabled=$job_enabled"); 
    if ($job_enabled == 1) { $job_cnt_enabled++; } 
    else                   { $job_cnt_disabled++; } 
  }

  &dataReturn("SYSPERF: SQL_Jobs_Enabled $job_cnt_enabled"); 
  &dataReturn("SYSPERF: SQL_Jobs_Disabled $job_cnt_disabled"); 
  &dataReturn("SYSPERF: SQL_Jobs $job_cnt"); 

  &msg("checkJobs - Done - Found $job_cnt jobs");
}

# ----------------------------------------------------------------------
sub saveConfigSQL
# ----------------------------------------------------------------------
{
  $scs_db  = $_[0]; 
  $scs_sql = $_[1]; 
  $scs_width = $_[2]; 
  $scs_width = 28 if ! $scs_width;
  &msg("saveConfigSQL - Starting - $scs_db=$scs_db scs_sql=$scs_sql scs_width=$scs_width");

  $dbh->do("use \[$scs_db\]")           || &dbError("scs_Use_Master_1");
  $sth = $dbh->prepare("$scs_sql ") || &dbError("scs_Prepare");
  $sth->execute                     || &dbError("scs_Execute_Select");

  push @saveconfig_out, " ";
  push @saveconfig_out, "================================================================================ ";
  push @saveconfig_out, "Running: $scs_sql - Against DB: $scs_db";
  push @saveconfig_out, "================================================================================ ";
  push @saveconfig_out, " ";
  $scs_heading = 0; 

  do 
  {
    while($href = $sth->fetchrow_hashref)
    {
      if (! $scs_heading)
      {
	$scs_line = ""; 
	foreach (sort keys %{$href} )
	{
	  $scs_colname = sprintf("%-${scs_width}s",$_);   
	  $scs_line    .= uc "$scs_colname "; 
	}
	push @saveconfig_out, "$scs_line";
	$scs_heading = 1; 
      }

      $scs_line = ""; 
      foreach (sort keys %{$href} )
      {
	$scs_colname = $_;   
	$scs_value   = sprintf("%-${scs_width}s",$href->{$scs_colname});   
	$scs_line .= "$scs_value "; 
      }
      push @saveconfig_out, "$scs_line";
    }
  }
  while($sth->{odbc_more_results});
  
  &msg("saveConfigSQL - Done");
}

# ----------------------------------------------------------------------
sub saveConfigBkup
# ----------------------------------------------------------------------
{
  &msg("saveConfigBkup - Listing recent backup info");

  if ($vershort < 90)
  {
    &msg("This query will only work on SQL2005+"); 
    return; 
  }

  $sc_backup_days = 10; 
  $sc_backup_sql = "SELECT distinct
        ba.database_name as A1_Database_Name,
        ba.backup_start_date as A2_Backup_Start_Date,
        ba.backup_finish_date as A3_Backup_Finish_Date,
        ba.type as A4_Type,
        ba.is_snapshot as A5_Is_Snapshot,
	ba.is_copy_only as A6_Is_Copy_Only,
        ba.backup_size as A7_Backup_Size,
        ba.name as A8_Name,
        bm.physical_device_name AS A9_Backup_Device 
        --ba.USER_NAME as A9_User_Name,
FROM    [msdb].[dbo].[backupset] ba ,
        [msdb].[dbo].[backupmediafamily] bm
WHERE   ba.media_set_id = bm.media_set_id
        AND ba.backup_start_date > DATEADD(dd, -$sc_backup_days, GETDATE())
        AND ba.type != 'L'
ORDER BY 1, 2 DESC
  ";
  push @saveconfig_out, " ";
  push @saveconfig_out, "================================================================================ ";
  push @saveconfig_out, "Recent SQL Backups (Last $sc_backup_days Days):";
  push @saveconfig_out, "================================================================================ ";
  push @saveconfig_out, " ";
  &saveConfigSQL("master",$sc_backup_sql); 

  &msg("saveConfigBkup - Done");
}

# ----------------------------------------------------------------------
sub saveConfig
# ----------------------------------------------------------------------
{
  &msg("saveConfig - Listing instance and DB info");
  $sc_tsfile = "dbamon_mssql_saveconfig_$in_instance.txt";
  ##$sc_seconds_ago_t = 43200; 
  $sc_seconds_ago_t = 7200; 

  my $bookmark_from_file = 0; 

  if ($bookmark_from_file)
  {
    #---- (FILE Start) Read TS file
    open(TS, "$sc_tsfile") || print "$P | Can't open input $sc_tsfile - $!\n";;
    while (<TS>)
    {
      @words = split;
      $tsts   = $words[0];
      $tstime = $words[1];
    }
    close(TS);
    $tstime_seconds_ago = time - $tstime; 
    &msg("From $sc_tsfile - tstime=$tstime tstime_seconds_ago=$tstime_seconds_ago");
    if ($tstime > 0 && $tstime_seconds_ago < $sc_seconds_ago_t )
    {
      &msg("Since it has only been $tstime_seconds_ago seconds since this was last run, skipping (Threshold: $sc_seconds_ago_t seconds)"); 
      return;
    }
    #---- (FILE End) Read TS file
  }

  $tstime_seconds_ago = time - $dcf_data{'SaveConfigTS_Num'}; 
  &msg("DCF - dcf_data{'SaveConfigTS_Char'}=$dcf_data{'SaveConfigTS_Char'} - tstime_seconds_ago=$tstime_seconds_ago");
  &msg("saveConfing Was last run $tstime_seconds_ago seconds ago ($dcf_data{'SaveConfigTS_Char'})");
  if ($dcf_data{'SaveConfigTS_Num'} > 0 && $tstime_seconds_ago < $sc_seconds_ago_t )
  {
    &msg("Since it has only been $tstime_seconds_ago seconds since this was last run, skipping this execution (Threshold: $sc_seconds_ago_t seconds)"); 
    return;
  }

  #---- Steps to save configuration
  &connectDB if ! $connected_to_db; 
  undef @saveconfig_out;

  #---- Heading
  $date = &get_date("Y/M/D-H:M:S");
  push @saveconfig_out, " ";
  push @saveconfig_out, "================================================================================ ";
  push @saveconfig_out, "SaveConfig Report - Created on $host at $date ";
  push @saveconfig_out, "================================================================================ ";
  push @saveconfig_out, " ";

  #---- Get list of all DBs 
  $dbh->do("use master") || &dbError("Use_Master");
  undef @sc_dblist;
  $sql = "select name from sysdatabases order by 1; ";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute                || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
    $dbname = $Data[0];
    push(@sc_dblist,$dbname);
    ++$numdbs;
  }
  foreach $this_db (@sc_dblist)
  {
    &msg("SC db=$this_db"); 
    &msg("  dbattrs{$this_db}=$dbattrs{$this_db}"); 

    if ($dbattrs{$this_db} ne "" && $dbattrs{$this_db} =~ /restoring/i) 
    {

      &msg("DB [$this_db] is RESTORING - Skipping"); 
      next; 
    }

    if ($dbattrs{$this_db} ne "" && $dbattrs{$this_db} =~ /=offline/i) 
    {

      &msg("DB [$this_db] is OFFLINE - Skipping"); 
      next; 
    }

    #---- This was for blanks and hyphens in the DB name
    #if ($zthis_db =~ /\s/ || $zthis_db =~ /\-/)
    #{
    #  &msg("Not processing DB with funky name - $this_db"); 
    #}
    #else
    #{
    #  &saveConfigSQL($this_db,"sp_helpdb \@dbname='$this_db'"); 
    #  &saveConfigSQL($this_db,"sp_dboption '$this_db'"); 
    #}

    &saveConfigSQL($this_db,"sp_helpdb \@dbname='$this_db'"); 
    &saveConfigSQL($this_db,"sp_dboption '$this_db'") if $vershort < 110; 
  }

  &saveConfigSQL("master","sp_configure"); 
  &saveConfigSQL("master","sp_helpsort"); 
  &saveConfigSQL("master","sp_helpdevice"); 
  &saveConfigSQL("master","sp_helpdb"); 

  #---- Backup report
  &saveConfigBkup; 

  #---- Return all saveconfig data
  foreach (@saveconfig_out)
  {
    &dataReturn("Stack: SaveConfig: $_ "); 
  }

  #---- Save timestamp of this sample
  $date = &get_date("Y/M/D-H:M:S");
  $timestamp = time;

  if ($bookmark_from_file)
  {
    #---- Old - Save timestamp
    &msg("Saving timestamps: $save_rdate $save_rtime to $sc_tsfile");
    open(TS, "> $sc_tsfile")    || die "Error: Can't open output file: $sc_tsfile\n";
    print TS "$date $timestamp\n";
    close(TS);
    &msg("Contents of sc_tsfile=$sc_tsfile:");
    system("type $sc_tsfile"); 
  }

  #---- New - Save timestamp
  &msg("Saving timestamps: $save_rdate $save_rtime to DCF");
  $dcf_data{'SaveConfigTS_Char'} = "$date";
  $dcf_data{'SaveConfigTS_Num'} = "$timestamp";

  &msg("saveConfig - Done");
}

# ----------------------------------------------------------------------
sub readSPConfig
# ----------------------------------------------------------------------
{
  &msg("readSPConfig - Starting");

  my $sql = ""; 
  my $thisname = ""; 
 
  if ($vershort <= 80) 
  {
    $sql = "SELECT comment, value FROM master..sysconfigures (nolock) order by 1"; 
  }
  else
  {
    $sql = "SELECT name, value_in_use FROM master.sys.configurations (nolock) order by 1";
  }
  &msg("  Running sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5236");
  $sth->execute              || &dbError("scs_Execute_Select_5237");
 
  while (@Data = $sth->fetchrow_array)
  {
    my $name  = $Data[0];
    my $rval  = $Data[1];
    $spconfig_rvals{$name} = $rval;
  }
 
  foreach $thisname (sort keys %spconfig_rvals)
  {
    ## &msg("DEBUG - $thisname=$spconfig_rvals{$thisname}");
    if ($thisname =~ /memory/i)
    {
      my $thisname_out = $thisname;
      $thisname_out =~ s/\s/_/g;
      &dataReturn("SPConfig: $thisname_out $spconfig_rvals{$thisname}");
    }
  }
 
  &msg("readSPConfig - Done");
}

# ----------------------------------------------------------------------
sub checkPctGrowth
# ----------------------------------------------------------------------
{
  &msg("checkPctGrowth - Starting");

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  #---- Check for files with percent_growth
  $sql = "SELECT
    type_desc ,
    COUNT(*) AS cnt
  FROM sys.master_files with (NOLOCK)
  WHERE is_percent_growth = 1
  GROUP BY type_desc
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5236");
  $sth->execute              || &dbError("scs_Execute_Select_5237");
 
  while (@Data = $sth->fetchrow_array)
  {
    my $pct_type  = $Data[0];
    my $pct_cnt   = $Data[1];
    &dataReturn("FILE_PCT_GROWTH: $pct_type $pct_cnt"); 
  }

  &msg("checkPctGrowth - Done");
}

# ----------------------------------------------------------------------
sub checkAO
# ----------------------------------------------------------------------
{
  &msg("checkAO - Starting");

  if ($vershort < 110) 
  {
    &msg("This routine only works on SQL2012+"); 
    return;
  }

  #---- Check AO states
  $sql = "SELECT
            ag.name AS HADR_AG_Name ,
	    role_desc HADR_Role ,
	    operational_state_desc HADR_Oper_State ,
	    synchronization_health_desc HADR_Sync_Health ,
	    connected_state_desc HADR_Conn_State ,
	    automated_backup_preference_desc HADR_Backup_Pref ,
	    re.replica_server_name HADR_Replica_Server , 
            re.availability_mode_desc HADR_Availability_Mode,
            re.failover_mode_desc HADR_Failover_Mode
	    --, *
    FROM    sys.dm_hadr_availability_replica_states rs ,
	    sys.availability_groups ag ,
	    sys.availability_replicas re
    WHERE   rs.group_id = ag.group_id
	    AND rs.replica_id = re.replica_id
	    AND is_local = 1
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7256");
  $sth->execute              || &dbError("scs_Execute_Select_7256");

  $ao_rows = 0; 
 
  while($href = $sth->fetchrow_hashref)
  {
    $ao_rows++; 
    foreach (sort keys %{$href} )
    {
      $ao_colname = $_;   
      $ao_value   = $href->{$ao_colname};   
      &dataReturn("AO: $ao_colname $ao_value"); 
      #---- Save for later
      $ao_readings{$ao_colname} = $ao_value;
    }
  }

  #---- Check AO stats
  $sql = "SELECT
    sum(log_send_queue_size) as SUM_Log_Send_Queue_Size,
    sum(log_send_rate) as SUM_Log_Send_Rate,  
    sum(redo_queue_size) as SUM_Redo_Queue_Size,
    sum(redo_rate) as SUM_Redo_Rate,
    min(datediff(ss, last_redone_time, getdate()) ) as MIN_Last_Redone_Lag
  FROM sys.dm_hadr_database_replica_states
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7256");
  $sth->execute              || &dbError("scs_Execute_Select_7256");

  $ao_f1 = 0; 
  $ao_f2 = 0; 
  $ao_f3 = 0; 
  $ao_f4 = 0; 
  $ao_f5 = 0; 
 
  while (@Data = $sth->fetchrow_array)
  {
    &dataReturn("SYSPERF: SQL_AO_Tot_SendQueueSize_KB     $Data[0]"); 
    &dataReturn("SYSPERF: SQL_AO_Tot_SendQueueRate_KBSec  $Data[1]"); 
    &dataReturn("SYSPERF: SQL_AO_Tot_RedoQueueSize_KB     $Data[2]"); 
    &dataReturn("SYSPERF: SQL_AO_Tot_RedoQueueRate_KBSec  $Data[3]"); 
    &dataReturn("SYSPERF: SQL_AO_Min_LastRedoneLag_Sec    $Data[4]"); 
  }

  &msg("checkAO - Done - ao_rows=$ao_rows");
}

# ----------------------------------------------------------------------
sub checkBufferCache
# ----------------------------------------------------------------------
{
  &msg("checkBufferCache - Starting");

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  $sql = "SELECT
    COUNT(*) AS Pages ,
        COUNT(*) / 128 AS Space_MB ,
        SUM(ROW_COUNT) AS Rows ,
        SUM(CASE is_modified
          WHEN 1 THEN 1
        END) AS Mod_Pages
    FROM    sys.dm_os_buffer_descriptors WITH ( NOLOCK )
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7306");
  $sth->execute              || &dbError("scs_Execute_Select_7307");

  $bc_rows = 0; 
 
  while($href = $sth->fetchrow_hashref)
  {
    $bc_rows++; 
    foreach (sort keys %{$href} )
    {
      $bc_colname = $_;   
      $bc_value   = $href->{$bc_colname};   
      &dataReturn("SYSPERF: SQL_BufferCache_${bc_colname} $bc_value"); 
    }
  }

  &msg("checkBufferCache - Done - bc_rows=$bc_rows");
}

# ----------------------------------------------------------------------
sub checkPlanCache
# ----------------------------------------------------------------------
{
  &msg("checkPlanCache - Starting");

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  $pc_rows = 0; 

  #---- First query - total size, usecount
  &msg("First Q"); 
  $sql = "SELECT
    COUNT(*) ObjCnt_All,
    CONVERT(BIGINT, ( SUM(CAST (size_in_bytes AS BIGINT)) )) / ( 1024* 1024 ) AS TotSizeMB_All,
    SUM(CAST (usecounts AS BIGINT)) as TotUseCnt_All
  FROM sys.dm_exec_cached_plans
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7348");
  $sth->execute              || &dbError("scs_Execute_Select_7349");
 
  while($href = $sth->fetchrow_hashref)
  {
    $pc_rows++; 
    foreach (sort keys %{$href} )
    {
      $bc_colname = $_;   
      $bc_value   = $href->{$bc_colname};   
      &dataReturn("SYSPERF: SQL_PlanCache_${bc_colname} $bc_value"); 
    }
  }

  #---- First query - total size, usecount
  &msg("Second Q"); 
  $sql = "SELECT
  --    cacheobjtype ,
  objtype as AAA_ObjType,
	  COUNT(*) ObjCnt ,
	  CONVERT(BIGINT, ( SUM(CAST (size_in_bytes AS BIGINT)) )) / ( 1024* 1024 ) AS TotSizeMB,
		  SUM(CAST (usecounts AS BIGINT)) as TotUseCnt
  FROM    sys.dm_exec_cached_plans
  where cacheobjtype = 'Compiled Plan'
  GROUP BY cacheobjtype ,
	  objtype
  ORDER BY 1 ,
	  2
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7306");
  $sth->execute              || &dbError("scs_Execute_Select_7307");
 
  while($href = $sth->fetchrow_hashref)
  {
    $pc_rows++; 
    &msg("(New Row)"); 
    foreach (sort keys %{$href} )
    {
      $bc_colname = $_;   
      $bc_value   = $href->{$bc_colname};   

      if ($bc_colname eq "AAA_ObjType") 
      {
        $last_objtype = $bc_value; 
      }
      else
      {
        &dataReturn("SYSPERF: SQL_PlanCache_${bc_colname}_${last_objtype} $bc_value"); 
      }
    }
  }

  &msg("checkPlanCache - Done - pc_rows=$bc_rows");
}

# ----------------------------------------------------------------------
sub checkWorkerThreads
# ----------------------------------------------------------------------
{
  &msg("checkWorkerThreads (Worker Threads) - Starting");

  #---- A few vars
  $wt_cnt        = -1; 
  $wt_cfgmax     = -1; 
  $wt_pct        = -1; 
  $wt_sickcnt    = -1; 
  $wt_c_running  = -1; 
  $wt_c_susp     = -1; 
  $wt_c_runnable = -1; 
  $wt_c_init     = -1; 

  #---- First query - total size, usecount
  $sql = "select count(*) from sys.dm_os_workers;"; 
  &msg("Q1 = sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7348");
  $sth->execute              || &dbError("scs_Execute_Select_7349");
  while (@Data = $sth->fetchrow_array)
  {
    $wt_cnt = $Data[0]; 
  }

  #---- 2nd query - Config max
  $sql = "SELECT  max_workers_count FROM sys.dm_os_sys_info;"; 
  &msg("Q2 = sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7348");
  $sth->execute              || &dbError("scs_Execute_Select_7349");
  while (@Data = $sth->fetchrow_array)
  {
    $wt_cfgmax = $Data[0]; 
  }
  $wt_pct = sprintf("%.2f", ($wt_cnt / $wt_cfgmax) * 100) if $wt_cfgmax > 0; 

  #---- 3rd query - sick cnt
  $sql = "select count(*) from sys.DM_OS_WORKERS where is_sick = 1 or is_in_cc_exception = 1 or is_fatal_exception = 1;"; 
  &msg("Q3 = sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7348");
  $sth->execute              || &dbError("scs_Execute_Select_7349");
  while (@Data = $sth->fetchrow_array)
  {
    $wt_sickcnt = $Data[0]; 
  }

  #---- 4th query - workers running 
  $sql = "SELECT  COUNT(*)  FROM    sys.dm_os_workers WHERE   state = 'RUNNING';"; 
  &msg("Q4 = sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7348");
  $sth->execute              || &dbError("scs_Execute_Select_7349");
  while (@Data = $sth->fetchrow_array)
  {
    $wt_c_running = $Data[0]; 
  }

  #---- 5th query - workers susp 
  $sql = "SELECT  COUNT(*)  FROM    sys.dm_os_workers WHERE   state = 'SUSPENDED';"; 
  &msg("Q5 = sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7348");
  $sth->execute              || &dbError("scs_Execute_Select_7349");
  while (@Data = $sth->fetchrow_array)
  {
    $wt_c_susp = $Data[0]; 
  }

  #---- 6th query - workers runnable 
  $sql = "SELECT  COUNT(*)  FROM    sys.dm_os_workers WHERE   state = 'RUNNABLE';"; 
  &msg("Q6 = sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7348");
  $sth->execute              || &dbError("scs_Execute_Select_7349");
  while (@Data = $sth->fetchrow_array)
  {
    $wt_c_runnable = $Data[0]; 
  }

  #---- 7th query - workers init 
  $sql = "SELECT  COUNT(*)  FROM    sys.dm_os_workers WHERE   state = 'INIT';"; 
  &msg("Q7 = sql=$sql"); 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L7348");
  $sth->execute              || &dbError("scs_Execute_Select_7349");
  while (@Data = $sth->fetchrow_array)
  {
    $wt_c_init = $Data[0]; 
  }

  #---- Return perf metrics
  &dataReturn("SYSPERF: SQL_WorkerThreads_Total_Cnt     $wt_cnt"); 
  &dataReturn("SYSPERF: SQL_WorkerThreads_Config_Max    $wt_cfgmax"); 
  &dataReturn("SYSPERF: SQL_WorkerThreads_Total_Pct     $wt_pct"); 
  &dataReturn("SYSPERF: SQL_WorkerThreads_Sick_Cnt      $wt_sickcnt"); 
  &dataReturn("SYSPERF: SQL_WorkerThreads_Running_Cnt   $wt_c_running"); 
  &dataReturn("SYSPERF: SQL_WorkerThreads_Runnable_Cnt  $wt_c_runnable"); 
  &dataReturn("SYSPERF: SQL_WorkerThreads_Susp_Cnt      $wt_c_susp"); 
  &dataReturn("SYSPERF: SQL_WorkerThreads_Init_Cnt      $wt_c_init"); 

  &msg("checkWorkerThreads - Done");
}

# ----------------------------------------------------------------------
sub checkCFiles
# ----------------------------------------------------------------------
{
  &msg("checkCFiles - Starting");

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  #---- Check for files with percent_growth
  $sql = "SELECT  
    SUBSTRING(physical_name, 1, 1) AS drive ,
    COUNT(*) AS cnt
  FROM    sys.master_files with (NOLOCK)
  WHERE   UPPER(physical_name) LIKE 'C:%'
  GROUP BY SUBSTRING(physical_name, 1, 1)
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5236");
  $sth->execute              || &dbError("scs_Execute_Select_5237");
 
  while (@Data = $sth->fetchrow_array)
  {
    my $pct_type  = $Data[0];
    my $pct_cnt   = $Data[1];
    &dataReturn("FILES_ON_C: $pct_type $pct_cnt"); 
  }

  &msg("checkCFiles - Done");
}
 
# ----------------------------------------------------------------------
sub checkDBFilePerf
# ----------------------------------------------------------------------
{
  &msg("checkDBFilePerf - Starting");

  my $rcnt = 0; 

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  #---- Check for files with percent_growth
  $sql = "SELECT  
	    DB_NAME(fs.database_id) AS [Database Name] ,
	    mf.name ,
	    mf.physical_name ,
	    io_stall_read_ms ,
	    num_of_reads ,
	    CAST(io_stall_read_ms / ( 1.0 + num_of_reads ) AS NUMERIC(10, 1)) AS [avg_read_stall_ms] ,
	    io_stall_write_ms ,
	    num_of_writes ,
	    CAST(io_stall_write_ms / ( 1.0 + num_of_writes ) AS NUMERIC(10, 1)) AS [avg_write_stall_ms] ,
	    io_stall_read_ms + io_stall_write_ms AS [io_stalls] ,
	    num_of_reads + num_of_writes AS [total_io] ,
	    CAST(( io_stall_read_ms + io_stall_write_ms ) / ( 1.0 + num_of_reads
							      + num_of_writes ) AS NUMERIC(10,
								  1)) AS [avg_io_stall_ms]
    FROM    sys.dm_io_virtual_file_stats(NULL, NULL) AS fs
	    INNER JOIN sys.master_files AS mf WITH ( NOLOCK ) ON fs.database_id = mf.database_id
								 AND fs.[file_id] = mf.[file_id]
    ORDER BY total_io DESC
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5236");
  $sth->execute              || &dbError("scs_Execute_Select_5237");
 
  while (@Data = $sth->fetchrow_array)
  {
    $rcnt++;
    &dataReturn("DB_File_Perf: @Data"); 

    if ($rcnt == 1) 
    {
      &dataReturn("DB_File_Perf_Top_File: $Data[1]"); 
    }
  }

  #---- Check outstanding I/O requests
  $sql = "select count(*) from sys.dm_io_pending_io_requests"; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L6242");
  $sth->execute              || &dbError("Execute_Select_L6243");
  while (@Data = $sth->fetchrow_array)
  {
    &dataReturn("SYSPERF: SQL_Pending_IO_Requests $Data[0]"); 
  }

  &msg("checkDBFilePerf - Done");
}
 
# ----------------------------------------------------------------------
sub checkDBMailServer
# ----------------------------------------------------------------------
{
  return if $WWW; 

  &msg("checkDBMailServer - Starting");

  my $rcnt          = 0; 
  my $dbmail_server = "?"; 

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  $sql = "SELECT servername, port FROM msdb.dbo.sysmail_server"; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5236");
  $sth->execute              || &dbError("scs_Execute_Select_5237");
 
  while (@Data = $sth->fetchrow_array)
  {
    $rcnt++;
    $dbmail_server = $Data[0];
  }

  &dataReturn("DBMail_Server: $dbmail_server"); 

  &msg("checkDBMailServer - Done - rcnt=$rcnt");
}
 
# ----------------------------------------------------------------------
sub checkRemoteNTLMSessions
# ----------------------------------------------------------------------
# 2014/09/16 BB: Now counts all remote session auth schemes
# ----------------------------------------------------------------------
{
  &msg("checkRemoteNTLMSessions - Starting");

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  my $rcnt            = 0; 
  my $remote_sessions = 0; 
  undef %auth_types; 

  $sql = "select 
    dc.auth_scheme,
    count(*) Ses_Count
  from 
    master.sys.dm_exec_connections dc,
    master..sysprocesses sp
  where 
    dc.session_id = sp.spid
  --  and dc.auth_scheme = 'NTLM'
    and client_net_address != '<local machine>'
    and client_net_address != '127.0.0.1'
    and hostname != \@\@servername
  group by
    dc.auth_scheme
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5236");
  $sth->execute              || &dbError("scs_Execute_Select_5237");
 
  while (@Data = $sth->fetchrow_array)
  {
    $rcnt++;
    $remote_auth_scheme = $Data[0];
    $remote_sessions    = $Data[1];
    &dataReturn("SYSPERF: SQL_Sessions_${remote_auth_scheme}_Remote $remote_sessions"); 
    $auth_types{$remote_auth_scheme} = 1; 
  }

  #---- Create a 0 line for types that didn't return anything
  &dataReturn("SYSPERF: SQL_Sessions_NTLM_Remote      0") if $auth_types{'NTLM'}      != 1; 
  &dataReturn("SYSPERF: SQL_Sessions_SQL_Remote       0") if $auth_types{'SQL'}       != 1; 
  &dataReturn("SYSPERF: SQL_Sessions_KERBEROS_Remote  0") if $auth_types{'KERBEROS'}  != 1; 

  &msg("checkRemoteNTLMSessions - Done - rcnt=$rcnt");
}
 
# ----------------------------------------------------------------------
sub jobsLongRunning
# ----------------------------------------------------------------------
{
  &msg("jobsLongRunning - Starting");

  my $joblr_debug   = 1; 
  ##my $joblr_hours   = 12; 
  my $joblr_hours   = 12; 
  my $rcnt          = 0; 
  my @excl_strings = split(/\,/,$rq_mssql_job_lr_check_name_excl_string);

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  $sql = "SELECT  sj.name AS Running_Job_Name ,
        cat.NAME AS Job_Category ,
        DATEDIFF(MI, aj.start_execution_date, GETDATE()) / 60.0 AS Duration_Hrs,
        DATEDIFF(DD, aj.start_execution_date, GETDATE()) AS Duration_Days
FROM    msdb..sysjobactivity aj WITH ( NOLOCK )
        JOIN msdb..sysjobs sj WITH ( NOLOCK ) ON sj.job_id = aj.job_id
        JOIN msdb..syscategories cat WITH ( NOLOCK ) ON sj.category_id = cat.category_id
WHERE   aj.stop_execution_date IS NULL -- job hasn't stopped running
        AND aj.start_execution_date IS NOT NULL -- job is currently running
        AND cat.name NOT LIKE 'REPL%'
        AND DATEDIFF(HH, aj.start_execution_date, GETDATE()) >= $joblr_hours
        AND NOT EXISTS ( -- make sure this is the most recent run
        SELECT  1
        FROM    msdb..sysjobactivity new
        WHERE   new.job_id = aj.job_id
                AND new.start_execution_date > aj.start_execution_date )
ORDER BY 3
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5236");
  $sth->execute              || &dbError("scs_Execute_Select_5237");

  $nextflag = 0; 
 
  while (@Data = $sth->fetchrow_array)
  {
    &msg("  Found job name ($Data[0]) which has been running at least $joblr_hours hours"); 

    #---- See if THIS JOB was excluded by the DBC $rq_mssql_job_lr_check_name_excl_string parameter
    foreach $this_excl_string (@excl_strings) 
    {
      &msg("    DEBUG - Checking this job name ($Data[0]) against search string ($this_excl_string)") if $joblr_debug;
      if ( index(uc $Data[0], uc $this_excl_string) > -1) 
      {
        &msg("      NOTE: This job has been EXCLUDED from Long Running Jobs Check by DBC (MSSQL_Job_LR_Check_Name_Excl_String: $this_excl_string) parameter"); 
        $nextflag = 1; 
        next;
      }
    }
    if ($nextflag == 1) 
    {
      $nextflag = 0; 
      next; 
    }

    $rcnt++;
    &dataReturn("Jobs_Long_Running: $Data[2] $joblr_hours \{$Data[0]\}"); 
  }

  &msg("jobsLongRunning - Done - rcnt=$rcnt");
}
 
# ----------------------------------------------------------------------
sub transLongRunning
# ----------------------------------------------------------------------
{
  &msg("transLongRunning - Starting");

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  my $tranlr_debug   = 0; 
  ##my $tranlr_mins    = 10; 
  my $rcnt           = 0; 

  $sql = "SELECT
        st.session_id AS SPID ,
        DATEDIFF(mi, at.database_transaction_begin_time, GETDATE()) AS Trans_Run_Mins ,
        DATEDIFF(hh, at.database_transaction_begin_time, GETDATE()) AS Trans_Run_Hrs ,
        at.database_transaction_log_bytes_reserved / ( 1024 * 1024 ) AS TLog_MB_Rsvd ,
        at.database_transaction_log_bytes_used / ( 1024 * 1024 ) AS TLog_MB_Used ,
        sp.cmd AS Sysprocesses_Cmd ,
        st.transaction_id AS TransID ,
        DB_NAME(at.database_id) AS DBName ,
        at.database_transaction_begin_time DB_Trans_Begin_Time ,
        CASE at.database_transaction_type
          WHEN 1 THEN '1:Read/Write'
          WHEN 2 THEN '2:Read Only'
          WHEN 3 THEN '3:System'
        END AS TransType ,
        CASE at.database_transaction_state
          WHEN 1 THEN '1:Not Initialized'
          WHEN 3 THEN '3:Trans No Log'
          WHEN 4 THEN '4:Trans Run w/Log Data'
          WHEN 5 THEN '5:Trans Prepared'
          WHEN 10 THEN '6:Commited'
          WHEN 11 THEN '7:Rolled Back'
          WHEN 12 THEN '8:Commited/Log Gend'
        END AS TransState ,
        SUBSTRING(hostname, 1, 30) AS Hostname ,
        cpu ,
        physical_io ,
        waittime AS WtTim_MS ,
        sp.blocked,
        SUBSTRING(sp.program_name, 1, 24) AS Program_Name,
        sp.nt_username as sysprocesses_nt_username,
        sp.loginame as sysprocesses_loginame
  FROM  [sys].[dm_tran_session_transactions] st
        INNER JOIN sys.dm_tran_database_transactions at ON st.transaction_id = at.transaction_id
        INNER JOIN master..sysprocesses sp ON sp.spid = st.session_id
  WHERE at.database_transaction_log_bytes_reserved > 0
        AND at.database_transaction_begin_time IS NOT NULL
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5236");
  $sth->execute              || &dbError("scs_Execute_Select_5237");

  while($href = $sth->fetchrow_hashref)
  {
    $tran_cudata = ""; 
    foreach (sort keys %{$href} )
    {
      $tran_colname = $_;   
      $tran_value   = $href->{$tran_colname};   
      $tran_value   =~ s/\n/ /g;
      $tran_value   =~ s/\s+$//;    #---- Strip trailing spaces
      &msg("DEBUG - tran_colname=($tran_colname) tran_value=($tran_value)") if $tranlr_debug; 

      $tran_colname = lc $tran_colname;
      $tran_cudata .= "tr_$tran_colname='$tran_value'<|>";
      $tran_values{"tr_$tran_colname"} = $tran_value; 
    }
    print "DDP:<|>$P<|>TRANS_ACTIVE:<|>$tran_cudata\n";
    $rcnt++;

    &msg("Found trans - tr_spid=$tran_values{'tr_spid'} tr_trans_run_mins=$tran_values{'tr_trans_run_mins'} tr_tlog_mb_rsvd=$tran_values{'tr_tlog_mb_rsvd'} tr_transstate=$tran_values{'tr_transstate'}"); 
  }

  &msg("transLongRunning - Done - rcnt=$rcnt");
}

# ----------------------------------------------------------------------
sub snapSessionsActive 
# ----------------------------------------------------------------------
{
  &msg("snapSessionsActive - Starting");

  if ($vershort < 90) 
  {
    &msg("This routine only works on SQL2005+"); 
    return;
  }

  my $snap_debug   = 0; 
  my $rcnt         = 0; 

  $sql = "select 
    datediff( mi, login_time, getdate()) as logged_in_mins,
    cpu, 
    spid,
    cmd,
    status,
    hostname, 
    nt_username,
    loginame,
    open_tran,
    blocked,
    waittime,
    waitresource,
    lastwaittype,
    db_name(dbid) as dbname,
    program_name, 
    physical_io,
    memusage
    from master..sysprocesses
  where 
    spid > 50 
    and spid != \@\@SPID
    and 
    (
      status != 'sleeping' or  
      spid in (select blocked from master..sysprocesses where blocked > 0)
    )
    --and cmd not in ('awaiting command')
  order by 
    spid
  "; 
 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L5236");
  $sth->execute              || &dbError("scs_Execute_Select_5237");

  while($href = $sth->fetchrow_hashref)
  {
    $snap_cudata = ""; 
    foreach (sort keys %{$href} )
    {
      $snap_colname = $_;   
      $snap_value   = $href->{$snap_colname};   
      $snap_value   =~ s/\n/ /g;
      $snap_value   =~ s/\s+$//;    #---- Strip trailing spaces
      &msg("DEBUG - snap_colname=($snap_colname) snap_value=($snap_value)") if $snap_debug; 

      $snap_colname = lc $snap_colname;
      $snap_cudata .= "sn_$snap_colname='$snap_value'<|>";
      $snap_values{"sn_$snap_colname"} = $snap_value; 
    }
    print "DDP:<|>$P<|>SNAP_SES_ACTIVE:<|>$snap_cudata\n";
    $rcnt++;

    &msg("Found ses - sn_spid=$snap_values{'sn_spid'} tr_trans_run_mins=$tran_values{'tr_trans_run_mins'} tr_tlog_mb_rsvd=$tran_values{'tr_tlog_mb_rsvd'} tr_transstate=$tran_values{'tr_transstate'}"); 
    ##&msg("Found ses - sn_spid=$snap_values{'sn_spid'} tr_trans_run_mins=$tran_values{'tr_trans_run_mins'} tr_tlog_mb_rsvd=$tran_values{'tr_tlog_mb_rsvd'} tr_transstate=$tran_values{'tr_transstate'}"); 
  }

  &msg("snapSessionsActive - Done - rcnt=$rcnt");
}


# ----------------------------------------------------------------------
sub setlocale_C
# ----------------------------------------------------------------------
{
  &msg("setlocale_C - Starting - Resetting LC_NUMERIC to C (just in case it changed)");
  use POSIX;
  setlocale(LC_NUMERIC, "C");
  &msg("setlocale_C - Done");
}

# ----------------------------------------------------------------------
sub checkST
# ----------------------------------------------------------------------
{
  &msg("checkST - Starting - Checking for Synthetic Trans results file(s)");

  #---- Sample line: DBAmon_Synthetic_Trans1_MS: 60 [SQLSTATE 01000]

  my $debug_st     = 0; 
  my $st_value     = -1; 
  my $this_st_file = ""; 
  my @st_filelist  = (
    "C:\\temp\\DBAmon_User_Metric1.txt", 
    "C:\\temp\\DBAmon_User_Metric2.txt", 
    "C:\\temp\\DBAmon_User_Metric3.txt", 
    "C:\\temp\\DBAmon_User_Metric4.txt", 
    "C:\\temp\\DBAmon_Synthetic_Trans1.txt", 
    "C:\\temp\\DBAmon_Synthetic_Trans2.txt",
    "C:\\temp\\DBAmon_Synthetic_Trans3.txt",
    "C:\\temp\\DBAmon_Synthetic_Trans4.txt"
  );

  foreach $this_st_file (@st_filelist)
  {
    &msg("  Looking for this_st_file=($this_st_file)") if $debug_st; 

    if (-e "$this_st_file") 
    {
      &msg("    File $this_st_file DOES exist - Reading") if $debug_st; 
      #---- Read file and extract value
      open(STF, "$this_st_file") || &error("Cannot open input STF $this_st_file - $!"); 
      while(<STF>) 
      {
        $_ =~ tr/\x80-\xFF//d;
        $_ =~ tr/\x00//d;
        $_ =~ tr/\x0d//d;
        $_ =~ tr/\n//d;
        
        my @zwords = split; 

        ##&msg("DEBUG - line=($_)"); 
        ##&msg("DEBUG - zwords[0]=$zwords[0] zwords[1]=$zwords[1]"); 

        if ($zwords[0] eq "DBAmon_Synthetic_Trans_MS:" ) { &dataReturn("SYSPERF: SQL_Synthetic_Trans1_RT_MS $zwords[1]"); }
        if ($zwords[0] eq "DBAmon_Synthetic_Trans1_MS:") { &dataReturn("SYSPERF: SQL_Synthetic_Trans1_RT_MS $zwords[1]"); }
        if ($zwords[0] eq "DBAmon_Synthetic_Trans2_MS:") { &dataReturn("SYSPERF: SQL_Synthetic_Trans2_RT_MS $zwords[1]"); }
        if ($zwords[0] eq "DBAmon_Synthetic_Trans3_MS:") { &dataReturn("SYSPERF: SQL_Synthetic_Trans3_RT_MS $zwords[1]"); }
        if ($zwords[0] eq "DBAmon_Synthetic_Trans4_MS:") { &dataReturn("SYSPERF: SQL_Synthetic_Trans4_RT_MS $zwords[1]"); }

        if ($zwords[0] eq "DBAmon_User_Metric1:") { &dataReturn("SYSPERF: SQL_User_Metric1 $zwords[1]"); }
        if ($zwords[0] eq "DBAmon_User_Metric2:") { &dataReturn("SYSPERF: SQL_User_Metric2 $zwords[1]"); }
        if ($zwords[0] eq "DBAmon_User_Metric3:") { &dataReturn("SYSPERF: SQL_User_Metric3 $zwords[1]"); }
        if ($zwords[0] eq "DBAmon_User_Metric4:") { &dataReturn("SYSPERF: SQL_User_Metric4 $zwords[1]"); }
      }
      close(STF); 

      #---- Delete file 
      &msg("    Deleting file this_st_file=$this_st_file"); 
      unlink "$this_st_file"; 
    }
    else
    {
      &msg("    File $this_st_file DOES NOT exist") if $debug_st; 
    }
  }

  &msg("checkST - Done");
}

# ----------------------------------------------------------------------
sub dataReturn
# ----------------------------------------------------------------------
{
  my $in_data = $_[0]; 
  return if $WWW; 
  print "$P ${in_data}\n"; 
  return; 
}

# ----------------------------------------------------------------------
sub checkSQLPort
# ----------------------------------------------------------------------
{
  &msg("checkSQLPort - Query SQL TCP Port");

  if ($vershort < 90) 
  {
    &msg("This only works for SQL 2005+ - Skipping"); 
    return;
  }

  $sql = "SELECT distinct local_tcp_port
    FROM    sys.dm_exec_connections
    WHERE   local_tcp_port IS NOT NULL order by 1
  "; 
  $sth = $dbh->prepare($sql) || &dbError("Prepare_L3546");
  $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

  $rowcnt = 0; 
  $sql_port = "?"; 

  while(@Data = $sth->fetchrow_array)
  {
    $rowcnt++;
    $sql_port      = shift(@Data); 
  }

  &dataReturn("SQLPort: $sql_port"); 

  &msg("checkSQLPort - Done - rowcnt=$rowcnt sql_port=$sql_port");
}

#--------------------------------------------------------------------------
#
# Main
#
#--------------------------------------------------------------------------

&msg("Starting - \$0=$0 usewin32registry=$usewin32registry");

#---- Initial housekeeping
&init;
&DCFRead unless $WWW;
&reqFileRead unless $WWW;

#---- Find SQL instance, version, system stuff 
if ($usewin32registry)    #---- NEW LOGIC
{
  &getRegInfo;   #---- This is the OLD WAY
}
else
{
  &connectDB;     #---- This calls connectVars which reads variable values from the engine
  &newVars;
  #---- Make sure that all required vars are populated
  &checkVars;
}

#---- Check to see if Oracle is up
if ($verb eq "up") 
{
  ##$subrc += &SQLPerf;           #---- OLD METHOD: Moved to within the "up" sub, since the DB may not be running
  ##$subrc += &checkDoubleTake(); #---- This doesn't work any more!!! - if $host eq "wcosdba2" || $host eq "wgttdrp";

  $subrc += &up();
  $subrc += &checkTLog() unless $WWW;
  $subrc += &checkCFiles unless $WWW;
  $subrc += &checkFilegroups();   #---- unless $WWW;
  $subrc += &checkJobs() unless $WWW;
  $subrc += &checkDBMail() unless $WWW;
  $subrc += &checkLRBackup unless $WWW; 
  $subrc += &checkSuspectPages unless $WWW; 
  $subrc += &checkSignalWait unless $WWW; 
  $subrc += &checkVLF unless $WWW; 
  $subrc += &saveConfig() unless $WWW;
  $subrc += &readSPConfig() unless $WWW;
  $subrc += &checkST() unless $WWW;         #---- Check for synthetic trans results
  $subrc += &checkReplication unless $WWW;
  $subrc += &checkPctGrowth unless $WWW;
  $subrc += &checkDBFilePerf unless $WWW;
  $subrc += &checkDBMailServer unless $WWW;
  $subrc += &jobsLongRunning unless $WWW;
  $subrc += &transLongRunning unless $WWW;
  $subrc += &snapSessionsActive unless $WWW;
  $subrc += &checkRemoteNTLMSessions unless $WWW;
  $subrc += &checkPrimeTimeLRC unless $WWW; 
  $subrc += &checkTempDBContention unless $WWW;   #---- Put back into prod - Before: Doesn't work on some servers - syntax error. 
  $subrc += &checkTempDBIOBalance unless $WWW;
  $subrc += &checkTLOGMultiFile unless $WWW;
  $subrc += &checkAO unless $WWW;
  $subrc += &checkSQLPort;
  $subrc += &checkBufferCache;
  $subrc += &checkPlanCache;
  $subrc += &checkWorkerThreads;
  $subrc += &checkSSRSLog;
  $subrc += &checkReorgAge;
  $subrc += &checkRJSF unless $WWW;
  $subrc += &checkCDNS unless $WWW;
  $subrc += &checkCDSF unless $WWW;

  #---- Combined Probes 2013/06/27
  $subrc =  &bkup() unless $WWW;
  $subrc += &checkBackupDBFull unless $WWW;
  $subrc += &checkBackupAgeFull unless $WWW;

  #---- Combined Probes 2013/06/27
  $subrc =  &checklog() unless $WWW;
  $subrc += &checkAgentLog unless $sql_edition =~ /express/i; 
  $subrc =  &processDeadlocks() if $deadlock_flag;
  
  #---- Old/obsolete
  #$subrc += &oldPerl();       #---- This is now done in WMITopProcesses
}

#---- Check the event log
elsif ($verb eq "checklog") 
{
  $subrc =  &checklog();
  $subrc += &checkAgentLog unless $sql_edition =~ /express/i; 
    print "dlf=$deadlock_flag\n"; 
  $subrc =  &processDeadlocks() if $deadlock_flag;
}

#---- Check TLOGs
elsif ($verb eq "checktlog") 
{
  $subrc = &checkTLog();
}

#---- Backup age
elsif ($verb eq "bkup") 
{
  $subrc =  &bkup();
  $subrc += &checkBackupDBFull;
  $subrc += &checkBackupAgeFull;
  #---- Not used any more
  # $subrc = &backupJobs();
}

#---- Backup rerun
elsif ($verb eq "bkrun") 
{
  $subrc = &bkrun();
}

#---- Backup logs - run from menu
elsif ($verb eq "bkbl") 
{
  $subrc = &bkbl();
}

#---- Backup history
elsif ($verb eq "bkhi") 
{
  $subrc = &bkhi();
}

#---- Test - Backup history
elsif ($verb eq "test1") 
{
  &connectDB;
  ##$subrc += &getDBAttrs2000("msdb"); 
  $subrc += &checkSSRSLog;
}

#---- Test - Old Perl ProcessesBackup history
elsif ($verb eq "test2") 
{
  $subrc += &SysPerf; 
  $subrc += &SysPerfBulk; 
  $subrc += &SysPerfCompare; 
  $subrc += &SysPerfSpecial; 
}
else
{
  &error("Unknown verb=$verb passed"); 
}

#---- Terminate
$etime = time;
$elapsed = $etime - $stime;

&msg("Done - elapsed: $elapsed - subrc: $subrc");
&msg("END_OF_PROBE");

#---- Cleanup
close(PLOG); 
&DCFWrite unless $WWW;

#---- Terminate
exit 0;
